(* ::Package:: *)

(* ::Title:: *)
(*GraphicsUtilities*)


(* ::Section:: *)
(*Reference*)


(* ::Subsection:: *)
(*Title*)


(* ::Text:: *)
(*GraphicsUtilities.m*)


(* ::Subsection:: *)
(*Author*)


(* ::Text:: *)
(*Simon Rochester (simonkeys@yahoo.com)*)


(* ::Subsection:: *)
(*Summary*)


(* ::Text:: *)
(*Various graphics utilities.*)


(* ::Subsection:: *)
(*Copyright*)


(* ::Text:: *)
(*\[Copyright] Copyright 2008, Simon Rochester*)


(* ::Subsection:: *)
(*Notebook Version*)


(* ::Text:: *)
(*1.0*)


(* ::Subsection:: *)
(*Mathematica version*)


(* ::Text:: *)
(*6.0+*)


(* ::Subsection:: *)
(*History*)


(* ::Subsection:: *)
(*Keywords*)


(* ::Section:: *)
(*Interface*)


(* ::Text:: *)
(*This part declares publicly visible symbols.*)


(* ::Subsection:: *)
(*Begin package context*)


BeginPackage["Graphics`GraphicsUtilities`"]


(* ::Subsection:: *)
(*Usage messages*)


GetLine::usage=""


TranslateX::usage=""


TranslateY::usage=""


TranslateZ::usage=""


RotateX::usage=""


RotateY::usage=""


RotateZ::usage=""


Crop::usage=""


(* ::Subsection:: *)
(*Error messages*)


(* ::Section:: *)
(*Implementation*)


(* ::Subsection:: *)
(*Begin private context*)


Begin["`Private`"]


(* ::Subsection:: *)
(*GetLine*)


GetLine[g_]:=Cases[Flatten[g[[1]]],Line[_]]


GetLine[g_,spec_]:=Cases[Flatten[g[[1]]],Line[_],spec]


(* ::Subsection:: *)
(*Translate*)


TranslateX[x_][g_]:=Translate[g,{x,0,0}]


TranslateY[x_][g_]:=Translate[g,{0,x,0}]


TranslateZ[x_][g_]:=Translate[g,{0,0,x}]


(* ::Subsection:: *)
(*Rotate*)


RotateX[theta_][g_]:=Rotate[g,theta,{1,0,0}]


RotateY[theta_][g_]:=Rotate[g,theta,{0,1,0}]


RotateZ[theta_][g_]:=Rotate[g,theta,{0,0,1}]


(* ::Subsection:: *)
(*Crop*)


Crop[{{xmin_,xmax_},{ymin_,ymax_}}]:={{0,1}+{-xmin,1-xmax}/(xmax-xmin),{0,1}+{-ymin,1-ymax}/(ymax-ymin)}


(* ::Subsection:: *)
(*End the private context*)


End[]


(* ::Section:: *)
(*Epilog*)


(* ::Text:: *)
(*This section protects exported symbols and ends the package.*)


(* ::Subsection:: *)
(*Protect exported symbols*)


(*Protect[Evaluate[$Context<>"*"]]*)


(* ::Subsection:: *)
(*End the package context*)


EndPackage[]
