(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     59252,       1619]
NotebookOptionsPosition[     52742,       1400]
NotebookOutlinePosition[     54456,       1448]
CellTagsIndexPosition[     54370,       1443]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMICDENSITYMATRIX PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Displaying the Density Matrix", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Displaying the Density Matrix\"\>"}, 
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "DensityMatrix", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Ket", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Ket", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"DensityMatrix\"\>", 2->"\<\"Ket\"\>"}, 
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"See Also \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/ref/DMVariables", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/ref/DMVariables", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/ref/DMVariables.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/ref/DMVariables", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/ref/DMVariables\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["DMVariables", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["DMVariables",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/DMVariables"], "[", 
       StyleBox["sys", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the list of variables representing the \
density-matrix elements for an atomic system (list of ",
     Cell[BoxData[
      ButtonBox["AtomicState",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"]], 
      "InlineFormula"],
     " objects) ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "NotesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       Cell[
        BoxData[
         ButtonBox[
          FrameBox[
           StyleBox[
            RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"], 
           StripOnInput -> False], BaseStyle -> None, ButtonFrame -> "None", 
          ButtonFunction :> (FrontEndExecute[{
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], All, ButtonCell], 
             FrontEndToken["OpenCloseGroup"], 
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
          Evaluator -> None, Method -> "Preemptive"]]]], "NotesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Details and Options"}], "NotesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, ButtonFrame -> 
       "None", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), Evaluator -> 
       None, Method -> "Preemptive"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415988855],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["DMVariables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DMVariables"]], 
  "InlineFormula"],
 " takes the same options as ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 ", with the default value for each being ",
 Cell[BoxData[
  ButtonBox["Automatic",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Automatic"]], "InlineFormula"],
 ", indicating that the corresponding default value for ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 " is used."
}], "Notes",
 CellID->1067943069],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]],

Cell[CellGroupData[{

Cell["", "PrimaryExamplesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "EXAMPLES", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "PrimaryExamplesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Examples", 
          "\[NonBreakingSpace]\[NonBreakingSpace]", 
          Cell["(9)", "ExampleCount"]}], "PrimaryExamplesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellTags->"PrimaryExamplesSection",
 CellID->71160402],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->324120342],

Cell["\<\
Density-matrix variables for a system with no angular momentum:\
\>", "ExampleText",
 CellID->135693201],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->40423541],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", "1", "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->90393259],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", "1", "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{226, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->559774093]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->71264253],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "2"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}], "}"}]], "Output",
 ImageSize->{226, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->7077349]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->719744508],

Cell["Density-matrix variables for a system with Zeeman structure:", \
"ExampleText",
 CellID->453682541],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->389492628],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<a\>\"", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"\"\<b\>\"", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1002736892],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{398, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->233021057]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->115787309],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{407, 71},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->6768336]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->422283026],

Cell["\<\
Density-matrix variables for a system with hyperfine structure:\
\>", "ExampleText",
 CellID->27102674],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->287776136],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->53916052],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{367, 120},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->100365622]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->89018852],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{487, 71},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->93782655]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(3)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->253621532],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "ComplexExpandVariables",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->124303609],

Cell["Write density matrix in terms of real and imaginary parts:", \
"ExampleText",
 CellID->131826769],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->23655700],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", " ", 
     RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->141331294],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{398, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->152457763]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->675428486],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{392, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->381644329]
}, Open  ]],

Cell["Indicate real and imaginary parts using labels:", "ExampleText",
 CellID->276259480],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "Subscript"}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->395829546],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzlW8uO1DgUdVeqKummaITEZmZDS+xRSzNsCta8JJgHS5pF0SIDi9GMAAk+
I1+Tn6mPCbGv7dhVN4nTfsQJLUh3uex7fY+Prx3n5NXu68cP/+6+frreXTz7
vPv/46frLxdP//tcFyUnhCweEkIeXBD6d1X/yS9V/Q8ul/RCyAX7lZB9sSVk
W5B9/ekOL6uqPYHiPTlF6t1D6m0d23vi2N5jw3qm9r4DjL/yr4ptTkoAmFWk
17KA5vTTGqmXqmaLkn1aWNjbIPZ+i7x/jyLv3++O7bnu3zegoYBiX5sQ1Zfs
ek6qfVHPzuYnL/jnmt2UzWS7ZZ/zEtqVOWM4NF9pvRKmFszQ8rAJBJcde+TV
eMdlvNBKwWCQt9TM21KCAZO3bkuKfXUqivcNGrVj0beKOslLjWcquIlwXpUk
545ZLMwcHTNW3tL1G2Crgsa9STJhBAsD7soLuOGZGye69tTNYqCuYbSTSAu8
mPbvnZ56q7KgBpTsnWnZm24oaB9YGTWTlws5OozFrCq2GCz4TFHNCZN6u+M6
LL4cbA3zd9bpD8oUpqzkoNH/oqk2iXg3ErWMT6xNazcE6Gx4ULSXIpHUDIA+
0G5BfUGm5aDQ7/aHDiPIv8tlXyKEe+kYbi/knhXiNgTPEMTdE9xb6BMbgQRp
e0WUvL5mg1OUzVKprQjHs4D2sKj3JUXJ6JoqeIgVSDjF7mXUMhmYHPbmvqDP
3sbQHrbJEUuj3AwRZeVvYbDYS9QTVF2AEeBg/MochjSRPaHekoOypjf9Ea/E
VYlOtAmBJEY5J0iGouDYAHqgYjYOFU0jjgxBrOytmgxTDu7BorxVU79CR3UD
zu/U6jAzxAt2KiLIj25oi/LU0Mym2wy2OUqUaUeDg+rAnnqYsOVMv38ETzC6
dzsxU0ev6aFCVN4uNYx2JQiPzGH34K18gxeUcGGx80i8dATi9UQbF2i9iQ47
9FlrW3IFt3NO1aMzinoBEnGshV+9HEvYmYG5W+bmsG2JdprBb6nWCCbtB9hp
A4ZGJLgn2RgjkmnDVuZb/bZOEMcZGu0EskHDATVCA2FDi9seaTEghIgmylKt
xzMsTyhiC1rmBxmNbUnloiW2oM1iIzqfQm5XdqzHuT7VyiRr4GycnBrY2RjY
sZk8t6V9DAbI1gIDcXg9FAM4OyBKe/cYtG95TDHwToUQMNhQQSZFD1Qw6XsM
GHTsQDLRSMmgyprw2pqAUzN93m36bz/DIB4EydkE981/IN7UW3HxgxF40Rrc
XNzcwd28ceymY9iuLNiwG6ltbtG24wD7SmJl8oTzvcfa/wyqrYVO4MEtf9bK
YmaXS48F93kHbiI9w+rZSOOwejbSOKweJo0bK15MagdSRfIL/yoGqRhmLyap
HWYvJqkdZs9GavezjS92FgFpi4jzMFiDm3MELgGCtTOg+iesKNDQ20xEgWGx
1c+aSatIzg+4c5ezmqKbWKMbhSjQNFxHistw6P6EiSGYWBiQ6BQe+dVNhdZg
2vvDjrXjEluGxtSN1HASqsppQmtD2TDyyTHUquNjO890EKXuGlvotA1RcE2b
a4Gqqb35CFRdIzhUr4lN/UkJVMcGcD4CVV9S3wgQncnkHlF13rv2hFUWOtIB
95iZmQ7YEWiGkth56YDDYjczHbBjEfX4IE549o6n3ocywpcSOO9jNzbYcuVW
UexMOjrAHBaVLBtdY+0YkV6lso1E0qvGOjQQ9npZn7RwojgPgMSEJkigFxFg
YDoeX/mVWdtqa03sxC41d4VBl1Z7AlLzEDDEKjV3Jbf3jcEUpoPvNy96M2ar
uvy5NfKtpl/EabpHbu8REJuXBDpGWByHHYjSMYw8SOxfTtNNi5I/EGiu30vA
2MGf0v1lQTqblw3GamvzogKHUVRXFaZ/yqlmou15F03tYS8ynAEADA12uflL
BuTkB4v7IsY=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{558, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->15037071]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "DMLabel",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->239804243],

Cell["Provide an additional label for the density-matrix elements:", \
"ExampleText",
 CellID->11034410],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->330352135],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"DMLabel", "\[Rule]", "\"\<lab\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->731005036],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztm81y0zAQx9V8OEmbwvBxgAv0wBVuzIAvcIJTYYbvmV4aOjUtDNNO6YP4
afwyeZhgWyt5la4duZLlOFGGpo4qrVb/ldaWfuRwdn12+nd2fX4yO3h/Nbs8
Oz/5d/Du4iot6u8wtnPBGHt5wLLrRXoJb4v03+Iye2PsWf6rz+ZxyFgYs3n6
6SGULRZzxovnbELUu0vUe2PZ3lsDe1S9p3zYT+BPcRixhAuSV8zek5g3zz4F
RL0pNhsn+aeegb0RYe/Vmvv3eo38o+zx+ErX56kJUX2Qv+/xmYJe2ewoykIW
ZpdRxKL0Vy8vG+bl8ZzbSSLehtsbKm4u5jELZbsBixKlDXdrLKuJl6gGI5EC
QE+FKLV66+n1NpDq8NUCY52IYtGaLy7h2yLrJEqUibLVamMzMFI5u/EM9XJb
kVuzt1uqDcWFEkUyTGIpVgBWcFJKA8U93suc4cUodviax4XXoXIenz27qvml
drwsyeIpwilEzX5EU2UiRrwLUabnxqjSjX5JHdxfH/sAi2Fa2p8IAp+a267+
vdVuZGrJoUVSJdznwEfg1hFozA3dZdEvbQuxCfJ4xUnuhbwFoax28xkLLdj8
tgXXMJUCJJBIq5StKVEmR5raFUro2htp2qu6u8q7MM/iA0LQojkolg55w5Qc
infUVrSh7FJz0St6G3uGc7NcXRB0BCIv3QBCnNr2l1KWKr7IxmFYPB3iRE8F
9qYSAX3Lj5OJpplRtRnqltVHUyoUI4HRpbGjcrj6cM57CjZLSL7Wx+RaR+aG
XlA7ZizNzJUrnTovCZTHsOwHnBRpDE+CCYTlxuYqTaNibHvCF7WcymJjDXOB
vjnqlqNsw+BhMSB0Kj9Q6oZAY2WiJFGoPrVXLdZNFqeGOZPZM8D1lPQEXu6m
IVla+vlDDM5Y+d+LMPHiTLtdMdBIPutAlIuEOcV1lJ0EHFak3k807Iw07JSn
q9VK7XdTDnnuJfaeyI7JyuqYHDp2TGZHxR1sLPNNpOyHIdV9Mg5CqenPzZn+
3oxW4kgSn+CmvVMDwRsO8eLHDn002Yt6uLc7dDdf3HTzw3I3FXoeG4QpMmj7
26BtxRnPsRyvzkH2r1q1/9SqvXxInm0w4JA8H8Wl+TUFpylIbAKnTexRcFrX
HgWnX/Bhm8Dp8s3CesBpF/6ZwGnb/lGP3895mNeU36lbelYKMHuonqfTXZFb
tzuvtx29m+XTSO4HalJxzufsoEkPo9dU6i0mz23I3TpmpiKgpJjWUF5dmOlx
c1uKeuzclLKO8DOlqJIE2od8mrjTY+iWBPU4uiFh3WBpStD7OANQmybrYFET
k+qb2iQkbV2cTcHRFoVxhKIf8ZXlCDvr8NEtws625eg4drYlR9PYWVkzpbD2
0FjwUtMfmjNtAsZBlxKcTDndAOf96KYb23ActDsykH9m0PbUPOxHIJTeefLP
WrWjWrUfc4dy7zwS9ki4Hf86goTFDo3nt+JRFRgav5e3is80cS3eN3o43BG1
1c0+2z427FZu12i46suPzqGaObr1qHgNZd5iTOxa6nVGxOX/oaY1FKeLdz0u
dq2kx8S2FW0fD5cngPZB3ArG61GxYyE9IrYsaOtoGJII37HkElA5u1Hs57/D
7FagzYLGXfsOM5z6l5t1hgurMN8WwmRbcmwITDaVwxFMLl9HHjDraCX2EB46
1+iG0hNOZL4ZhKllEC2qY6L1VU6SjsJptvMf52KPcA==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{367, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->378615288]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "TimeDependence",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->302951700],

Cell["Remove explicit time dependence:", "ExampleText",
 CellID->173529821],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->689187939],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DMVariables", "[", 
  RowBox[{
   RowBox[{"Sublevels", "@", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", " ", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], ",", 
   RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->173556418],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzlWlty0zAUVWIndtrQwgyU38ywC/9CC4VhEaGDST8YmNI9AB90vAFYhjbj
xRhbr0iJbMvRlaxApnFjPa7Oubq+lnX8fn2/+fh5fX97s169vlt/3dzefFtd
fbmri6IJQpNfCKEXK9T8ruqf7FDVf9VDc0DoMfkXobLIEMoKVNZn56ysqkpE
i0u0MGx3YWHvqabdc8N2pvig7en4mtrTtTtVpwUXtGlzNmdlRZYjzMoS2USB
ydlU0y6ysPdsJCxLjb0Li77QfgkJi+kcQWPR2TuhIcxhlrUJrJiYKWarskB1
8Ncwmk+MckzLcU6uCIEkR/RTXzzTDhasm8TC6XBV0zDHysQcF2OKOhXN+Ic3
Y0PG7ggbIohg+E6HjSbzTY+RbwAR7Zfw0IBmzZoRYzV1VbhARalmPxkIddkT
JSM2X3KTR1JZMwRzaVnkwiZBklN7U+HqbV9dFnYxJnVBRtqEz/2kf8wK12cs
PmYilpov76pcAQxGZO0OZ9CGeSjphBG1tOmLjPQYXRHKhRKIO5zBiDVlkZxN
58R5BSbWxY2obiYT4CmaE5DBzvixTvMcFe8j37t43RzMbqLUSU4i98nA6S01
ZTp720kFp2YKwZRS0mqve6bSMOkEEoDQtEzt8cyxn6wYs4Sx3UnZmZr/9rvr
vJxqvSzSfYEXsOYEOTpZpPs8XFZLNsPapUGBZ47Z9AxvyiLpNqObE8hIA2IR
SIQBsekx075w6thWPFXWXs137ymxTo98xDn3J3MCaZ9n6nqPE0ogTD0KDznd
Xo53y3X7AVDoBwyZGvv++Bl4ix5g9APM8dvFftoRSzGc76QDsoap+LKHJLVs
C0aXsukDDBJ7VlxNac4XQHbOwoG7lNsoz21bO+f2cE2GGeLdI4PrOBig4JrY
6bi1igeinacLlo1edldfW1W/6a6+bEe9YBlIzBHxT3mpL343qPitvviqHQ05
+SFnP3X3g9R/lzMholvRsVT/YP87JCHfVHiHfjHABt9GdeP/LLzbiN0hvQTg
wy+faNhErBPNG9u1HBPOaE+XMuV4oiiQRuiXr6ko+s8QHijBOlC9Pb/WYBHR
H+g13aW2mIk+cDrcmLrfMKHLN2cYgc9e+vXN27mgeLj0O8ZLAW5CX5cJlDRl
rbq0a1l+tTEgEQmazlBV1KGKCU2tXR/zomK60psPDcDeSw1GzujRhhxKTJCi
DBALQ4nJtewHxKZHYnIt+wFLsQdE2JpeQmxniW5ukPuYWN2ACFFjSDnt760H
wKBXyjkLE/0IYiC4CGuEnm3StD/ggyg7PqQSQCHKh1QCoOxAwfWkm0Grkl1w
N/1hfZiy86q7ukfZ+d0OK2ZHM+nmSl/cIt380QzLHu0IvJ+0nt8LlZ3apoxq
OIN1FzT5C2xNjVE=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{397, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->161483207]
}, Open  ]],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SeeAlsoSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "SEE ALSO", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "SeeAlsoSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "See Also"}], "SeeAlsoSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["DensityMatrix",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Ket",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Ket"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "TUTORIALS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "TutorialsSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Tutorials"}], "TutorialsSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Displaying the Density Matrix",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"]], \
"Tutorials",
 CellID->341631938],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "MoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "MORE ABOUT", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "MoreAboutSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "More About"}], "MoreAboutSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], "MoreAbout",
 CellID->727532681],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DMVariables - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 41, 56.3987049}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"ADM", "Atomic Density Matrix"}, 
    "index" -> True, "label" -> "AtomicDensityMatrix Paclet Symbol", 
    "language" -> "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None",
     "summary" -> 
    "DMVariables[sys] returns the list of variables representing the \
density-matrix elements for an atomic system (list of AtomicState objects) \
sys.", "synonyms" -> {}, "title" -> "DMVariables", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/DMVariables"}, "SearchTextTranslated" -> "", 
  "SearchText" -> ""},
CellContext->"Global`",
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[16908, 414, 2081, 51, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->71160402]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 54226, 1436}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 76, 1, 3, "SymbolColorBar"],
Cell[647, 24, 220, 5, 70, "LinkTrail"],
Cell[870, 31, 10499, 220, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[11394, 255, 54, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[11451, 258, 842, 25, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[12330, 288, 2153, 54, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->415988855],
Cell[14486, 344, 804, 18, 70, "SectionHeaderSpacer"],
Cell[15293, 364, 771, 25, 70, "Notes",
 CellID->1067943069],
Cell[16067, 391, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]],
Cell[CellGroupData[{
Cell[16908, 414, 2081, 51, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->71160402],
Cell[CellGroupData[{
Cell[19014, 469, 181, 6, 70, "ExampleSection",
 CellID->324120342],
Cell[19198, 477, 114, 3, 70, "ExampleText",
 CellID->135693201],
Cell[19315, 482, 127, 3, 70, "Input",
 CellID->40423541],
Cell[CellGroupData[{
Cell[19467, 489, 220, 7, 70, "Input",
 CellID->90393259],
Cell[19690, 498, 282, 9, 70, "Output",
 CellID->559774093]
}, Open  ]],
Cell[CellGroupData[{
Cell[20009, 512, 108, 3, 70, "Input",
 CellID->71264253],
Cell[20120, 517, 558, 19, 70, "Output",
 CellID->7077349]
}, Open  ]],
Cell[CellGroupData[{
Cell[20715, 541, 125, 3, 70, "ExampleDelimiter",
 CellID->719744508],
Cell[20843, 546, 105, 2, 70, "ExampleText",
 CellID->453682541],
Cell[20951, 550, 128, 3, 70, "Input",
 CellID->389492628],
Cell[CellGroupData[{
Cell[21104, 557, 400, 12, 70, "Input",
 CellID->1002736892],
Cell[21507, 571, 830, 24, 70, "Output",
 CellID->233021057]
}, Open  ]],
Cell[CellGroupData[{
Cell[22374, 600, 109, 3, 70, "Input",
 CellID->115787309],
Cell[22486, 605, 2381, 43, 70, "Output",
 Evaluatable->False,
 CellID->6768336]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24916, 654, 125, 3, 70, "ExampleDelimiter",
 CellID->422283026],
Cell[25044, 659, 113, 3, 70, "ExampleText",
 CellID->27102674],
Cell[25160, 664, 128, 3, 70, "Input",
 CellID->287776136],
Cell[CellGroupData[{
Cell[25313, 671, 361, 11, 70, "Input",
 CellID->53916052],
Cell[25677, 684, 1375, 40, 70, "Output",
 CellID->100365622]
}, Open  ]],
Cell[CellGroupData[{
Cell[27089, 729, 108, 3, 70, "Input",
 CellID->89018852],
Cell[27200, 734, 2407, 44, 70, "Output",
 Evaluatable->False,
 CellID->93782655]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29668, 785, 255, 8, 70, "ExampleSection",
 CellID->253621532],
Cell[CellGroupData[{
Cell[29948, 797, 276, 8, 70, "ExampleSubsection",
 CellID->124303609],
Cell[30227, 807, 103, 2, 70, "ExampleText",
 CellID->131826769],
Cell[30333, 811, 127, 3, 70, "Input",
 CellID->23655700],
Cell[CellGroupData[{
Cell[30485, 818, 226, 7, 70, "Input",
 CellID->141331294],
Cell[30714, 827, 650, 20, 70, "Output",
 CellID->152457763]
}, Open  ]],
Cell[CellGroupData[{
Cell[31401, 852, 186, 5, 70, "Input",
 CellID->675428486],
Cell[31590, 859, 2359, 43, 70, "Output",
 Evaluatable->False,
 CellID->381644329]
}, Open  ]],
Cell[33964, 905, 90, 1, 70, "ExampleText",
 CellID->276259480],
Cell[CellGroupData[{
Cell[34079, 910, 194, 6, 70, "Input",
 CellID->395829546],
Cell[34276, 918, 2175, 40, 70, "Output",
 Evaluatable->False,
 CellID->15037071]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[36500, 964, 261, 8, 70, "ExampleSubsection",
 CellID->239804243],
Cell[36764, 974, 104, 2, 70, "ExampleText",
 CellID->11034410],
Cell[36871, 978, 128, 3, 70, "Input",
 CellID->330352135],
Cell[CellGroupData[{
Cell[37024, 985, 312, 9, 70, "Input",
 CellID->731005036],
Cell[37339, 996, 1964, 36, 70, "Output",
 Evaluatable->False,
 CellID->378615288]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[39352, 1038, 268, 8, 70, "ExampleSubsection",
 CellID->302951700],
Cell[39623, 1048, 75, 1, 70, "ExampleText",
 CellID->173529821],
Cell[39701, 1051, 128, 3, 70, "Input",
 CellID->689187939],
Cell[CellGroupData[{
Cell[39854, 1058, 313, 9, 70, "Input",
 CellID->173556418],
Cell[40170, 1069, 1631, 31, 70, "Output",
 Evaluatable->False,
 CellID->161483207]
}, Open  ]],
Cell[41816, 1103, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42681, 1128, 1929, 48, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[44613, 1178, 530, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[45180, 1201, 1936, 48, 70, "TutorialsSection",
 CellID->250839057],
Cell[47119, 1251, 804, 18, 70, "SectionHeaderSpacer"],
Cell[47926, 1271, 195, 5, 70, "Tutorials",
 CellID->341631938],
Cell[48124, 1278, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48965, 1301, 1937, 48, 70, "MoreAboutSection",
 CellID->38303248],
Cell[50905, 1351, 804, 18, 70, "SectionHeaderSpacer"],
Cell[51712, 1371, 181, 4, 70, "MoreAbout",
 CellID->727532681],
Cell[51896, 1377, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[52715, 1398, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

