(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     50106,       1425]
NotebookOptionsPosition[     44847,       1257]
NotebookOutlinePosition[     46712,       1308]
CellTagsIndexPosition[     46626,       1303]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMICDENSITYMATRIX PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Specifying the Atomic System", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Constructing the Hamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Specifying the Atomic System\"\>", 
       2->"\<\"Constructing the Hamiltonian\"\>"}, 
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicState", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/AtomicState", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "HyperfineA", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/HyperfineA", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "HyperfineB", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/HyperfineB", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicState\"\>", 2->"\<\"HyperfineA\"\>", 
       3->"\<\"HyperfineB\"\>"}, 
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"See Also \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/ref/Energy", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/ref/Energy", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/ref/Energy.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/ref/Energy", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {1->"\<\"AtomicDensityMatrix/ref/Energy\"\>",
        2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Energy", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      ButtonBox["Energy",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], 
      "InlineFormula"],
     "\[LineSeparator]is a parameter specified in an ",
     Cell[BoxData[
      ButtonBox["AtomicState",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"]], 
      "InlineFormula"],
     " expression that specifies the (fine-structure) energy of the state in \
units of angular frequency."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["Energy",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
       StyleBox["state", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the value specified for ",
     Cell[BoxData[
      ButtonBox["Energy",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], 
      "InlineFormula"],
     " in ",
     Cell[BoxData[
      ButtonBox["AtomicState",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"]], 
      "InlineFormula"],
     " ",
     Cell[BoxData[
      StyleBox["state", "TI"]], "InlineFormula"],
     ", or ",
     Cell[BoxData[
      RowBox[{
       ButtonBox["Energy",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
       RowBox[{
        ButtonBox["StateLabel",
         BaseStyle->"Link",
         ButtonData->"paclet:AtomicDensityMatrix/ref/StateLabel"], "[", 
        StyleBox["state", "TI"], "]"}], "]"}]], "InlineFormula"],
     " if it is not specified."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "NotesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       Cell[
        BoxData[
         ButtonBox[
          FrameBox[
           StyleBox[
            RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"], 
           StripOnInput -> False], BaseStyle -> None, ButtonFrame -> "None", 
          ButtonFunction :> (FrontEndExecute[{
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], All, ButtonCell], 
             FrontEndToken["OpenCloseGroup"], 
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
          Evaluator -> None, Method -> "Preemptive"]]]], "NotesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Details"}], "NotesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, ButtonFrame -> 
       "None", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), Evaluator -> 
       None, Method -> "Preemptive"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->36502549],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Energy",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], "InlineFormula"],
 " is automatically threaded over a list of ",
 Cell[BoxData[
  ButtonBox["AtomicState",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"]], 
  "InlineFormula"],
 " objects appearing as its argument."
}], "Notes",
 CellID->1067943069],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]],

Cell[CellGroupData[{

Cell["", "PrimaryExamplesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "EXAMPLES", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "PrimaryExamplesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Examples", 
          "\[NonBreakingSpace]\[NonBreakingSpace]", 
          Cell["(3)", "ExampleCount"]}], "PrimaryExamplesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellTags->"PrimaryExamplesSection",
 CellID->18242343],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->67394676],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->172351502],

Cell[TextData[{
 "Specify an ",
 Cell[BoxData[
  ButtonBox["Energy",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], "InlineFormula"],
 " parameter in an atomic state:"
}], "ExampleText",
 CellID->153570923],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->50043046],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{302, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->357688947]
}, Open  ]],

Cell["\<\
Get the specified value for each state, or a placeholder variable if it is \
not specified:\
\>", "ExampleText",
 CellID->150151381],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Energy", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->26368808],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"Energy", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{100, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->307288597]
}, Open  ]],

Cell[TextData[{
 "The values for ",
 Cell[BoxData[
  ButtonBox["Energy",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], "InlineFormula"],
 " appear in the diagonal entries of the Hamiltonian:"
}], "ExampleText",
 CellID->106127667],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->181335948],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{102, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->23453645]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->1293636265],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->5107226],

Cell[TextData[{
 "In addition to the ",
 Cell[BoxData[
  ButtonBox["Energy",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], "InlineFormula"],
 " parameter, external fields can also affect the diagonal energies:"
}], "ExampleText",
 CellID->254723305],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
       RowBox[{"GFactor", "\[Rule]", "1"}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->176021316],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"GFactor", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{373, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->648711265]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Hamiltonian", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"MagneticField", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], "}"}]}]}], "]"}], 
  "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->416711007],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      RowBox[{"\[Omega]0", "+", "\[CapitalOmega]L"}], "0", "0"},
     {"0", "0", "\[Omega]0", "0"},
     {"0", "0", "0", 
      RowBox[{"\[Omega]0", "-", "\[CapitalOmega]L"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{151, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->440651168]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->95893693],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->19096790],

Cell[TextData[{
 "The value for ",
 Cell[BoxData[
  ButtonBox["Energy",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"]], "InlineFormula"],
 " does not include the hyperfine interaction for atoms with nuclear spin:"
}], "ExampleText",
 CellID->175609409],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}]}], "]"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->40642380],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{367, 240},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->571570854]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Hamiltonian", "[", "sys", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->161577106],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Energy", "[", "1", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "1", "]"}], "4"]}], ",", "0", ",", "0", ",",
      "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "1", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "1", "]"}], "4"]}], ",", "0", ",", "0", ",",
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "1", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "1", "]"}], "4"]}], ",", "0", ",", "0", ",",
      "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "1", "]"}], "-", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"HyperfineA", "[", "1", "]"}]}], "4"]}], ",", "0", ",", "0", 
     ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "2", "]"}], "4"]}], ",", "0", ",", "0", ",",
      "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "2", "]"}], "4"]}], ",", "0", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "+", 
      FractionBox[
       RowBox[{"HyperfineA", "[", "2", "]"}], "4"]}], ",", "0"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "-", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"HyperfineA", "[", "2", "]"}]}], "4"]}]}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{341, 240},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->7631333]
}, Open  ]],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SeeAlsoSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "SEE ALSO", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "SeeAlsoSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "See Also"}], "SeeAlsoSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["AtomicState",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/AtomicState"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["HyperfineA",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/HyperfineA"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["HyperfineB",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/HyperfineB"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "TUTORIALS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "TutorialsSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Tutorials"}], "TutorialsSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Specifying the Atomic System",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/SpecifyingTheAtomicSystem"]], \
"Tutorials",
 CellID->281460451],

Cell[TextData[ButtonBox["Constructing the Hamiltonian",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]], \
"Tutorials",
 CellID->341631938],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "MoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "MORE ABOUT", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "MoreAboutSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "More About"}], "MoreAboutSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], "MoreAbout",
 CellID->54393492],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Energy - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 41, 58.1818069}", "context" -> 
    "AtomicDensityMatrix`", 
    "keywords" -> {"Atomic Density Matrix", "ADM", "AtomicDensityMatrix"}, 
    "index" -> True, "label" -> "AtomicDensityMatrix Paclet Symbol", 
    "language" -> "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None",
     "summary" -> 
    "Energy is a parameter specified in an AtomicState expression that \
specifies the (fine-structure) energy of the state in units of angular \
frequency.Energy[state] returns the value specified for Energy in AtomicState \
state, or Energy[StateLabel[state]] if it is not specified.", 
    "synonyms" -> {}, "title" -> "Energy", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/Energy"}, "SearchTextTranslated" -> "", 
  "SearchText" -> ""},
CellContext->"Global`",
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[18416, 449, 2081, 51, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->18242343]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 46482, 1296}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 76, 1, 3, "SymbolColorBar"],
Cell[647, 24, 220, 5, 70, "LinkTrail"],
Cell[870, 31, 11356, 236, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[12251, 271, 49, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[12303, 274, 1864, 56, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[14204, 335, 2140, 54, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->36502549],
Cell[16347, 391, 804, 18, 70, "SectionHeaderSpacer"],
Cell[17154, 411, 418, 13, 70, "Notes",
 CellID->1067943069],
Cell[17575, 426, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]],
Cell[CellGroupData[{
Cell[18416, 449, 2081, 51, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->18242343],
Cell[CellGroupData[{
Cell[20522, 504, 180, 6, 70, "ExampleSection",
 CellID->67394676],
Cell[20705, 512, 128, 3, 70, "Input",
 CellID->172351502],
Cell[20836, 517, 239, 8, 70, "ExampleText",
 CellID->153570923],
Cell[CellGroupData[{
Cell[21100, 529, 284, 9, 70, "Input",
 CellID->50043046],
Cell[21387, 540, 344, 11, 70, "Output",
 CellID->357688947]
}, Open  ]],
Cell[21746, 554, 142, 4, 70, "ExampleText",
 CellID->150151381],
Cell[CellGroupData[{
Cell[21913, 562, 103, 3, 70, "Input",
 CellID->26368808],
Cell[22019, 567, 238, 8, 70, "Output",
 CellID->307288597]
}, Open  ]],
Cell[22272, 578, 264, 8, 70, "ExampleText",
 CellID->106127667],
Cell[CellGroupData[{
Cell[22561, 590, 142, 4, 70, "Input",
 CellID->181335948],
Cell[22706, 596, 764, 23, 70, "Output",
 CellID->23453645]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23519, 625, 254, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[23776, 635, 126, 3, 70, "Input",
 CellID->5107226],
Cell[23905, 640, 283, 8, 70, "ExampleText",
 CellID->254723305],
Cell[CellGroupData[{
Cell[24213, 652, 543, 16, 70, "Input",
 CellID->176021316],
Cell[24759, 670, 1154, 31, 70, "Output",
 CellID->648711265]
}, Open  ]],
Cell[CellGroupData[{
Cell[25950, 706, 329, 10, 70, "Input",
 CellID->416711007],
Cell[26282, 718, 910, 26, 70, "Output",
 CellID->440651168]
}, Open  ]],
Cell[CellGroupData[{
Cell[27229, 749, 124, 3, 70, "ExampleDelimiter",
 CellID->95893693],
Cell[27356, 754, 127, 3, 70, "Input",
 CellID->19096790],
Cell[27486, 759, 284, 8, 70, "ExampleText",
 CellID->175609409],
Cell[CellGroupData[{
Cell[27795, 771, 606, 18, 70, "Input",
 CellID->40642380],
Cell[28404, 791, 2565, 73, 70, "Output",
 CellID->571570854]
}, Open  ]],
Cell[CellGroupData[{
Cell[31006, 869, 109, 3, 70, "Input",
 CellID->161577106],
Cell[31118, 874, 2280, 66, 70, "Output",
 CellID->7631333]
}, Open  ]],
Cell[33413, 943, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34278, 968, 1929, 48, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[36210, 1018, 844, 28, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[37091, 1051, 1936, 48, 70, "TutorialsSection",
 CellID->250839057],
Cell[39030, 1101, 804, 18, 70, "SectionHeaderSpacer"],
Cell[39837, 1121, 193, 5, 70, "Tutorials",
 CellID->281460451],
Cell[40033, 1128, 194, 5, 70, "Tutorials",
 CellID->341631938],
Cell[40230, 1135, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41071, 1158, 1937, 48, 70, "MoreAboutSection",
 CellID->38303248],
Cell[43011, 1208, 804, 18, 70, "SectionHeaderSpacer"],
Cell[43818, 1228, 180, 4, 70, "MoreAbout",
 CellID->54393492],
Cell[44001, 1234, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[44820, 1255, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

