(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     63341,       1900]
NotebookOptionsPosition[     56130,       1666]
NotebookOutlinePosition[     58090,       1717]
CellTagsIndexPosition[     58004,       1712]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMICDENSITYMATRIX PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Constructing the Hamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Light Polarization Demonstration", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
LightPolarizationDemonstration", "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Constructing the Hamiltonian\"\>", 
       2->"\<\"Light Polarization Demonstration\"\>"}, 
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Observables", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/Observables", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ReparameterizeField", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ReparameterizeField", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Observables\"\>", 
       2->"\<\"ReparameterizeField\"\>"}, 
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"See Also \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/ref/OpticalField", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/ref/OpticalField", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/ref/OpticalField.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/ref/OpticalField", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/ref/OpticalField\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["OpticalField", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["OpticalField",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"], "[", 
       RowBox[{
        StyleBox["\[Omega]", "TR"], ",", " ", 
        StyleBox["a", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives a complex time-dependent electric field with \
angular frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula"],
     ", real amplitude ",
     Cell[BoxData[
      StyleBox["a", "TI"]], "InlineFormula"],
     ", and default polarization. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["OpticalField",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"], "[", 
       RowBox[{
        StyleBox["\[Omega]", "TR"], ",", 
        StyleBox["a", "TI"], ",", 
        StyleBox["pol", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives a field with polarization parameters ",
     Cell[BoxData[
      StyleBox["pol", "TI"]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          ButtonBox["OpticalField",
           BaseStyle->"Link",
           ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"], "[", 
          RowBox[{"{", 
           RowBox[{
            StyleBox["\[Omega]", "TR"], ",", 
            StyleBox["k", "TI"]}]}]}], ")"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["a", "TI"], ",", 
          StyleBox["\[CurlyPhi]", "TR"]}], "}"}], ",", 
        StyleBox["pol", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives a spatially dependent plane-wave field with \
angular wavenumber ",
     Cell[BoxData[
      StyleBox["k", "TI"]], "InlineFormula"],
     " and phase ",
     Cell[BoxData[
      StyleBox["\[CurlyPhi]", "TR"]], "InlineFormula"],
     ". "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "NotesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       Cell[
        BoxData[
         ButtonBox[
          FrameBox[
           StyleBox[
            RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"], 
           StripOnInput -> False], BaseStyle -> None, ButtonFrame -> "None", 
          ButtonFunction :> (FrontEndExecute[{
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], All, ButtonCell], 
             FrontEndToken["OpenCloseGroup"], 
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
          Evaluator -> None, Method -> "Preemptive"]]]], "NotesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Details and Options"}], "NotesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, ButtonFrame -> 
       "None", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), Evaluator -> 
       None, Method -> "Preemptive"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->244500273],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell["The following options can be given:", "Notes",
 CellID->1067943069],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PolarizationVector",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/PolarizationVector"], 
    RowBox[{"{", 
     RowBox[{"1", ",", " ", "0", ",", " ", "0"}], "}"}], Cell[
    "reference polarization vector", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PropagationVector",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/PropagationVector"], 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "1"}], "}"}], Cell[
    "unit wave vector", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Parameterization",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Parameterization"], 
    "\"\<AngleEllipticity\>\"", Cell[
    "parameterization scheme for polarization", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["CartesianCoordinates",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/CartesianCoordinates"], 
    RowBox[{"{", 
     RowBox[{"Xx", ",", " ", "Yy", ",", " ", "Zz"}], "}"}], Cell[
    "symbols used to represent Cartesian coordinates", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TimeVariable",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TimeVariable"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "symbol used to represent the time variable", "TableText"]], 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True, True}}}},
 CellID->183288137],

Cell[TextData[{
 "Possible values for the ",
 Cell[BoxData[
  ButtonBox["Parameterization",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Parameterization"]], 
  "InlineFormula"],
 " option are ",
 Cell[BoxData["\"\<AngleEllipticity\>\""], "InlineFormula"],
 ", ",
 Cell[BoxData["\"\<RatioPhase\>\""], "InlineFormula"],
 ", and ",
 Cell[BoxData["\"\<Stokes\>\""], "InlineFormula"],
 "."
}], "Notes",
 CellID->99659405],

Cell[TextData[{
 "The polarization of the field is specified in reference to the unit vectors \
",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula"],
 ", given by the value of the option ",
 Cell[BoxData[
  ButtonBox["PolarizationVector",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/PolarizationVector"]], 
  "InlineFormula"],
 ", and ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    OverscriptBox["e", "^"], 
    StyleBox["2", "TR"]], "=", 
   RowBox[{
    OverscriptBox[
     StyleBox["k", "TI"], "^"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["e", "^"], 
     StyleBox["1", "TR"]]}]}]], "InlineFormula"],
 ", where ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["k", "TI"], "^"]], "InlineFormula"],
 " is the unit vector specified by the option ",
 Cell[BoxData[
  ButtonBox["PropagationVector",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/PropagationVector"]], 
  "InlineFormula"],
 "."
}], "Notes",
 CellID->149466482],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<AngleEllipticity\>\""], "InlineFormula"],
 " parameterization, the polarization parameters ",
 Cell[BoxData[
  StyleBox["pol", "TI"]], "InlineFormula"],
 " are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    StyleBox["\[Alpha]", "TR"], ",", 
    StyleBox["\[Epsilon]", "TR"]}], "}"}]], "InlineFormula"],
 ", where ",
 Cell[BoxData[
  StyleBox["\[Alpha]", "TR"]], "InlineFormula"],
 " is the polarization angle (relative to ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula"],
 " with respect to rotation about ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["k", "TI"], "^"]], "InlineFormula"],
 ") and ",
 Cell[BoxData[
  StyleBox["\[Epsilon]", "TR"]], "InlineFormula"],
 " is the ellipticity, or as simply ",
 Cell[BoxData[
  StyleBox["\[Alpha]", "TR"]], "InlineFormula"],
 ", with ",
 Cell[BoxData[
  StyleBox["\[Epsilon]", "TR"]], "InlineFormula"],
 " assumed to be zero."
}], "Notes",
 CellID->67102925],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<RatioPhase\>\""], "InlineFormula"],
 " parameterization, the polarization parameters are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    StyleBox["\[Chi]", "TR"], ",", 
    StyleBox["\[Phi]", "TR"]}], "}"}]], "InlineFormula"],
 ", where ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"tan", "(", "\[Chi]", ")"}], "=", 
    RowBox[{
     SubscriptBox["a", "2"], "/", 
     SubscriptBox["a", "1"]}]}], TraditionalForm]], "InlineMath"],
 ", and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "1"], TraditionalForm]], "InlineMath"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "2"], TraditionalForm]], "InlineMath"],
 " are the field amplitudes of the components along ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], "2"]], "InlineFormula"],
 ", respectively, and \[Phi] is the relative phase angle between the \
components. The parameters can also be specified simply as ",
 Cell[BoxData[
  StyleBox["\[Chi]", "TR"]], "InlineFormula"],
 ", with ",
 Cell[BoxData[
  StyleBox["\[Phi]", "TR"]], "InlineFormula"],
 " assumed to be zero."
}], "Notes",
 CellID->169132515],

Cell[TextData[{
 "In the ",
 Cell[BoxData["\"\<Stokes\>\""], "InlineFormula"],
 " parameterization, the polarization parameters are specified as ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox[
     StyleBox["s", "TI"], "1"], ",", 
    SubscriptBox[
     StyleBox["s", "TI"], "2"], ",", 
    SubscriptBox[
     StyleBox["s", "TI"], "3"]}], "}"}]], "InlineFormula"],
 ", where ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], "1"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], 
   StyleBox["2", "TR"]]], "InlineFormula"],
 ", and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["s", "TI"], 
   StyleBox["3", "TR"]]], "InlineFormula"],
 " are the normalized Stokes parameters relative to the axes  ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], 
   StyleBox["1", "TR"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["e", "^"], "2"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->659303226],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]],

Cell[CellGroupData[{

Cell["", "PrimaryExamplesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "EXAMPLES", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "PrimaryExamplesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Examples", 
          "\[NonBreakingSpace]\[NonBreakingSpace]", 
          Cell["(11)", "ExampleCount"]}], "PrimaryExamplesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellTags->"PrimaryExamplesSection",
 CellID->129798937],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->57605816],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->869218289],

Cell["Default optical field:", "ExampleText",
 CellID->11738106],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->105189423],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
    "E0"}], ",", "0", ",", "0"}], "}"}]], "Output",
 ImageSize->{103, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->624585786]
}, Open  ]],

Cell["\<\
Explicitly specify all parameters in the angle-ellipticity parameterization:\
\>", "ExampleText",
 CellID->533248697],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"E0", ",", "\[CurlyPhi]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
   RowBox[{"PolarizationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->295891880],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "+", "\[CurlyPhi]", "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Yy"}], "+", "\[CurlyPhi]", "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 ImageSize->{336, 39},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->27785597]
}, Open  ]],

Cell["If the ellipticity is omitted, it is assumed to be zero:", "ExampleText",
 CellID->187199296],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"E0", ",", "\[CurlyPhi]"}], "}"}], ",", "\[Alpha]"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->101590317],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Zz"}], "+", "\[CurlyPhi]", "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"Cos", "[", "\[Alpha]", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "Zz"}], "+", "\[CurlyPhi]", "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0", " ", 
    RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], ",", "0"}], "}"}]], "Output",
 ImageSize->{309, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->102831471]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(5)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->102283500],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "CartesianCoordinates",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->155972239],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->737662693],

Cell["Specify variables denoting the Cartesian coordinates:", "ExampleText",
 CellID->137224686],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Omega]", ",", "k"}], "}"}], ",", "E0", ",", 
   RowBox[{"CartesianCoordinates", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ",", 
   RowBox[{"PropagationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{"PolarizationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->300804433],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["x", 
            SqrtBox["2"]], "+", 
           FractionBox["y", 
            SqrtBox["2"]]}], ")"}]}], "-", 
        RowBox[{"t", " ", "\[Omega]"}]}], ")"}]}]], " ", "E0"}]}], 
  "}"}]], "Output",
 ImageSize->{180, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->14963178]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Parameterization",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->14951964],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->218685727],

Cell["Specify polarization using the ratio-phase parameterization:", \
"ExampleText",
 CellID->5650014],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], ",", 
   RowBox[{"Parameterization", "\[Rule]", "\"\<RatioPhase\>\""}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->47645834],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"Cos", "[", "\[Chi]", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", "\[Phi]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]}]], " ", "E0", " ",
     
    RowBox[{"Sin", "[", "\[Chi]", "]"}]}], ",", "0"}], "}"}]], "Output",
 ImageSize->{249, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->154511953]
}, Open  ]],

Cell["Specify polarization using the Stokes parameterization:", "ExampleText",
 CellID->65390182],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", 
   RowBox[{"Parameterization", "\[Rule]", "\"\<Stokes\>\""}]}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->331923263],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
     "E0", " ", 
     SqrtBox[
      RowBox[{"1", "+", "S1"}]]}], 
    SqrtBox["2"]], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"ArcTan", "[", 
        RowBox[{"S2", ",", "S3"}], "]"}]}]}]], " ", "E0", " ", 
    SqrtBox[
     RowBox[{
      FractionBox["1", "2"], "-", 
      FractionBox["S1", "2"]}]]}], ",", "0"}], "}"}]], "Output",
 ImageSize->{343, 41},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->132741891]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "PolarizationVector",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->236129826],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->422061296],

Cell["Specify a reference polarization vector:", "ExampleText",
 CellID->197373087],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
   RowBox[{"PolarizationVector", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->602020787],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}], ",", "0"}], 
  "}"}]], "Output",
 ImageSize->{299, 39},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->185672639]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "PropagationVector",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->11358517],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->142123334],

Cell[TextData[{
 "Specify a unit propagation vector in the direction ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"\[Theta]", ",", "\[Phi]"}], ")"}], TraditionalForm]], 
  "InlineMath"],
 ". The propagation and polarization vectors should be orthogonal, so we find \
the polarization vector that is perpendicular to both the propagation vector \
and ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath"],
 ":"
}], "ExampleText",
 CellID->132425472],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kvec", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ",", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->413686104],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
   RowBox[{
    RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ",", 
   RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]], "Output",
 ImageSize->{257, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->150306818]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pvec", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"kvec", "\[Cross]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ")"}], "\[Cross]", 
     "kvec"}], "/", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "//", "Simplify"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->309916076],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], " ", 
    RowBox[{"Cos", "[", "\[Phi]", "]"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], " ", 
    RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ",", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}]], "Output",
 ImageSize->{272, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->95744290]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"OpticalField", "[", 
   RowBox[{"\[Omega]", ",", "E0", ",", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], ",", 
    RowBox[{"PropagationVector", "\[Rule]", "kvec"}], ",", 
    RowBox[{"PolarizationVector", "\[Rule]", "pvec"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->706255779],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
          RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}], "+", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
          RowBox[{"Cos", "[", "\[Phi]", "]"}]}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}], " ", 
    "E0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
          RowBox[{"Cos", "[", "\[Phi]", "]"}]}], "-", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", "E0",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "}"}]], "Output",
 ImageSize->{380, 90},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->107498942]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "TimeVariable",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->97344979],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->29595265],

Cell["Specify a different time variable:", "ExampleText",
 CellID->268475990],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OpticalField", "[", 
  RowBox[{"\[Omega]", ",", "E0", ",", 
   RowBox[{"TimeVariable", "\[Rule]", "\[Tau]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->194298250],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Tau]", " ", "\[Omega]"}]], " ", 
    "E0"}], ",", "0", ",", "0"}], "}"}]], "Output",
 ImageSize->{103, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->284622005]
}, Open  ]],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SeeAlsoSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "SEE ALSO", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "SeeAlsoSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "See Also"}], "SeeAlsoSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["Observables",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ReparameterizeField",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/ReparameterizeField"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "TUTORIALS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "TutorialsSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Tutorials"}], "TutorialsSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Constructing the Hamiltonian",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]], \
"Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["Light Polarization Demonstration",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/LightPolarizationDemonstration"]], \
"Tutorials",
 CellID->678857706],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "MoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "MORE ABOUT", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "MoreAboutSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "More About"}], "MoreAboutSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], "MoreAbout",
 CellID->244862756],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OpticalField - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 16.1728359}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"ADM", "Atomic Density Matrix"}, 
    "index" -> True, "label" -> "AtomicDensityMatrix Paclet Symbol", 
    "language" -> "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None",
     "summary" -> 
    "OpticalField[\\[Omega], a] gives a complex time-dependent electric field \
with angular frequency \\[Omega], real amplitude a, and default polarization. \
OpticalField[\\[Omega], a, pol] gives a field with polarization parameters \
pol. OpticalField[{\\[Omega], k), {a, \\[CurlyPhi]}, pol] gives a spatially \
dependent plane-wave field with angular wavenumber k and phase \\[CurlyPhi]. \
", "synonyms" -> {}, "title" -> "OpticalField", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/OpticalField"}, "SearchTextTranslated" -> "", 
  "SearchText" -> ""},
CellContext->"Global`",
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[24702, 664, 2083, 51, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->129798937]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 57859, 1705}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 76, 1, 3, "SymbolColorBar"],
Cell[647, 24, 220, 5, 70, "LinkTrail"],
Cell[870, 31, 11026, 230, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[11921, 265, 55, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[11979, 268, 2185, 66, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[14201, 339, 2153, 54, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->244500273],
Cell[16357, 395, 804, 18, 70, "SectionHeaderSpacer"],
Cell[17164, 415, 73, 1, 70, "Notes",
 CellID->1067943069],
Cell[17240, 418, 1836, 43, 70, "3ColumnTableMod",
 CellID->183288137],
Cell[19079, 463, 441, 15, 70, "Notes",
 CellID->99659405],
Cell[19523, 480, 1036, 37, 70, "Notes",
 CellID->149466482],
Cell[20562, 519, 1023, 35, 70, "Notes",
 CellID->67102925],
Cell[21588, 556, 1275, 43, 70, "Notes",
 CellID->169132515],
Cell[22866, 601, 992, 38, 70, "Notes",
 CellID->659303226],
Cell[23861, 641, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]],
Cell[CellGroupData[{
Cell[24702, 664, 2083, 51, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->129798937],
Cell[CellGroupData[{
Cell[26810, 719, 180, 6, 70, "ExampleSection",
 CellID->57605816],
Cell[26993, 727, 128, 3, 70, "Input",
 CellID->869218289],
Cell[27124, 732, 64, 1, 70, "ExampleText",
 CellID->11738106],
Cell[CellGroupData[{
Cell[27213, 737, 139, 4, 70, "Input",
 CellID->105189423],
Cell[27355, 743, 361, 12, 70, "Output",
 CellID->624585786]
}, Open  ]],
Cell[27731, 758, 127, 3, 70, "ExampleText",
 CellID->533248697],
Cell[CellGroupData[{
Cell[27883, 765, 557, 16, 70, "Input",
 CellID->295891880],
Cell[28443, 783, 1322, 38, 70, "Output",
 CellID->27785597]
}, Open  ]],
Cell[29780, 824, 99, 1, 70, "ExampleText",
 CellID->187199296],
Cell[CellGroupData[{
Cell[29904, 829, 267, 9, 70, "Input",
 CellID->101590317],
Cell[30174, 840, 800, 23, 70, "Output",
 CellID->102831471]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31023, 869, 255, 8, 70, "ExampleSection",
 CellID->102283500],
Cell[CellGroupData[{
Cell[31303, 881, 274, 8, 70, "ExampleSubsection",
 CellID->155972239],
Cell[31580, 891, 128, 3, 70, "Input",
 CellID->737662693],
Cell[31711, 896, 96, 1, 70, "ExampleText",
 CellID->137224686],
Cell[CellGroupData[{
Cell[31832, 901, 543, 15, 70, "Input",
 CellID->300804433],
Cell[32378, 918, 604, 21, 70, "Output",
 CellID->14963178]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[33031, 945, 269, 8, 70, "ExampleSubsection",
 CellID->14951964],
Cell[33303, 955, 128, 3, 70, "Input",
 CellID->218685727],
Cell[33434, 960, 103, 2, 70, "ExampleText",
 CellID->5650014],
Cell[CellGroupData[{
Cell[33562, 966, 282, 8, 70, "Input",
 CellID->47645834],
Cell[33847, 976, 651, 20, 70, "Output",
 CellID->154511953]
}, Open  ]],
Cell[34513, 999, 97, 1, 70, "ExampleText",
 CellID->65390182],
Cell[CellGroupData[{
Cell[34635, 1004, 282, 8, 70, "Input",
 CellID->331923263],
Cell[34920, 1014, 834, 28, 70, "Output",
 CellID->132741891]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[35803, 1048, 272, 8, 70, "ExampleSubsection",
 CellID->236129826],
Cell[36078, 1058, 128, 3, 70, "Input",
 CellID->422061296],
Cell[36209, 1063, 83, 1, 70, "ExampleText",
 CellID->197373087],
Cell[CellGroupData[{
Cell[36317, 1068, 332, 9, 70, "Input",
 CellID->602020787],
Cell[36652, 1079, 1153, 35, 70, "Output",
 CellID->185672639]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[37854, 1120, 270, 8, 70, "ExampleSubsection",
 CellID->11358517],
Cell[38127, 1130, 128, 3, 70, "Input",
 CellID->142123334],
Cell[38258, 1135, 473, 14, 70, "ExampleText",
 CellID->132425472],
Cell[CellGroupData[{
Cell[38756, 1153, 397, 12, 70, "Input",
 CellID->413686104],
Cell[39156, 1167, 452, 14, 70, "Output",
 CellID->150306818]
}, Open  ]],
Cell[CellGroupData[{
Cell[39645, 1186, 360, 12, 70, "Input",
 CellID->309916076],
Cell[40008, 1200, 493, 16, 70, "Output",
 CellID->95744290]
}, Open  ]],
Cell[CellGroupData[{
Cell[40538, 1221, 372, 10, 70, "Input",
 CellID->706255779],
Cell[40913, 1233, 2931, 81, 70, "Output",
 CellID->107498942]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[43893, 1320, 265, 8, 70, "ExampleSubsection",
 CellID->97344979],
Cell[44161, 1330, 127, 3, 70, "Input",
 CellID->29595265],
Cell[44291, 1335, 77, 1, 70, "ExampleText",
 CellID->268475990],
Cell[CellGroupData[{
Cell[44393, 1340, 195, 5, 70, "Input",
 CellID->194298250],
Cell[44591, 1347, 366, 12, 70, "Output",
 CellID->284622005]
}, Open  ]],
Cell[44972, 1362, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45837, 1387, 1929, 48, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[47769, 1437, 558, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[48364, 1460, 1936, 48, 70, "TutorialsSection",
 CellID->250839057],
Cell[50303, 1510, 804, 18, 70, "SectionHeaderSpacer"],
Cell[51110, 1530, 194, 5, 70, "Tutorials",
 CellID->341631938],
Cell[51307, 1537, 202, 5, 70, "Tutorials",
 CellID->678857706],
Cell[51512, 1544, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52353, 1567, 1937, 48, 70, "MoreAboutSection",
 CellID->38303248],
Cell[54293, 1617, 804, 18, 70, "SectionHeaderSpacer"],
Cell[55100, 1637, 181, 4, 70, "MoreAbout",
 CellID->244862756],
Cell[55284, 1643, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[56103, 1664, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

