(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    166099,       5233]
NotebookOptionsPosition[    150308,       4710]
NotebookOutlinePosition[    152938,       4770]
CellTagsIndexPosition[    152851,       4765]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMICDENSITYMATRIX PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "The Rotating Wave Approximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
TheRotatingWaveApproximation", "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"The Rotating Wave Approximation\"\>"}, 
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "RotatingWaveTransform", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveTransform", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "RotatingWaveTransformMatrix", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "EffectiveHamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "DropFastTerms", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/DropFastTerms", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"RotatingWaveTransform\"\>", 
       2->"\<\"RotatingWaveTransformMatrix\"\>", 
       3->"\<\"EffectiveHamiltonian\"\>", 4->"\<\"DropFastTerms\"\>"}, 
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"See Also \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/ref/RotatingWaveApproximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/ref/RotatingWaveApproximation", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/ref/RotatingWaveApproximation.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/ref/RotatingWaveApproximation", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/ref/RotatingWaveApproximation\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["RotatingWaveApproximation", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["RotatingWaveApproximation",
        BaseStyle->"Link",
        ButtonData->
         "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["h", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["\[Omega]", "TR"], ",", 
          StyleBox["tr", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]performs the rotating-wave approximation on a \
Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula"],
     " for atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula"],
     ", assuming an optical field with angular frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula"],
     " acting on transitions specified by ",
     Cell[BoxData[
      StyleBox["tr", "TI"]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["RotatingWaveApproximation",
        BaseStyle->"Link",
        ButtonData->
         "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["h", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Omega]", "TR"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["tr", "TI"], 
             StyleBox["1", "TR"]]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Omega]", "TR"], 
             StyleBox["2", "TR"]], ",", 
            SubscriptBox[
             StyleBox["tr", "TI"], 
             StyleBox["2", "TR"]]}], "}"}], ",", "..."}], "}"}]}], "]"}]], 
      "InlineFormula"],
     " \[LineSeparator]performs the RWA assuming optical fields with angular \
frequencies ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["\[Omega]", "TR"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     " acting on transitions specified by ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["tr", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["RotatingWaveApproximation",
        BaseStyle->"Link",
        ButtonData->
         "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["h", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Omega]", "TR"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["tr", "TI"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["\[CapitalDelta]", "TR"], 
             StyleBox["1", "TR"]]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Omega]", "TR"], 
             StyleBox["2", "TR"]], ",", 
            SubscriptBox[
             StyleBox["tr", "TI"], 
             StyleBox["2", "TR"]], ",", 
            SubscriptBox[
             StyleBox["\[CapitalDelta]", "TR"], 
             StyleBox["2", "TR"]]}], "}"}], ",", "..."}], "}"}]}], "]"}]], 
      "InlineFormula"],
     "\[LineSeparator]writes optical frequencies in terms of their detunings \
from resonance ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["\[CapitalDelta]", "TR"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     " after performing the RWA. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["RotatingWaveApproximation",
        BaseStyle->"Link",
        ButtonData->
         "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["h", "TI"], ",", 
        StyleBox["\[Omega]", "TR"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]performs the RWA using an automatically generated \
transformation appropriate for a single optical field. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["RotatingWaveApproximation",
        BaseStyle->"Link",
        ButtonData->
         "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["h", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Omega]", "TR"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["\[Omega]", "TR"], 
           StyleBox["2", "TR"]], ",", "..."}], "}"}], ",", 
        RowBox[{
         ButtonBox["TransformMatrix",
          BaseStyle->"Link",
          ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"], 
         "\[Rule]", 
         StyleBox["u", "TI"]}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]performs the RWA using an explicitly specified unitary \
transformation matrix."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "NotesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       Cell[
        BoxData[
         ButtonBox[
          FrameBox[
           StyleBox[
            RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"], 
           StripOnInput -> False], BaseStyle -> None, ButtonFrame -> "None", 
          ButtonFunction :> (FrontEndExecute[{
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], All, ButtonCell], 
             FrontEndToken["OpenCloseGroup"], 
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
          Evaluator -> None, Method -> "Preemptive"]]]], "NotesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Details and Options"}], "NotesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, ButtonFrame -> 
       "None", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), Evaluator -> 
       None, Method -> "Preemptive"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->71777552],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[{
 "Transitions are specified by ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["crit", "TI"], 
    StyleBox["lower", "TI"]], "\[Rule]", 
   SubscriptBox[
    StyleBox["crit", "TI"], 
    StyleBox["upper", "TI"]]}]], "InlineFormula"],
 ", where ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["crit", "TI"], 
   StyleBox["lower", "TI"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["crit", "TI"], 
   StyleBox["upper", "TI"]]], "InlineFormula"],
 " are state-selection criteria for the lower and upper states involved in \
the transition, respectively. (",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["crit", "TI"], 
   StyleBox["lower", "TI"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["crit", "TI"], 
   StyleBox["upper", "TI"]]], "InlineFormula"],
 " can each designate multiple states.)"
}], "Notes",
 CellID->462711809],

Cell[TextData[{
 "State-selection criteria are specified as for ",
 Cell[BoxData[
  ButtonBox["StatePosition",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/StatePosition"]], 
  "InlineFormula"],
 ": boolean expressions involving the state parameters, such as ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["StateLabel",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/StateLabel"], "\[Equal]", "2"}], "&&", 
   RowBox[{
    ButtonBox["F",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/F"], "\[Equal]", "1"}]}]], 
  "InlineFormula"],
 ". As a shorthand, if all states with a particular label are to be selected, \
just the label itself can be specified."
}], "Notes",
 CellID->679172156],

Cell[TextData[{
 "Putting the lower (in energy) states first in the transition specification \
corresponds to the assumption that the optical frequencies ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TR"], 
   StyleBox["i", "TI"]]], "InlineFormula"],
 " are positive. If the upper states are put first, the result will be as if \
the optical frequency is negative."
}], "Notes",
 CellID->211042750],

Cell[TextData[{
 "A list of transitions ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox[
     StyleBox["tr", "TI"], 
     RowBox[{
      StyleBox["i", "TI"], ",", "1"}]], ",", 
    SubscriptBox[
     StyleBox["tr", "TI"], 
     RowBox[{
      StyleBox["i", "TI"], ",", "2"}]], ",", "..."}], "}"}]], 
  "InlineFormula"],
 " can be supplied instead of a single transition in place of any of the \
input parameters ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["tr", "TI"], 
   StyleBox["i", "TI"]]], "InlineFormula"],
 " in the function definition above."
}], "Notes",
 CellID->272989670],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " performs the rotating-wave approximation by applying a unitary \
transformation, such as obtained from ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransformMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"]],
   "InlineFormula"],
 ", to the Hamiltonian, as done by ",
 Cell[BoxData[
  ButtonBox["EffectiveHamiltonian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"]], 
  "InlineFormula"],
 ". Far-off-resonant terms are then dropped, as done by ",
 Cell[BoxData[
  ButtonBox["DropFastTerms",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DropFastTerms"]], 
  "InlineFormula"],
 "."
}], "Notes",
 CellID->164629098],

Cell["\<\
The transform matrix is constructed so as to shift the levels involved in the \
transitions so as to eliminate the corresponding optical frequencies, working \
in the order that the transitions are specified.\
\>", "Notes",
 CellID->266548110],

Cell["\<\
If not all of the optical frequencies can be eliminated (because the states \
in the transition have already been shifted to eliminate earlier frequencies \
in the list), the remaining frequencies are written in terms of differences \
from the eliminated frequencies prior to dropping the off-resonant terms. \
This allows the elimination of all but the optical difference frequencies \
from the Hamiltonian.\
\>", "Notes",
 CellID->590769213],

Cell[TextData[{
 "Specifying a detuning parameter, as in ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["1", "TR"]], ",", 
    SubscriptBox[
     StyleBox["tr", "TI"], 
     StyleBox["1", "TR"]], ",", 
    SubscriptBox[
     StyleBox["\[CapitalDelta]", "TR"], 
     StyleBox["1", "TR"]]}], "}"}]], "InlineFormula"],
 ", amounts to making the substitution ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["\[Omega]", "TR"], 
    StyleBox["1", "TR"]], "\[Rule]", 
   RowBox[{
    RowBox[{
     ButtonBox["Energy",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
     StyleBox["upper", "TI"], "]"}], "-", 
    RowBox[{
     ButtonBox["Energy",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
     StyleBox["lower", "TI"], "]"}], "+", 
    SubscriptBox[
     StyleBox["\[CapitalDelta]", "TR"], 
     StyleBox["1", "TR"]]}]}]], "InlineFormula"],
 " in the final result, where ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Energy",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
   StyleBox["upper", "TI"], "]"}]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Energy",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
   StyleBox["lower", "TI"], "]"}]], "InlineFormula"],
 " are the energies of the upper and lower states in the transition, \
respectively."
}], "Notes",
 CellID->429937407],

Cell["The following options can be given:", "Notes",
 CellID->725381723],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Method",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Method"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "the method to use for performing the RWA", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TimeVariable",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TimeVariable"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[{
     Cell["", "TableText"],
     "symbol used to represent the time variable"
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TransformMatrix",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "unitary transformation to the rotating frame", "TableText"]], 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->11120096],

Cell[TextData[{
 "The option ",
 Cell[BoxData[
  ButtonBox["TransformMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"]], 
  "InlineFormula"],
 " can be used to explicitly a matrix to be used for transformation to the \
rotating frame."
}], "Notes",
 CellID->119417824],

Cell[TextData[{
 "If ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["RotatingWaveApproximation",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"], 
   "[", 
   RowBox[{
    StyleBox["sys", "TI"], ",", 
    StyleBox["h", "TI"], ",", 
    StyleBox["\[Omega]", "TR"]}], "]"}]], "InlineFormula"],
 " is called with ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["TransformMatrix",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"], "\[Rule]", 
   
   ButtonBox["Automatic",
    BaseStyle->"Link",
    ButtonData->"paclet:ref/Automatic"]}]], "InlineFormula"],
 ", the transform matrix is generated by assuming that states with ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Energy",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "\[Rule]", "0"}]], 
  "InlineFormula"],
 " are lower states, and all other states are upper states, coupled to the \
lower states by a field of frequency \[Omega]."
}], "Notes",
 CellID->60959430],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]],

Cell[CellGroupData[{

Cell["", "PrimaryExamplesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "EXAMPLES", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "PrimaryExamplesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Examples", 
          "\[NonBreakingSpace]\[NonBreakingSpace]", 
          Cell["(9)", "ExampleCount"]}], "PrimaryExamplesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellTags->"PrimaryExamplesSection",
 CellID->258058395],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->362576285],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->163132088],

Cell["Define a two-level system.", "ExampleText",
 CellID->260603312],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->428778375],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{302, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->30111425]
}, Open  ]],

Cell["\<\
Find the Hamiltonian with states coupled by an optical field with angular \
frequency \[Omega].\
\>", "ExampleText",
 CellID->525153128],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{"\[Omega]", ",", 
         RowBox[{"\[CapitalOmega]R", "/", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->575381706],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{186, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->164966071]
}, Open  ]],

Cell["\<\
Apply the rotating-wave approximation, specifying that the field of frequency \
\[Omega] couples the lower state with label 1 to the upper state with label \
2.\
\>", "ExampleText",
 CellID->387250359],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{"\[Omega]", ",", 
       RowBox[{"1", "\[Rule]", "2"}]}], "}"}]}], "]"}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->38299464],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{145, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->472917779]
}, Open  ]],

Cell[TextData[{
 "Specifying the detuning \[CapitalDelta] is equivalent to making the \
replacement ",
 Cell[BoxData[
  RowBox[{
   StyleBox["\[Omega]", "TR"], "\[Rule]", 
   RowBox[{
    RowBox[{
     ButtonBox["Energy",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "2", "]"}], 
    "+", 
    StyleBox["\[CapitalDelta]", "TR"]}]}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->97730723],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{"\[Omega]", ",", 
       RowBox[{"1", "\[Rule]", "2"}], ",", "\[CapitalDelta]"}], "}"}]}], 
    "]"}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->163651981],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{"-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{76, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->43282277]
}, Open  ]],

Cell[TextData[{
 "For this system, ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " can guess that state 1 is the lower state and state 2 is the upper state, \
so it is not necessary to specify the transition."
}], "ExampleText",
 CellID->165752904],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", "\[Omega]"}], "]"}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->7720144],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{145, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->527164188]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->127523831],

Cell["Here is an example with three levels and two fields.", "ExampleText",
 CellID->61580775],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->162128187],

Cell["Define a three level system.", "ExampleText",
 CellID->250408516],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<a\>\"", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}], ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<b\>\"", ",", 
      RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}], ",", " ", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<c\>\"", ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->13203490],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"c\"\>", ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{413, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->27142826]
}, Open  ]],

Cell[TextData[{
 "Find the Hamiltonian with two optical fields. We make the assumption that \
the field ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TI"], "1"]], "InlineFormula"],
 " only interacts with the ",
 Cell[BoxData[
  RowBox[{
   StyleBox["a", "TI"], "\[Rule]", 
   StyleBox["b", "TI"]}]], "InlineFormula"],
 " transition, while the field ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TI"], "2"]], "InlineFormula"],
 " only interacts with the ",
 Cell[BoxData[
  RowBox[{
   StyleBox["b", "TI"], "\[Rule]", 
   StyleBox["c", "TI"]}]], "InlineFormula"],
 " transition, by setting the additional terms to zero."
}], "ExampleText",
 CellID->277806248],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{
     RowBox[{"Expand", "@", 
      RowBox[{"Hamiltonian", "[", 
       RowBox[{"sys", ",", 
        RowBox[{"ElectricField", "\[Rule]", 
         RowBox[{
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "1"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "1"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"\"\<a\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "\"\<b\>\""}], 
              "]"}]}]}], "]"}], "+", 
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "2"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "2"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"\"\<b\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "\"\<c\>\""}], 
              "]"}]}]}], "]"}]}]}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "_", "]"}], 
       RowBox[{"ReducedME", "[", "__", "]"}]}], "\[Rule]", "0"}]}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->195541620],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], "0"},
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], 
      RowBox[{"Energy", "[", "\<\"b\"\>", "]"}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{"Energy", "[", "\<\"c\"\>", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{304, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->391305259]
}, Open  ]],

Cell[TextData[{
 "Here we apply the RWA assuming that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["a", "TI"], "]"}], "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["b", "TI"], "]"}], "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["c", "TI"], "]"}]}]], "InlineFormula"],
 ". "
}], "ExampleText",
 CellID->3515590],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"sys", ",", "h", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["\[Omega]", "1"], ",", 
          RowBox[{"\"\<a\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["\[Omega]", "2"], ",", 
          RowBox[{"\"\<b\>\"", "\[Rule]", "\"\<c\>\""}]}], "}"}]}], "}"}]}], 
     "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->23579567],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"b\"\>", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "-", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{271, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->319224327]
}, Open  ]],

Cell[TextData[{
 "The two-photon transition between states ",
 Cell[BoxData[
  StyleBox["a", "TI"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  StyleBox["c", "TI"]], "InlineFormula"],
 " is resonant when the energies of the two states in the rotating-frame \
Hamiltonian are equal; in this case, when ",
 Cell[BoxData[
  RowBox[{
   StyleBox["0", "TR"], 
   StyleBox["\[Equal]", "TR"], 
   RowBox[{
    RowBox[{
     ButtonBox["Energy",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
     StyleBox["c", "TI"], "]"}], "-", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["1", "TR"]], "-", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["2", "TR"]]}]}]], "InlineFormula"],
 ", or ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["1", "TR"]], "+", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["2", "TR"]]}], "\[Equal]", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["c", "TI"], "]"}]}]], "InlineFormula"],
 ". This corresponds to the level diagram for the system:"
}], "ExampleText",
 CellID->370785425],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "\"\<b\>\"", "]"}], "\[Rule]", "1"}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "\"\<c\>\"", "]"}], "\[Rule]", "2"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->31998729],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{-0.9, 0}, {-0.09999999999999998, 0}}]}, {{}, 
     LineBox[{{0.09999999999999998, 1}, {0.9, 1}}]}, {{}, 
     LineBox[{{-0.9, 2}, {-0.09999999999999998, 2}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{-0.45999999999999996`, 0}, {0.45999999999999996`, 1.}}], 
    ArrowBox[{{0.45999999999999996`, 1}, {-0.45999999999999996`, 2.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 103},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->929217795]
}, Open  ]],

Cell[TextData[{
 "If, instead, we assume that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["a", "TI"], "]"}], "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["c", "TI"], "]"}], "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["b", "TI"], "]"}]}]], "InlineFormula"],
 ", we obtain the rotating-frame Hamiltonian:"
}], "ExampleText",
 CellID->93080877],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"\"\<a\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"\"\<c\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}]}], "}"}]}], 
    "]"}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->229121164],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"b\"\>", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "+", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{271, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->890298591]
}, Open  ]],

Cell[TextData[{
 "Here, the two-photon resonance condition is ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["1", "TR"]], "-", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["2", "TR"]]}], "\[Equal]", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", 
    StyleBox["c", "TI"], "]"}]}]], "InlineFormula"],
 ", corresponding to the level diagram:"
}], "ExampleText",
 CellID->13622058],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "\"\<b\>\"", "]"}], "\[Rule]", "2"}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "\"\<c\>\"", "]"}], "\[Rule]", "1"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->26719029],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{-0.9, 0}, {-0.09999999999999998, 0}}]}, {{}, 
     LineBox[{{0.09999999999999998, 2}, {0.9, 2}}]}, {{}, 
     LineBox[{{-0.9, 1}, {-0.09999999999999998, 1}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{-0.45999999999999996`, 0}, {0.45999999999999996`, 2.}}], 
    ArrowBox[{{-0.45999999999999996`, 1}, {0.45999999999999996`, 2.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 103},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->101251172]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(4)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->1293636265],

Cell["\<\
A system where not all of the optical frequencies can be eliminated from the \
Hamiltonian.\
\>", "ExampleText",
 CellID->277541947],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->84518896],

Cell["\<\
Define a system with four levels coupled by four optical fields. We assume \
that each field interacts with only one transition \[LongDash] additional \
coupling terms are set to zero.\
\>", "ExampleText",
 CellID->4305022],

Cell[BoxData[
 RowBox[{
  RowBox[{"sys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"3", ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"4", ",", 
       RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "}"}]}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->241222996],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{
     RowBox[{"Expand", "@", 
      RowBox[{"Hamiltonian", "[", 
       RowBox[{"sys", ",", 
        RowBox[{"ElectricField", "\[Rule]", 
         RowBox[{
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "1"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "1"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"1", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
           "]"}], "+", 
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "2"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "2"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"1", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}]}], 
           "]"}], "+", 
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "3"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "3"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"2", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "4"}], "]"}]}]}], 
           "]"}], "+", 
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "4"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "4"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"3", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "4"}], "]"}]}]}], 
           "]"}]}]}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "_", "]"}], 
       RowBox[{"ReducedME", "[", "__", "]"}]}], "\[Rule]", "0"}]}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->329870550],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0"},
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], 
      RowBox[{"Energy", "[", "2", "]"}], "0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "3"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "3"]}]},
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0", 
      RowBox[{"Energy", "[", "3", "]"}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "4"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "4"]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "3"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "3"]}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "4"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "4"]}], 
      RowBox[{"Energy", "[", "4", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{400, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->183376454]
}, Open  ]],

Cell["\<\
Looking at the level diagram, we see that the \"closed loop\" of optical \
transitions means that, in general, not all of the optical frequencies can be \
eliminated from the Hamiltonian through a unitary transform. The position of \
one of the states is arbitrary, and after the remaining three are shifted to \
eliminate optical frequencies, there will be one uneliminated frequency left \
over, unless the optical frequencies are such that the four-photon transition \
frequency happens to be zero.\
\>", "ExampleText",
 CellID->174828097],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "3", "]"}], "\[Rule]", "1.5"}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "4", "]"}], "\[Rule]", "2"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->93078750],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{0.09999999999999998, 0}, {0.9, 0}}]}, {{}, 
     LineBox[{{-0.9, 1}, {-0.09999999999999998, 1}}]}, {{}, 
     LineBox[{{-0.9, 1.5}, {-0.09999999999999998, 1.5}}]}, {{}, 
     LineBox[{{0.09999999999999998, 2}, {0.9, 2}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{0.45999999999999996`, 0}, {-0.45999999999999996`, 1.}}], 
    ArrowBox[{{-0.45999999999999996`, 1}, {0.45999999999999996`, 2.}}], 
    ArrowBox[{{0.45999999999999996`, 0}, {-0.45999999999999996`, 1.5}}], 
    ArrowBox[{{-0.45999999999999996`, 1.5}, {0.45999999999999996`, 2.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 103},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->136527215]
}, Open  ]],

Cell[TextData[{
 "Apply the RWA, eliminating optical frequencies in the order specified. The \
last frequency, ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TR"], 
   StyleBox["4", "TR"]]], "InlineFormula"],
 ", acting on the ",
 Cell[BoxData[
  RowBox[{"3", "\[Rule]", "4"}]], "InlineFormula"],
 " transition, is not be eliminated, but it is shifted to become  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"-", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["1", "TR"]]}], "+", 
   SubscriptBox[
    StyleBox["\[Omega]", "TR"], 
    StyleBox["2", "TR"]], "-", 
   SubscriptBox[
    StyleBox["\[Omega]", "TR"], 
    StyleBox["3", "TR"]], "+", 
   SubscriptBox[
    StyleBox["\[Omega]", "TR"], 
    StyleBox["4", "TR"]]}]]],
 "."
}], "ExampleText",
 CellID->24887920],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"1", "\[Rule]", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"1", "\[Rule]", "3"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "3"], ",", 
         RowBox[{"2", "\[Rule]", "4"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "4"], ",", 
         RowBox[{"3", "\[Rule]", "4"}]}], "}"}]}], "}"}]}], "]"}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->116068404],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}]},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], "0", 
      RowBox[{
       RowBox[{"Energy", "[", "3", "]"}], "-", 
       SubscriptBox["\[Omega]", "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[Omega]", "1"]}], "+", 
           SubscriptBox["\[Omega]", "2"], "-", 
           SubscriptBox["\[Omega]", "3"], "+", 
           SubscriptBox["\[Omega]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "4"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[Omega]", "1"]}], "+", 
           SubscriptBox["\[Omega]", "2"], "-", 
           SubscriptBox["\[Omega]", "3"], "+", 
           SubscriptBox["\[Omega]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "4"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "4", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "-", 
       SubscriptBox["\[Omega]", "3"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{444, 101},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->63396683]
}, Open  ]],

Cell[TextData[{
 "If the four-photon resonance condition ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SubscriptBox[
      StyleBox["\[Omega]", "TR"], 
      StyleBox["1", "TR"]]}], "+", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["2", "TR"]], "-", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["3", "TR"]], "+", 
    SubscriptBox[
     StyleBox["\[Omega]", "TR"], 
     StyleBox["4", "TR"]]}], "\[Equal]", "0"}]]],
 " is satisfied, all time dependence is eliminated from the rotating-frame \
Hamiltonian."
}], "ExampleText",
 CellID->3439604],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", 
   RowBox[{
    SubscriptBox["\[Omega]", "4"], "\[Rule]", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["\[Omega]", "1"]}], "+", 
       SubscriptBox["\[Omega]", "2"], "-", 
       SubscriptBox["\[Omega]", "3"]}], ")"}]}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->11902821],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}]},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], "0", 
      RowBox[{
       RowBox[{"Energy", "[", "3", "]"}], "-", 
       SubscriptBox["\[Omega]", "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "4", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "-", 
       SubscriptBox["\[Omega]", "3"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{368, 101},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->193096257]
}, Open  ]],

Cell["\<\
Specifying the frequencies and transitions in a different order results in a \
different rotating-frame Hamiltonian, in which the left-over time dependence \
is found in different coupling terms.\
\>", "ExampleText",
 CellID->141763483],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"1", "\[Rule]", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "3"], ",", 
         RowBox[{"2", "\[Rule]", "4"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "4"], ",", 
         RowBox[{"3", "\[Rule]", "4"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"1", "\[Rule]", "3"}]}], "}"}]}], "}"}]}], "]"}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->90987668],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[Omega]", "1"]}], "+", 
           SubscriptBox["\[Omega]", "2"], "-", 
           SubscriptBox["\[Omega]", "3"], "+", 
           SubscriptBox["\[Omega]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[Omega]", "1"]}], "+", 
           SubscriptBox["\[Omega]", "2"], "-", 
           SubscriptBox["\[Omega]", "3"], "+", 
           SubscriptBox["\[Omega]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0", 
      RowBox[{
       RowBox[{"Energy", "[", "3", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "-", 
       SubscriptBox["\[Omega]", "3"], "+", 
       SubscriptBox["\[Omega]", "4"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "4", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "-", 
       SubscriptBox["\[Omega]", "3"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{532, 101},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->588583548]
}, Open  ]],

Cell["\<\
The result can also be written in terms of the corresponding detunings from \
the one-photon optical resonances.\
\>", "ExampleText",
 CellID->661166995],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"1", "\[Rule]", "2"}], ",", 
         SubscriptBox["\[CapitalDelta]", "1"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "3"], ",", 
         RowBox[{"2", "\[Rule]", "4"}], ",", 
         SubscriptBox["\[CapitalDelta]", "2"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "4"], ",", 
         RowBox[{"3", "\[Rule]", "4"}], ",", 
         SubscriptBox["\[CapitalDelta]", "3"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"1", "\[Rule]", "3"}], ",", 
         SubscriptBox["\[CapitalDelta]", "4"]}], "}"}]}], "}"}]}], "]"}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->416343866],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[CapitalDelta]", "1"]}], "-", 
           SubscriptBox["\[CapitalDelta]", "2"], "+", 
           SubscriptBox["\[CapitalDelta]", "3"], "+", 
           SubscriptBox["\[CapitalDelta]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{"-", 
       SubscriptBox["\[CapitalDelta]", "1"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["\[CapitalDelta]", "1"]}], "-", 
           SubscriptBox["\[CapitalDelta]", "2"], "+", 
           SubscriptBox["\[CapitalDelta]", "3"], "+", 
           SubscriptBox["\[CapitalDelta]", "4"]}], ")"}]}]], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], "0", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["\[CapitalDelta]", "1"]}], "-", 
       SubscriptBox["\[CapitalDelta]", "2"], "+", 
       SubscriptBox["\[CapitalDelta]", "3"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "3"], "2"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "4"], "2"]}], 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["\[CapitalDelta]", "1"]}], "-", 
       SubscriptBox["\[CapitalDelta]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{401, 101},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->638765535]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->390157435],

Cell["\<\
A system in which a single field acts on multiple transitions.\
\>", "ExampleText",
 CellID->230501236],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->190661463],

Cell[TextData[{
 "Define a three level system, and the Hamiltonian, assuming an optical field \
of amplitude ",
 Cell[BoxData["E0"], "InlineFormula"],
 " and frequency ",
 Cell[BoxData[
  StyleBox["\[Omega]", "TR"]], "InlineFormula"],
 ". The field interacts with both the ",
 Cell[BoxData[
  RowBox[{"1", "\[Rule]", "2"}]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  RowBox[{"2", "\[Rule]", "3"}]], "InlineFormula"],
 " transitions. "
}], "ExampleText",
 CellID->261533409],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"2", ",", 
      RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}], ",", " ", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"3", ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->82855473],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"3", ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{413, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->13547532]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{
     RowBox[{"Expand", "@", 
      RowBox[{"Hamiltonian", "[", 
       RowBox[{"sys", ",", 
        RowBox[{"ElectricField", "\[Rule]", 
         RowBox[{"OpticalField", "[", 
          RowBox[{"\[Omega]", ",", "E0"}], "]"}]}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{"ReducedME", "[", 
       RowBox[{"i_", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "j_"}], "]"}], "\[Rule]", 
      SubscriptBox["d", 
       RowBox[{"i", ",", "j"}]]}]}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->404284005],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "1", "]"}], 
      RowBox[{
       RowBox[{"-", "E0"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}], " ", 
       SubscriptBox["d", 
        RowBox[{"1", ",", "2"}]]}], "0"},
     {
      RowBox[{
       RowBox[{"-", "E0"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}], " ", 
       SubscriptBox["d", 
        RowBox[{"1", ",", "2"}]]}], 
      RowBox[{"Energy", "[", "2", "]"}], 
      RowBox[{
       RowBox[{"-", "E0"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}], " ", 
       SubscriptBox["d", 
        RowBox[{"2", ",", "3"}]]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", "E0"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}], " ", 
       SubscriptBox["d", 
        RowBox[{"2", ",", "3"}]]}], 
      RowBox[{"Energy", "[", "3", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{349, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->191339406]
}, Open  ]],

Cell[TextData[{
 "Apply the RWA assuming that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "1", "]"}], 
   "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "2", "]"}], 
   "<", 
   RowBox[{
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "3", "]"}]}]],
   "InlineFormula"],
 ", and specifying that the field acts on both transitions. "
}], "ExampleText",
 CellID->4950985],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"sys", ",", "h", ",", 
      RowBox[{"{", 
       RowBox[{"\[Omega]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "2"}], ",", 
          RowBox[{"2", "\[Rule]", "3"}]}], "}"}]}], "}"}]}], "]"}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->237795122],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "1", "]"}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", "E0", " ", 
       SubscriptBox["d", 
        RowBox[{"1", ",", "2"}]]}], "0"},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", "E0", " ", 
       SubscriptBox["d", 
        RowBox[{"1", ",", "2"}]]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", "E0", " ", 
       SubscriptBox["d", 
        RowBox[{"2", ",", "3"}]]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "2"]}], " ", "E0", " ", 
       SubscriptBox["d", 
        RowBox[{"2", ",", "3"}]]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "3", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{295, 69},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->220623488]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->109725417],

Cell["A system with Zeeman and hyperfine structure.", "ExampleText",
 CellID->87827499],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->648457342],

Cell[TextData[{
 "Define the atomic system, with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"I", "=", 
    RowBox[{"1", "/", "2"}]}], TraditionalForm]], "InlineMath"],
 " and upper and lower states having ",
 Cell[BoxData[
  FormBox[
   RowBox[{"J", "=", 
    RowBox[{"1", "/", "2"}]}], TraditionalForm]], "InlineMath"],
 "."
}], "ExampleText",
 CellID->419209294],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{"HyperfineA", "\[Rule]", "hfa1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"NuclearSpin", "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
       RowBox[{"HyperfineA", "\[Rule]", "hfa2"}]}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->114849154],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa1"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa1"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa1"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa1"}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa2"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa2"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa2"}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"HyperfineA", "\[Rule]", "hfa2"}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{576, 240},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->975681355]
}, Open  ]],

Cell["\<\
Find the Hamiltonian with states coupled by a circularly polarized optical \
field with angular frequency \[Omega].\
\>", "ExampleText",
 CellID->249814237],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"sys", ",", 
       RowBox[{"ElectricField", "\[Rule]", 
        RowBox[{"OpticalField", "[", 
         RowBox[{"\[Omega]", ",", 
          RowBox[{"\[CapitalOmega]R", "/", 
           RowBox[{"ReducedME", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"\[Pi]", "/", "4"}]}], "}"}]}], "]"}]}]}], "]"}], "//", 
     "TrigToExp"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->14892414],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["hfa1", "4"], "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]]},
     {"0", 
      FractionBox["hfa1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0"},
     {"0", "0", 
      FractionBox["hfa1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", "hfa1"}], "4"]}], 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], 
      RowBox[{
       FractionBox["hfa2", "4"], "+", "\[Omega]0"}], "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", 
      RowBox[{
       FractionBox["hfa2", "4"], "+", "\[Omega]0"}], "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", 
      RowBox[{
       FractionBox["hfa2", "4"], "+", "\[Omega]0"}], "0"},
     {
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
         "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"3", " ", "hfa2"}], "4"]}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{511, 285},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->21293874]
}, Open  ]],

Cell["\<\
Some of the matrix elements in the Hamiltonian represent resonant couplings, \
and others off resonant couplings. The LevelDiagram suppresses the \
off-resonant couplings by default. \
\>", "ExampleText",
 CellID->20208884],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "2"}], ",", 
      RowBox[{"hfa1", "\[Rule]", ".3"}], ",", 
      RowBox[{"hfa2", "\[Rule]", ".3"}], ",", 
      RowBox[{"\[Omega]", "\[Rule]", "2"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->64965567],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{0.6, 0.075}, {1.4, 0.075}}]}, {{}, 
     LineBox[{{-0.4, 0.075}, {0.4, 0.075}}]}, {{}, 
     LineBox[{{-1.4, 0.075}, {-0.6, 0.075}}]}, {{}, 
     LineBox[{{-0.4, -0.22499999999999998`}, {
      0.4, -0.22499999999999998`}}]}, {{}, 
     LineBox[{{0.6, 2.075}, {1.4, 2.075}}]}, {{}, 
     LineBox[{{-0.4, 2.075}, {0.4, 2.075}}]}, {{}, 
     LineBox[{{-1.4, 2.075}, {-0.6, 2.075}}]}, {{}, 
     LineBox[{{-0.4, 1.775}, {0.4, 1.775}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.05, 0.05}], 
    ArrowBox[{{0.04000000000000001, 0.075}, {0.96, 2.075}}], 
    ArrowBox[{{-0.96, 0.075}, {-0.04000000000000001, 2.075}}], 
    ArrowBox[{{-0.96, 0.075}, {-0.04000000000000001, 2.075}}], 
    ArrowBox[{{0.04000000000000001, -0.22499999999999998`}, {0.96, 
     1.775}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->144.]], "Output",
 ImageSize->{148, 120},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->9629248]
}, Open  ]],

Cell["\<\
Applying the rotating-wave approximation explicitly removes the off-resonant \
couplings from the Hamiltonian.\
\>", "ExampleText",
 CellID->56028379],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"sys", ",", "h", ",", 
      RowBox[{"{", 
       RowBox[{"\[Omega]", ",", 
        RowBox[{"1", "\[Rule]", "2"}], ",", "\[CapitalDelta]"}], "}"}]}], 
     "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->861700294],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["hfa1", "4"], "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["hfa1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0"},
     {"0", "0", 
      FractionBox["hfa1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", "hfa1"}], "4"]}], 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "0", "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], 
      RowBox[{
       FractionBox["hfa2", "4"], "-", "\[CapitalDelta]"}], "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", 
      RowBox[{
       FractionBox["hfa2", "4"], "-", "\[CapitalDelta]"}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{
       FractionBox["hfa2", "4"], "-", "\[CapitalDelta]"}], "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"3", " ", "hfa2"}], "4"]}], "-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{413, 231},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->596928366]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->172466977],

Cell["Using \[Nu]-units for frequency:", "ExampleText",
 CellID->500428719],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->88750917],

Cell["Define a two-level system.", "ExampleText",
 CellID->89528452],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->97292605],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{302, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->77763927]
}, Open  ]],

Cell[TextData[{
 "Find the Hamiltonian and apply the RWA with states coupled by an optical \
field with frequency \[Nu] in cycles per second. ",
 Cell[BoxData[
  ButtonBox["OpticalField",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"]], 
  "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " take angular frequencies as inputs \[LongDash] these can be specified as \
",
 Cell[BoxData[
  RowBox[{"2", 
   StyleBox["\[Pi]", "TR"], " ", 
   StyleBox["\[Nu]", "TR"]}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->92852458],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{
         RowBox[{"2", "\[Pi]", " ", "\[Nu]"}], ",", 
         RowBox[{"\[CapitalOmega]R", "/", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->517339817],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"2", " ", "\[Pi]", " ", "t", " ", "\[Nu]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"2", " ", "\[Pi]", " ", "t", " ", "\[Nu]"}], "]"}]}], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{226, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->154917320]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", "\[Pi]", " ", "\[Nu]"}], ",", 
       RowBox[{"1", "\[Rule]", "2"}]}], "}"}]}], "]"}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->54161398],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[Pi]", " ", "\[Nu]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{165, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->291845337]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->253720217],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "TransformMatrix",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->36428939],

Cell["Manually specify the transformation matrix.", "ExampleText",
 CellID->32320667],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->377929109],

Cell["Define a three level system.", "ExampleText",
 CellID->553409450],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<a\>\"", ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<b\>\"", ",", 
      RowBox[{"Parity", "\[Rule]", "Odd"}], ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", " ", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"\"\<c\>\"", ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->124661712],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"a\"\>", ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"b\"\>", ",", 
     RowBox[{"Parity", "\[Rule]", "Odd"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"\<\"c\"\>", ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{489, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->35215666]
}, Open  ]],

Cell[TextData[{
 "Find the Hamiltonian with two optical fields. We make the assumption that \
the field ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TI"], "1"]], "InlineFormula"],
 " only interacts with the ",
 Cell[BoxData[
  RowBox[{
   StyleBox["a", "TI"], "\[Rule]", 
   StyleBox["b", "TI"]}]], "InlineFormula"],
 " transition, while the field ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["\[Omega]", "TI"], "2"]], "InlineFormula"],
 " only interacts with the ",
 Cell[BoxData[
  RowBox[{
   StyleBox["b", "TI"], "\[Rule]", 
   StyleBox["c", "TI"]}]], "InlineFormula"],
 " transition, by setting the additional terms to zero."
}], "ExampleText",
 CellID->544981648],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{
     RowBox[{"Expand", "@", 
      RowBox[{"Hamiltonian", "[", 
       RowBox[{"sys", ",", 
        RowBox[{"ElectricField", "\[Rule]", 
         RowBox[{
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "1"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "1"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"\"\<a\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "\"\<b\>\""}], 
              "]"}]}]}], "]"}], "+", 
          RowBox[{"OpticalField", "[", 
           RowBox[{
            SubscriptBox["\[Omega]", "2"], ",", 
            RowBox[{
             SubscriptBox["\[CapitalOmega]R", "2"], "/", 
             RowBox[{"ReducedME", "[", 
              RowBox[{"\"\<b\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"Dipole", ",", "1"}], "}"}], ",", "\"\<c\>\""}], 
              "]"}]}]}], "]"}]}]}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "_", "]"}], 
       RowBox[{"ReducedME", "[", "__", "]"}]}], "\[Rule]", "0"}]}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->522370308],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "\<\"a\"\>", "]"}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], "0"},
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "1"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "1"]}], "0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", 
          SubscriptBox["\[Omega]", "2"]}], "]"}]}], " ", 
       SubscriptBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{"Energy", "[", "\<\"c\"\>", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{304, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->23330826]
}, Open  ]],

Cell[TextData[{
 "We have defined the energy of state ",
 Cell[BoxData[
  StyleBox["b", "TI"]], "InlineFormula"],
 " to be zero. Here we will assume that the energies of states ",
 Cell[BoxData[
  StyleBox["a", "TI"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  StyleBox["c", "TI"]], "InlineFormula"],
 " are negative, and we wish to perform the RWA by shifting the lower states \
up. We manually define a unitary transformation ",
 Cell[BoxData[
  StyleBox["u", "TI"]], "InlineFormula"],
 " to accomplish this."
}], "ExampleText",
 CellID->1935268],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", "0", ",", 
         SubscriptBox["\[Omega]", "2"]}], "}"}], "]"}]}], "]"}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->298032528],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", 
        SubscriptBox["\[Omega]", "1"]}]], "0", "0"},
     {"0", "1", "0"},
     {"0", "0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", 
        SubscriptBox["\[Omega]", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{111, 51},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->231205085]
}, Open  ]],

Cell[TextData[{
 "Perform the RWA using our predefined matrix ",
 Cell[BoxData[
  StyleBox["u", "TI"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->327482246],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["\[Omega]", "1"], ",", 
       SubscriptBox["\[Omega]", "2"]}], "}"}], ",", 
     RowBox[{"TransformMatrix", "\[Rule]", "u"}]}], "]"}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->331657492],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"Energy", "[", "\<\"a\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{246, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->482698859]
}, Open  ]],

Cell["\<\
If we instead perform the RWA by specifying the transition for each optical \
frequency, we get a slightly different result, because by default the \
transformation is defined to shift the upper states down:\
\>", "ExampleText",
 CellID->497989497],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"\"\<a\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"\"\<c\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}]}], "}"}]}], 
    "]"}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->561489579],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "\<\"a\"\>", "]"}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], 
      RowBox[{"-", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "-", 
       SubscriptBox["\[Omega]", "1"], "+", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{245, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->2949965]
}, Open  ]],

Cell["\<\
This effective Hamiltonian differs only by an overall energy shift from the \
one that we obtained with the custom transformation matrix:\
\>", "ExampleText",
 CellID->686231876],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "+", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], 
    RowBox[{"IdentityMatrix", "[", "3", "]"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->408347985],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"Energy", "[", "\<\"a\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{246, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->550219791]
}, Open  ]],

Cell[TextData[{
 "We can obtain the same result by specifying ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Method",
    BaseStyle->"Link",
    ButtonData->"paclet:ref/Method"], "\[Rule]", "\"\<ShiftLowerState\>\""}]],
   "InlineFormula"],
 "."
}], "ExampleText",
 CellID->355492260],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"RotatingWaveApproximation", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "1"], ",", 
         RowBox[{"\"\<a\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Omega]", "2"], ",", 
         RowBox[{"\"\<c\>\"", "\[Rule]", "\"\<b\>\""}]}], "}"}]}], "}"}], ",",
      
     RowBox[{"Method", "\[Rule]", "\"\<ShiftLowerState\>\""}]}], "]"}], ")"}],
   "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->633394463],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"Energy", "[", "\<\"a\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "1"]}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "1"], "2"]}], "0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}]},
     {"0", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[CapitalOmega]R", "2"], "2"]}], 
      RowBox[{
       RowBox[{"Energy", "[", "\<\"c\"\>", "]"}], "+", 
       SubscriptBox["\[Omega]", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{246, 75},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->292896034]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Properties & Relations",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->2123667759],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->411256587],

Cell["\<\
Define a system with Zeeman structure, and find the Hamiltonian assuming a \
single optical field of frequency \[Omega].\
\>", "ExampleText",
 CellID->62975021],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->137509959],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{543, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->137385330]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Expand", "@", 
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"sys", ",", 
       RowBox[{"ElectricField", "\[Rule]", 
        RowBox[{"OpticalField", "[", 
         RowBox[{"\[Omega]", ",", 
          RowBox[{"\[CapitalOmega]R", "/", 
           RowBox[{"ReducedME", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
         "]"}]}]}], "]"}]}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->552143696],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       SqrtBox["6"]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["6"]]}]},
     {
      FractionBox[
       RowBox[{"\[CapitalOmega]R", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       SqrtBox["6"]], "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["6"]]}], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{233, 109},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->18610209]
}, Open  ]],

Cell["Plot the level diagram.", "ExampleText",
 CellID->692730961],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", "h"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->411603585],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{0.6, 0}, {1.4, 0}}]}, {{}, 
     LineBox[{{-0.4, 0}, {0.4, 0}}]}, {{}, 
     LineBox[{{-1.4, 0}, {-0.6, 0}}]}, {{}, 
     LineBox[{{-0.4, 1}, {0.4, 1}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.05, 0.05}], 
    ArrowBox[{{-0.96, 0}, {-0.04000000000000001, 1.}}], 
    ArrowBox[{{0.96, 0}, {0.04000000000000001, 1.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->144.]], "Output",
 ImageSize->{148, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->466095746]
}, Open  ]],

Cell[TextData[{
 "Perform the RWA directly using ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 "."
}], "ExampleText",
 CellID->232829114],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"sys", ",", "h", ",", 
      RowBox[{"{", 
       RowBox[{"\[Omega]", ",", 
        RowBox[{"1", "\[Rule]", "2"}]}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->28490051],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{216, 105},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->361758417]
}, Open  ]],

Cell[TextData[{
 "The unitary transformation used is returned by ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransformMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"]],
   "InlineFormula"],
 ". "
}], "ExampleText",
 CellID->48554595],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"RotatingWaveTransformMatrix", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"{", 
       RowBox[{"\[Omega]", ",", 
        RowBox[{"1", "\[Rule]", "2"}]}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->109464664],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{101, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->296611083]
}, Open  ]],

Cell[TextData[{
 "This matrix can be supplied to the function ",
 Cell[BoxData[
  ButtonBox["EffectiveHamiltonian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"]], 
  "InlineFormula"],
 " to transform the Hamiltonian to the rotating frame without dropping the \
fast-oscillating terms."
}], "ExampleText",
 CellID->796288105],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"heff", "=", 
    RowBox[{
     RowBox[{"EffectiveHamiltonian", "[", 
      RowBox[{"h", ",", "u", ",", "t"}], "]"}], "//", "TrigToExp"}]}], ")"}], 
  "//", "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->624418580],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
           "\[Omega]"}]], " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
           "\[Omega]"}]], " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {
      RowBox[{
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], 
         " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], 
         " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{349, 121},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->45843083]
}, Open  ]],

Cell[TextData[{
 "This can also be accomplished in one step using the function ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransform",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransform"]], 
  "InlineFormula"],
 "."
}], "ExampleText",
 CellID->107693193],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotatingWaveTransform", "[", 
    RowBox[{"sys", ",", "h", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\[Omega]", ",", 
        RowBox[{"1", "\[Rule]", "2"}]}], "}"}], "}"}]}], "]"}], "//", 
   "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->1020165169],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
           "\[Omega]"}]], " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
           "\[Omega]"}]], " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {
      RowBox[{
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], 
         " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], "0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", 
         RowBox[{"2", " ", 
          SqrtBox["6"]}]]}], "-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], 
         " ", "\[CapitalOmega]R"}], 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{349, 121},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->331660569]
}, Open  ]],

Cell[TextData[{
 "Applying ",
 Cell[BoxData[
  ButtonBox["DropFastTerms",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DropFastTerms"]], 
  "InlineFormula"],
 " to the transformed matrix results in the same Hamiltonian returned by ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " above."
}], "ExampleText",
 CellID->301584982],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DropFastTerms", "[", 
   RowBox[{"heff", ",", "\[Omega]", ",", "t"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->10174850],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}]},
     {
      FractionBox["\[CapitalOmega]R", 
       RowBox[{"2", " ", 
        SqrtBox["6"]}]], "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", 
        RowBox[{"2", " ", 
         SqrtBox["6"]}]]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", 
       RowBox[{"Energy", "[", "2", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{216, 105},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->21958955]
}, Open  ]],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SeeAlsoSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "SEE ALSO", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "SeeAlsoSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "See Also"}], "SeeAlsoSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["RotatingWaveTransform",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransform"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["RotatingWaveTransformMatrix",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"],
   
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["EffectiveHamiltonian",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["DropFastTerms",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/DropFastTerms"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "TUTORIALS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "TutorialsSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Tutorials"}], "TutorialsSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["The Rotating Wave Approximation",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation"]], \
"Tutorials",
 CellID->341631938],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "MoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "MORE ABOUT", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "MoreAboutSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "More About"}], "MoreAboutSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], "MoreAbout",
 CellID->3266805],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RotatingWaveApproximation - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 18.8159871}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"ADM", "Atomic Density Matrix"}, 
    "index" -> True, "label" -> "AtomicDensityMatrix Paclet Symbol", 
    "language" -> "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None",
     "summary" -> 
    "RotatingWaveApproximation[sys, h, {\\[Omega], tr}] performs the \
rotating-wave approximation on a Hamiltonian h for atomic system sys, \
assuming an optical field with angular frequency \\[Omega] acting on \
transitions specified by tr. RotatingWaveApproximation[sys, h, {{\\[Omega]_1, \
tr_1}, {\\[Omega]_2, tr_2}, ...}] performs the RWA assuming optical fields \
with angular frequencies \\[Omega]_i acting on transitions specified by tr_i. \
RotatingWaveApproximation[sys, h, {{\\[Omega]_1, tr_1, \\[CapitalDelta]_1}, {\
\\[Omega]_2, tr_2, \\[CapitalDelta]_2}, ...}] writes optical frequencies in \
terms of their detunings from resonance \\[CapitalDelta]_i after performing \
the RWA. RotatingWaveApproximation[sys, h, \\[Omega]] performs the RWA using \
an automatically generated transformation appropriate for a single optical \
field. RotatingWaveApproximation[sys, h, {\\[Omega]_1, \\[Omega]_2, ...}, \
TransformMatrix -> u] performs the RWA using an explicitly specified unitary \
transformation matrix.", "synonyms" -> {}, "title" -> 
    "RotatingWaveApproximation", "type" -> "Symbol", "uri" -> 
    "AtomicDensityMatrix/ref/RotatingWaveApproximation"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
CellContext->"Global`",
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[30400, 821, 2082, 51, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->258058395]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 152706, 4758}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 76, 1, 3, "SymbolColorBar"],
Cell[647, 24, 220, 5, 70, "LinkTrail"],
Cell[870, 31, 11545, 239, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[12440, 274, 68, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[12511, 277, 5427, 161, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[17975, 443, 2152, 54, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->71777552],
Cell[20130, 499, 804, 18, 70, "SectionHeaderSpacer"],
Cell[20937, 519, 906, 33, 70, "Notes",
 CellID->462711809],
Cell[21846, 554, 750, 22, 70, "Notes",
 CellID->679172156],
Cell[22599, 578, 411, 10, 70, "Notes",
 CellID->211042750],
Cell[23013, 590, 601, 22, 70, "Notes",
 CellID->272989670],
Cell[23617, 614, 933, 27, 70, "Notes",
 CellID->164629098],
Cell[24553, 643, 253, 5, 70, "Notes",
 CellID->266548110],
Cell[24809, 650, 453, 8, 70, "Notes",
 CellID->590769213],
Cell[25265, 660, 1543, 51, 70, "Notes",
 CellID->429937407],
Cell[26811, 713, 72, 1, 70, "Notes",
 CellID->725381723],
Cell[26886, 716, 1320, 34, 70, "3ColumnTableMod",
 CellID->11120096],
Cell[28209, 752, 314, 10, 70, "Notes",
 CellID->119417824],
Cell[28526, 764, 1030, 32, 70, "Notes",
 CellID->60959430],
Cell[29559, 798, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]],
Cell[CellGroupData[{
Cell[30400, 821, 2082, 51, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->258058395],
Cell[CellGroupData[{
Cell[32507, 876, 181, 6, 70, "ExampleSection",
 CellID->362576285],
Cell[32691, 884, 128, 3, 70, "Input",
 CellID->163132088],
Cell[32822, 889, 69, 1, 70, "ExampleText",
 CellID->260603312],
Cell[CellGroupData[{
Cell[32916, 894, 285, 9, 70, "Input",
 CellID->428778375],
Cell[33204, 905, 343, 11, 70, "Output",
 CellID->30111425]
}, Open  ]],
Cell[33562, 919, 146, 4, 70, "ExampleText",
 CellID->525153128],
Cell[CellGroupData[{
Cell[33733, 927, 554, 16, 70, "Input",
 CellID->575381706],
Cell[34290, 945, 1037, 31, 70, "Output",
 CellID->164966071]
}, Open  ]],
Cell[35342, 979, 211, 5, 70, "ExampleText",
 CellID->387250359],
Cell[CellGroupData[{
Cell[35578, 988, 311, 10, 70, "Input",
 CellID->38299464],
Cell[35892, 1000, 949, 29, 70, "Output",
 CellID->472917779]
}, Open  ]],
Cell[36856, 1032, 439, 15, 70, "ExampleText",
 CellID->97730723],
Cell[CellGroupData[{
Cell[37320, 1051, 338, 10, 70, "Input",
 CellID->163651981],
Cell[37661, 1063, 888, 27, 70, "Output",
 CellID->43282277]
}, Open  ]],
Cell[38564, 1093, 382, 10, 70, "ExampleText",
 CellID->165752904],
Cell[CellGroupData[{
Cell[38971, 1107, 223, 7, 70, "Input",
 CellID->7720144],
Cell[39197, 1116, 949, 29, 70, "Output",
 CellID->527164188]
}, Open  ]],
Cell[CellGroupData[{
Cell[40183, 1150, 125, 3, 70, "ExampleDelimiter",
 CellID->127523831],
Cell[40311, 1155, 94, 1, 70, "ExampleText",
 CellID->61580775],
Cell[40408, 1158, 128, 3, 70, "Input",
 CellID->162128187],
Cell[40539, 1163, 71, 1, 70, "ExampleText",
 CellID->250408516],
Cell[CellGroupData[{
Cell[40635, 1168, 547, 15, 70, "Input",
 CellID->13203490],
Cell[41185, 1185, 595, 17, 70, "Output",
 CellID->27142826]
}, Open  ]],
Cell[41795, 1205, 684, 22, 70, "ExampleText",
 CellID->277806248],
Cell[CellGroupData[{
Cell[42504, 1231, 1289, 36, 70, "Input",
 CellID->195541620],
Cell[43796, 1269, 1630, 49, 70, "Output",
 CellID->391305259]
}, Open  ]],
Cell[45441, 1321, 629, 21, 70, "ExampleText",
 CellID->3515590],
Cell[CellGroupData[{
Cell[46095, 1346, 602, 18, 70, "Input",
 CellID->23579567],
Cell[46700, 1366, 1382, 42, 70, "Output",
 CellID->319224327]
}, Open  ]],
Cell[48097, 1411, 1258, 42, 70, "ExampleText",
 CellID->370785425],
Cell[CellGroupData[{
Cell[49380, 1457, 372, 12, 70, "Input",
 CellID->31998729],
Cell[49755, 1471, 648, 14, 70, "Output",
 CellID->929217795]
}, Open  ]],
Cell[50418, 1488, 663, 21, 70, "ExampleText",
 CellID->93080877],
Cell[CellGroupData[{
Cell[51106, 1513, 563, 17, 70, "Input",
 CellID->229121164],
Cell[51672, 1532, 1382, 42, 70, "Output",
 CellID->890298591]
}, Open  ]],
Cell[53069, 1577, 538, 18, 70, "ExampleText",
 CellID->13622058],
Cell[CellGroupData[{
Cell[53632, 1599, 372, 12, 70, "Input",
 CellID->26719029],
Cell[54007, 1613, 648, 14, 70, "Output",
 CellID->101251172]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[54716, 1634, 254, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[54973, 1644, 142, 4, 70, "ExampleText",
 CellID->277541947],
Cell[55118, 1650, 127, 3, 70, "Input",
 CellID->84518896],
Cell[55248, 1655, 233, 5, 70, "ExampleText",
 CellID->4305022],
Cell[55484, 1662, 671, 20, 70, "Input",
 CellID->241222996],
Cell[CellGroupData[{
Cell[56180, 1686, 2033, 56, 70, "Input",
 CellID->329870550],
Cell[58216, 1744, 2473, 75, 70, "Output",
 CellID->183376454]
}, Open  ]],
Cell[60704, 1822, 552, 9, 70, "ExampleText",
 CellID->174828097],
Cell[CellGroupData[{
Cell[61281, 1835, 436, 14, 70, "Input",
 CellID->93078750],
Cell[61720, 1851, 860, 17, 70, "Output",
 CellID->136527215]
}, Open  ]],
Cell[62595, 1871, 794, 28, 70, "ExampleText",
 CellID->24887920],
Cell[CellGroupData[{
Cell[63414, 1903, 807, 25, 70, "Input",
 CellID->116068404],
Cell[64224, 1930, 2682, 79, 70, "Output",
 CellID->63396683]
}, Open  ]],
Cell[66921, 2012, 605, 21, 70, "ExampleText",
 CellID->3439604],
Cell[CellGroupData[{
Cell[67551, 2037, 398, 14, 70, "Input",
 CellID->11902821],
Cell[67952, 2053, 1872, 58, 70, "Output",
 CellID->193096257]
}, Open  ]],
Cell[69839, 2114, 246, 5, 70, "ExampleText",
 CellID->141763483],
Cell[CellGroupData[{
Cell[70110, 2123, 806, 25, 70, "Input",
 CellID->90987668],
Cell[70919, 2150, 2771, 81, 70, "Output",
 CellID->588583548]
}, Open  ]],
Cell[73705, 2234, 163, 4, 70, "ExampleText",
 CellID->661166995],
Cell[CellGroupData[{
Cell[73893, 2242, 1020, 29, 70, "Input",
 CellID->416343866],
Cell[74916, 2273, 2778, 80, 70, "Output",
 CellID->638765535]
}, Open  ]],
Cell[CellGroupData[{
Cell[77731, 2358, 125, 3, 70, "ExampleDelimiter",
 CellID->390157435],
Cell[77859, 2363, 113, 3, 70, "ExampleText",
 CellID->230501236],
Cell[77975, 2368, 128, 3, 70, "Input",
 CellID->190661463],
Cell[78106, 2373, 476, 15, 70, "ExampleText",
 CellID->261533409],
Cell[CellGroupData[{
Cell[78607, 2392, 475, 14, 70, "Input",
 CellID->82855473],
Cell[79085, 2408, 524, 16, 70, "Output",
 CellID->13547532]
}, Open  ]],
Cell[CellGroupData[{
Cell[79646, 2429, 640, 19, 70, "Input",
 CellID->404284005],
Cell[80289, 2450, 1623, 50, 70, "Output",
 CellID->191339406]
}, Open  ]],
Cell[81927, 2503, 625, 21, 70, "ExampleText",
 CellID->4950985],
Cell[CellGroupData[{
Cell[82577, 2528, 442, 14, 70, "Input",
 CellID->237795122],
Cell[83022, 2544, 1592, 51, 70, "Output",
 CellID->220623488]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[84663, 2601, 125, 3, 70, "ExampleDelimiter",
 CellID->109725417],
Cell[84791, 2606, 87, 1, 70, "ExampleText",
 CellID->87827499],
Cell[84881, 2609, 128, 3, 70, "Input",
 CellID->648457342],
Cell[85012, 2614, 361, 13, 70, "ExampleText",
 CellID->419209294],
Cell[CellGroupData[{
Cell[85398, 2631, 829, 23, 70, "Input",
 CellID->114849154],
Cell[86230, 2656, 3405, 89, 70, "Output",
 CellID->975681355]
}, Open  ]],
Cell[89650, 2748, 166, 4, 70, "ExampleText",
 CellID->249814237],
Cell[CellGroupData[{
Cell[89841, 2756, 704, 20, 70, "Input",
 CellID->14892414],
Cell[90548, 2778, 5722, 176, 70, "Output",
 CellID->21293874]
}, Open  ]],
Cell[96285, 2957, 233, 5, 70, "ExampleText",
 CellID->20208884],
Cell[CellGroupData[{
Cell[96543, 2966, 383, 11, 70, "Input",
 CellID->64965567],
Cell[96929, 2979, 1020, 23, 70, "Output",
 CellID->9629248]
}, Open  ]],
Cell[97964, 3005, 160, 4, 70, "ExampleText",
 CellID->56028379],
Cell[CellGroupData[{
Cell[98149, 3013, 371, 11, 70, "Input",
 CellID->861700294],
Cell[98523, 3026, 2407, 74, 70, "Output",
 CellID->596928366]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[100979, 3106, 125, 3, 70, "ExampleDelimiter",
 CellID->172466977],
Cell[101107, 3111, 75, 1, 70, "ExampleText",
 CellID->500428719],
Cell[101185, 3114, 127, 3, 70, "Input",
 CellID->88750917],
Cell[101315, 3119, 68, 1, 70, "ExampleText",
 CellID->89528452],
Cell[CellGroupData[{
Cell[101408, 3124, 284, 9, 70, "Input",
 CellID->97292605],
Cell[101695, 3135, 343, 11, 70, "Output",
 CellID->77763927]
}, Open  ]],
Cell[102053, 3149, 718, 22, 70, "ExampleText",
 CellID->92852458],
Cell[CellGroupData[{
Cell[102796, 3175, 590, 17, 70, "Input",
 CellID->517339817],
Cell[103389, 3194, 1079, 31, 70, "Output",
 CellID->154917320]
}, Open  ]],
Cell[CellGroupData[{
Cell[104505, 3230, 345, 11, 70, "Input",
 CellID->54161398],
Cell[104853, 3243, 989, 30, 70, "Output",
 CellID->291845337]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[105903, 3280, 255, 8, 70, "ExampleSection",
 CellID->253720217],
Cell[CellGroupData[{
Cell[106183, 3292, 268, 8, 70, "ExampleSubsection",
 CellID->36428939],
Cell[106454, 3302, 85, 1, 70, "ExampleText",
 CellID->32320667],
Cell[106542, 3305, 128, 3, 70, "Input",
 CellID->377929109],
Cell[106673, 3310, 71, 1, 70, "ExampleText",
 CellID->553409450],
Cell[CellGroupData[{
Cell[106769, 3315, 548, 15, 70, "Input",
 CellID->124661712],
Cell[107320, 3332, 595, 17, 70, "Output",
 CellID->35215666]
}, Open  ]],
Cell[107930, 3352, 684, 22, 70, "ExampleText",
 CellID->544981648],
Cell[CellGroupData[{
Cell[108639, 3378, 1289, 36, 70, "Input",
 CellID->522370308],
Cell[109931, 3416, 1629, 49, 70, "Output",
 CellID->23330826]
}, Open  ]],
Cell[111575, 3468, 551, 16, 70, "ExampleText",
 CellID->1935268],
Cell[CellGroupData[{
Cell[112151, 3488, 422, 13, 70, "Input",
 CellID->298032528],
Cell[112576, 3503, 1014, 29, 70, "Output",
 CellID->231205085]
}, Open  ]],
Cell[113605, 3535, 165, 6, 70, "ExampleText",
 CellID->327482246],
Cell[CellGroupData[{
Cell[113795, 3545, 395, 12, 70, "Input",
 CellID->331657492],
Cell[114193, 3559, 1338, 41, 70, "Output",
 CellID->482698859]
}, Open  ]],
Cell[115546, 3603, 258, 5, 70, "ExampleText",
 CellID->497989497],
Cell[CellGroupData[{
Cell[115829, 3612, 563, 17, 70, "Input",
 CellID->561489579],
Cell[116395, 3631, 1374, 42, 70, "Output",
 CellID->2949965]
}, Open  ]],
Cell[117784, 3676, 188, 4, 70, "ExampleText",
 CellID->686231876],
Cell[CellGroupData[{
Cell[117997, 3684, 221, 8, 70, "Input",
 CellID->408347985],
Cell[118221, 3694, 1338, 41, 70, "Output",
 CellID->550219791]
}, Open  ]],
Cell[119574, 3738, 280, 10, 70, "ExampleText",
 CellID->355492260],
Cell[CellGroupData[{
Cell[119879, 3752, 636, 19, 70, "Input",
 CellID->633394463],
Cell[120518, 3773, 1338, 41, 70, "Output",
 CellID->292896034]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[121917, 3821, 271, 8, 70, "ExampleSection",
 CellID->2123667759],
Cell[122191, 3831, 128, 3, 70, "Input",
 CellID->411256587],
Cell[122322, 3836, 170, 4, 70, "ExampleText",
 CellID->62975021],
Cell[CellGroupData[{
Cell[122517, 3844, 427, 13, 70, "Input",
 CellID->137509959],
Cell[122947, 3859, 939, 27, 70, "Output",
 CellID->137385330]
}, Open  ]],
Cell[CellGroupData[{
Cell[123923, 3891, 595, 17, 70, "Input",
 CellID->552143696],
Cell[124521, 3910, 1525, 47, 70, "Output",
 CellID->18610209]
}, Open  ]],
Cell[126061, 3960, 66, 1, 70, "ExampleText",
 CellID->692730961],
Cell[CellGroupData[{
Cell[126152, 3965, 133, 4, 70, "Input",
 CellID->411603585],
Cell[126288, 3971, 580, 15, 70, "Output",
 CellID->466095746]
}, Open  ]],
Cell[126883, 3989, 271, 9, 70, "ExampleText",
 CellID->232829114],
Cell[CellGroupData[{
Cell[127179, 4002, 343, 11, 70, "Input",
 CellID->28490051],
Cell[127525, 4015, 1292, 41, 70, "Output",
 CellID->361758417]
}, Open  ]],
Cell[128832, 4059, 291, 9, 70, "ExampleText",
 CellID->48554595],
Cell[CellGroupData[{
Cell[129148, 4072, 333, 11, 70, "Input",
 CellID->109464664],
Cell[129484, 4085, 925, 27, 70, "Output",
 CellID->296611083]
}, Open  ]],
Cell[130424, 4115, 371, 10, 70, "ExampleText",
 CellID->796288105],
Cell[CellGroupData[{
Cell[130820, 4129, 276, 9, 70, "Input",
 CellID->624418580],
Cell[131099, 4140, 2443, 75, 70, "Output",
 CellID->45843083]
}, Open  ]],
Cell[133557, 4218, 293, 9, 70, "ExampleText",
 CellID->107693193],
Cell[CellGroupData[{
Cell[133875, 4231, 348, 11, 70, "Input",
 CellID->1020165169],
Cell[134226, 4244, 2444, 75, 70, "Output",
 CellID->331660569]
}, Open  ]],
Cell[136685, 4322, 483, 15, 70, "ExampleText",
 CellID->301584982],
Cell[CellGroupData[{
Cell[137193, 4341, 188, 6, 70, "Input",
 CellID->10174850],
Cell[137384, 4349, 1291, 41, 70, "Output",
 CellID->21958955]
}, Open  ]],
Cell[138690, 4393, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[139543, 4417, 1929, 48, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[141475, 4467, 1232, 39, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[142744, 4511, 1936, 48, 70, "TutorialsSection",
 CellID->250839057],
Cell[144683, 4561, 804, 18, 70, "SectionHeaderSpacer"],
Cell[145490, 4581, 199, 5, 70, "Tutorials",
 CellID->341631938],
Cell[145692, 4588, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146533, 4611, 1937, 48, 70, "MoreAboutSection",
 CellID->38303248],
Cell[148473, 4661, 804, 18, 70, "SectionHeaderSpacer"],
Cell[149280, 4681, 179, 4, 70, "MoreAbout",
 CellID->3266805],
Cell[149462, 4687, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[150281, 4708, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

