(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    178148,       3792]
NotebookOptionsPosition[    170031,       3553]
NotebookOutlinePosition[    173132,       3618]
CellTagsIndexPosition[    173089,       3615]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Angular-momentum Probability Surfaces", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "Visualizing Polarization Moments and Quantum Beats", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Angular-momentum Probability Surfaces\"\>", 
       2->"\<\"Visualizing Polarization Moments and Quantum Beats\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/CollapseAndRevivalQuantumBeats", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
CollapseAndRevivalQuantumBeats", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/CollapseAndRevivalQuantumBeats.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
CollapseAndRevivalQuantumBeats", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/CollapseAndRevivalQuantumBeats\"\>\
", 2->"\<\"Copy Mathematica url\"\>", Delimiter, 4->"\<\"Copy web url\"\>", 
       5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Collapse and Revival Quantum Beats", "Title",
 CellID->20726601],

Cell[TextData[{
 "Quantum beats occur when there is a coherence established between \
nondegenerate energy eigenstates of an atom. For example, the linear Zeeman \
shifts induced in an isolated atomic state by a magnetic field cause Larmor \
precession of the atomic polarization, with a precession frequency given by \
the size of the Zeeman splitting (see \"",
 ButtonBox["Larmor ",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/Tutorials/\
VisualizingPolarizationMomentsAndQuantumBeats#381021112"],
 ButtonBox["Precession",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats#381021112"],
 "\"). When a ",
 StyleBox["non-",
  FontSlant->"Italic"],
 "isolated state is subject to a magnetic field, on the other hand, there can \
be, in addition to the linear Zeeman effect, nonlinear shifts induced due to \
mixing between the different states. For an atomic state with hyperfine \
structure, this is the Breit-Rabi splitting (see \"",
 ButtonBox["Hyperfine structure: Breit-Rabi Diagram",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/HyperfineStructureBreitRabiDiagram"],
 "\"). When the shifts are small relative to the hyperfine splitting, they \
are described by the linear Zeeman effect plus a small additional quadratic \
shift, resulting in a low-frequency quantum-beat evolution superimposed on \
the higher-frequency Larmor precession."
}], "Text",
 CellID->96107494],

Cell[TextData[{
 "We can model this effect in a single ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]]],
 " state (assumed to have a tensor polarizability) by applying an electric \
field proportional to the magnetic field to simulate the quadratic part of \
the Zeeman splitting. Here we find the evolution of atomic polarization that \
is initially stretched along ",
 Cell[BoxData[
  StyleBox["x", "InlineMath"]]],
 " and then evolves due to ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-directed magnetic and electric fields."
}], "Text",
 CellID->1155734],

Cell["This loads the package.", "MathCaption",
 CellID->21129096],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->195332175],

Cell["Load a graphics package.", "MathCaption",
 CellID->377888904],

Cell[BoxData[
 RowBox[{"<<", "Graphics`Arrow3D`"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3877354],

Cell["Set some graphics options.", "MathCaption",
 CellID->393873513],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"AMPSPlot", ",", 
    RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ColorData", "[", 
        RowBox[{"35", ",", "\"\<ColorList\>\""}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], "}"}]}], ",", 
    RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Speed\>\""}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
    RowBox[{"PlotRegion", "\[Rule]", 
     RowBox[{"Crop", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{".25", ",", ".83"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{".25", ",", ".83"}], "}"}]}], "}"}], "]"}]}], ",", 
    RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
    RowBox[{"Mesh", "\[Rule]", "False"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Axes3D", ",", 
    RowBox[{"Label", "\[Rule]", "None"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "Black"}], ",", 
    RowBox[{"RenderStyle", "\[Rule]", "Flat"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Plot", ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ";"}]}], "Input",
 CellLabel->"In[3]:=",
 CellID->123700731],

Cell[TextData[{
 "Define the atomic system, consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]]],
 " state."
}], "MathCaption",
 CellID->399507665],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->105219035],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "2"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "2"}], ",", 
     RowBox[{"L", "\[Rule]", "2"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "0", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"Polarizability", "[", "2", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "2"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{462, 135},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->93885606]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for the system subject to ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-directed electric and magnetic fields. The electric field is proportional \
to the magnetic field\[LongDash]the parameter ",
 Cell[BoxData[
  StyleBox["a", "InlineMath"]]],
 " represents the relative size of the quadratic term."
}], "MathCaption",
 CellID->37038723],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"H", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"MagneticField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]L", "/", "BohrMagneton"}]}], "}"}]}], ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{
         SqrtBox["a"], " ", "\[CapitalOmega]L"}]}], "}"}]}], ",", 
     RowBox[{"Interaction", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<MagneticDipole\>\"", ",", "\"\<Polarizability\>\""}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->264225266],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"2", " ", "\[CapitalOmega]L"}], "-", 
       FractionBox[
        RowBox[{"a", " ", 
         SuperscriptBox["\[CapitalOmega]L", "2"]}], "2"]}], "0", "0", "0", 
      "0"},
     {"0", 
      RowBox[{"\[CapitalOmega]L", "+", 
       FractionBox[
        RowBox[{"a", " ", 
         SuperscriptBox["\[CapitalOmega]L", "2"]}], "4"]}], "0", "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"a", " ", 
        SuperscriptBox["\[CapitalOmega]L", "2"]}], "2"], "0", "0"},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]L"}], "+", 
       FractionBox[
        RowBox[{"a", " ", 
         SuperscriptBox["\[CapitalOmega]L", "2"]}], "4"]}], "0"},
     {"0", "0", "0", "0", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[CapitalOmega]L"}], "-", 
       FractionBox[
        RowBox[{"a", " ", 
         SuperscriptBox["\[CapitalOmega]L", "2"]}], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{333, 137},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->23002527]
}, Open  ]],

Cell["The evolution equations.", "MathCaption",
 CellID->249540538],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqs", "=", 
  RowBox[{"LiouvilleEquation", "[", 
   RowBox[{"system", ",", "H"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->195232335],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{584, 722},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->468420774]
}, Open  ]],

Cell[TextData[{
 "An initial state, stretched along the ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 " direction."
}], "MathCaption",
 CellID->43062275],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"initialState", "=", 
   RowBox[{
    RowBox[{"DensityMatrix", "[", "system", "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["\[Rho]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}]}]], "[", "t", "]"}], "\[Rule]", 
       "1"}], ",", 
      RowBox[{
       RowBox[{
        SubscriptBox["\[Rho]", "__"], "[", "t", "]"}], "->", "0"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->255181142],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{91, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->43299816]
}, Open  ]],

Cell[TextData[{
 "Rotate the initial state so that it points along ",
 Cell[BoxData[
  StyleBox["x", "InlineMath"]]],
 "."
}], "MathCaption",
 CellID->421610236],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"initRot", "=", 
    RowBox[{"WignerRotate", "[", 
     RowBox[{"system", ",", "initialState", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"\[Pi]", "/", "2"}], ",", "0"}], "}"}]}], "]"}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->360004944],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "16"], 
      FractionBox["1", "8"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "16"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "4"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "4"], 
      FractionBox["1", "4"], 
      FractionBox["1", "8"]},
     {
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "8"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "4"], 
      FractionBox["3", "8"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "4"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "4"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "4"], 
      FractionBox["1", "4"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "16"], 
      FractionBox["1", "8"], 
      FractionBox[
       SqrtBox[
        FractionBox["3", "2"]], "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "16"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{201, 217},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->146761073]
}, Open  ]],

Cell[TextData[{
 "Create a set of initial conditions at ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"t", "=", "0"}], "InlineMath"]]],
 " corresponding to the rotated state."
}], "MathCaption",
 CellID->415932578],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"inits", "=", 
  RowBox[{"InitialConditions", "[", 
   RowBox[{"system", ",", "initRot", ",", "0"}], "]"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->131736850],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "16"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "16"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["3", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "16"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox[
     SqrtBox[
      FractionBox["3", "2"]], "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "2"}]}], "}"}]}]], "[", "0", "]"}], "\[Equal]", 
    FractionBox["1", "16"]}]}], "}"}]], "Output",
 ImageSize->{563, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->370983]
}, Open  ]],

Cell["Solve the system of differential equations.", "MathCaption",
 CellID->591125754],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"DSolve", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{"eqs", ",", "inits"}], "]"}], ",", 
     RowBox[{"DMVariables", "[", "system", "]"}], ",", "t"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellLabel->"In[10]:=",
 CellID->51000242],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{533, 428},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->149850549]
}, Open  ]],

Cell["The time-dependent density matrix.", "MathCaption",
 CellID->362130201],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"dm", "=", 
    RowBox[{
     RowBox[{"DensityMatrix", "[", "system", "]"}], "/.", "sol"}]}], ")"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->49102556],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{727, 207},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]//MatrixForm=",
 CellID->215593990]
}, Open  ]],

Cell[TextData[{
 "To examine the time-dependence of the atomic polarization, we plot the ",
 Cell[BoxData[
  StyleBox["x", "InlineMath"]]],
 "-component of the atomic orientation (the rank-1 polarization moment)."
}], "Text",
 CellID->570828056],

Cell[TextData[{
 "Extract ",
 "the ",
 Cell[BoxData[
  StyleBox["x", "InlineMath"]]],
 "-component of the atomic orientation",
 " from the solution for the density matrix."
}], "MathCaption",
 CellID->472741309],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"orientation", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Component", "[", 
     RowBox[{
      RowBox[{"ToCartesian", "@", 
       RowBox[{"Component", "[", 
        RowBox[{
         RowBox[{"Decomposition", "[", "dm", "]"}], ",", "1"}], "]"}]}], ",", 
      "1"}], "]"}], "//", "ComplexExpand"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellLabel->"In[12]:=",
 CellID->429868938],

Cell[BoxData[
 RowBox[{
  SqrtBox[
   FractionBox["2", "5"]], " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"t", " ", "\[CapitalOmega]L"}], "]"}], " ", 
  SuperscriptBox[
   RowBox[{"Cos", "[", 
    RowBox[{
     FractionBox["1", "4"], " ", "a", " ", "t", " ", 
     SuperscriptBox["\[CapitalOmega]L", "2"]}], "]"}], "3"]}]], "Output",
 ImageSize->{194, 39},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->405823540]
}, Open  ]],

Cell[TextData[{
 "We can see that this component of the atomic polarization is proportional \
to the expectation value of ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", "x"], "InlineMath"]], "InlineFormula"],
 "."
}], "Text",
 CellID->18906293],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", "x"], "InlineMath"]], "InlineFormula"],
 " operator."
}], "MathCaption",
 CellID->365939695],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"jx", "=", 
    RowBox[{"Component", "[", 
     RowBox[{
      RowBox[{"ToCartesian", "@", 
       RowBox[{"WignerEckart", "[", 
        RowBox[{"system", ",", 
         RowBox[{"{", 
          RowBox[{"J", ",", "1"}], "}"}]}], "]"}]}], ",", "1"}], "]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->430008224],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1", "0", "0", "0"},
     {"1", "0", 
      SqrtBox[
       FractionBox["3", "2"]], "0", "0"},
     {"0", 
      SqrtBox[
       FractionBox["3", "2"]], "0", 
      SqrtBox[
       FractionBox["3", "2"]], "0"},
     {"0", "0", 
      SqrtBox[
       FractionBox["3", "2"]], "0", "1"},
     {"0", "0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{157, 153},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]//MatrixForm=",
 CellID->239111665]
}, Open  ]],

Cell[TextData[{
 "The expectation value of ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", "x"], "InlineMath"]], "InlineFormula"],
 ", proportional to the above expression for the ",
 Cell[BoxData[
  StyleBox["x", "InlineMath"]]],
 "-component of orientation."
}], "MathCaption",
 CellID->573274344],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Tr", "[", 
    RowBox[{"jx", ".", "dm"}], "]"}], "//", "ComplexExpand"}], "//", 
  "FullSimplify"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->503316507],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"t", " ", "\[CapitalOmega]L"}], "]"}], " ", 
  SuperscriptBox[
   RowBox[{"Cos", "[", 
    RowBox[{
     FractionBox["1", "4"], " ", "a", " ", "t", " ", 
     SuperscriptBox["\[CapitalOmega]L", "2"]}], "]"}], "3"]}]], "Output",
 ImageSize->{171, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->628313806]
}, Open  ]],

Cell["\<\
Plot as a function of time for particular values of the linear and quadratic \
splittings.\
\>", "MathCaption",
 CellID->26842024],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"orientation", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[CapitalOmega]L", "\[Rule]", "1"}], ",", 
      RowBox[{"a", "\[Rule]", ".1"}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", 
     RowBox[{"40", " ", "2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->485356648],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 111},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[15]=",
 CellID->396312025]
}, Open  ]],

Cell["\<\
The fast oscillation represents the Larmor precession. The amplitude of the \
fast oscillation is modulated at a slower frequency, determined by the value \
of the quadratic splitting. Since the quantum beats seem to disappear and \
then reappear, this phenomenon is known as \"collapse and revival\".\
\>", "Text",
 CellID->390017566],

Cell[TextData[{
 "We can plot the complete polarization state using angular-momentum \
probability surfaces (see \"",
 ButtonBox["Angular-momentum Probability Surfaces",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces"],
 "\"). We first plot the evolution over the shortest time scale\[LongDash]a \
period of the fast evolution."
}], "Text",
 CellID->521058742],

Cell["\<\
A series of frames showing a complete cycle of the fast evolution of the \
atomic polarization.\
\>", "MathCaption",
 CellID->662313930],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Axes3D", "[", 
        RowBox[{
         RowBox[{"AMPSPlot", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DensityMatrix", "[", "system", "]"}], "/.", "sol"}], "/.",
             
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\[CapitalOmega]L", "\[Rule]", "1"}], ",", 
              RowBox[{"a", "\[Rule]", ".1"}]}], "}"}]}], "]"}], "]"}], ",", 
         "1.25"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"2", 
          RowBox[{"\[Pi]", "/", "8"}]}]}], "}"}]}], "]"}], ",", "3"}], "]"}], 
   ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
   RowBox[{"Spacings", "\[Rule]", 
    RowBox[{"-", "40"}]}]}], "]"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->56815398],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{360, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[16]=",
 CellID->19972902]
}, Open  ]],

Cell[TextData[{
 "We se that the atomic polarization, initially oriented (\"pointing\") along \
",
 Cell[BoxData[
  FormBox["x", TraditionalForm]], "InlineMath"],
 ", undergoes Larmor precession about the ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]], "InlineMath"],
 "-axis. This corresponds to the fast oscillation in the plot above."
}], "Text",
 CellID->455565396],

Cell["\<\
We now plot the evolution over the longest time scale\[LongDash]a complete \
period of the slow evolution.\
\>", "Text",
 CellID->111314128],

Cell["\<\
A series of frames showing a complete cycle of the slow evolution of the \
atomic polarization.\
\>", "MathCaption",
 CellID->172571707],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Axes3D", "[", 
        RowBox[{
         RowBox[{"AMPSPlot", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DensityMatrix", "[", "system", "]"}], "/.", "sol"}], "/.",
             
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\[CapitalOmega]L", "\[Rule]", "1"}], ",", 
              RowBox[{"a", "\[Rule]", ".1"}]}], "}"}]}], "]"}], "]"}], ",", 
         "1.25"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", 
         RowBox[{"2", "\[Pi]", " ", "40"}], ",", 
         RowBox[{"2", "\[Pi]", " ", "5"}]}], "}"}]}], "]"}], ",", "3"}], 
    "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
   RowBox[{"Spacings", "\[Rule]", 
    RowBox[{"-", "40"}]}]}], "]"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->321949639],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{360, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->397044575]
}, Open  ]],

Cell[TextData[{
 "This series of frames corresponds to the entire range of the orientation \
plot above. The first frame is the same as in the previous series: atomic \
polarization initially oriented along ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["x", "InlineMath"], "^"]]],
 ". In the third frame, the orientation is gone: the polarization points \
equally along the ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["x", "InlineMath"], "^"]]],
 " and ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"-", 
    OverscriptBox[
     StyleBox["x", "InlineMath"], "^"]}], "TI"]]],
 " directions, a characteristic of atomic ",
 StyleBox["alignment",
  FontSlant->"Italic"],
 ", the rank-2 polarization moment. The orientation subsequently reappears, \
pointing along ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"-", 
    OverscriptBox[
     StyleBox["x", "InlineMath"], "^"]}], "TI"]]],
 ", and disappears again before the polarization returns to its initial \
state. This evolution is responsible for the slow modulation in the \
orientation plot. (In fact, a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "2"}], "InlineMath"]]],
 " system can support polarization moments up to rank 4, and these \
higher-order moments are also present. The evolution shown here corresponds \
to the disappearance and reappearance of the odd-order moments.)"
}], "Text",
 CellID->526600981],

Cell[TextData[{
 "We can make an animation from these plots showing both the fast and slow \
evolution. Many frames are required, so rather than assembling the animation \
inside the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notebook, it is more convenient to export the frames individually as \
images and join them with a video editor. ",
 ButtonBox["Here is a link",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://socrates.berkeley.edu/~budker/ADM/NLZ.mov"], None}],
 " to the exported animation on the ",
 ButtonBox["AtomicDensityMatrix website",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://socrates.berkeley.edu/~budker/ADM/"], None}],
 ". We see the polarization undergo fast Larmor precession about the ",
 Cell[BoxData[
  StyleBox["z", "InlineMath"]]],
 "-axis, as well as a more gradual change in shape of the surface, \
corresponding to the quadratic quantum beats. Initially the surface displays \
a preferred direction (orientation). At an intermediate stage, the \
orientation has disappeared, and the atomic polarization contains only \
even-order moments (there is a preferred axis, but no preferred direction). \
This represents a collapse, from the point of view of the Larmor precession \
of orientation. The orientation subsequently reappears; this is the revival."
}], "Text",
 CellID->308446489],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Angular-momentum Probability Surfaces",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces"]], \
"RelatedTutorials",
 CellID->806871991],

Cell[TextData[ButtonBox["Visualizing Polarization Moments and Quantum Beats",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"]], "RelatedTutorials",
 CellID->563144912],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Collapse and Revival Quantum Beats - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 28.8505611}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Quantum beats occur when there is a coherence established between \
nondegenerate energy eigenstates of an atom. For example, the linear Zeeman \
shifts induced in an isolated atomic state by a magnetic field cause Larmor \
precession of the atomic polarization, with a precession frequency given by \
the size of the Zeeman splitting (see \"Larmor Precession\"). When a \
non-isolated state is subject to a magnetic field, on the other hand, there \
can be, in addition to the linear Zeeman effect, nonlinear shifts induced due \
to mixing between the different states. For an atomic state with hyperfine \
structure, this is the Breit-Rabi splitting (see \"Hyperfine structure: \
Breit-Rabi Diagram\"). When the shifts are small relative to the hyperfine \
splitting, they are described by the linear Zeeman effect plus a small \
additional quadratic shift, resulting in a low-frequency quantum-beat \
evolution superimposed on the higher-frequency Larmor precession. We can \
model this effect in a single J=2 state (assumed to have a tensor \
polarizability) by applying an electric field proportional to the magnetic \
field to simulate the quadratic part of the Zeeman splitting. Here we find \
the evolution of atomic polarization that is initially stretched along x and \
then evolves due to z-directed magnetic and electric fields. This loads the \
package.", "synonyms" -> {}, "title" -> "Collapse and Revival Quantum Beats", 
    "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/CollapseAndRevivalQuantumBeats"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9695, 199, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10592, 234, 70, 1, 70, "Title",
 CellID->20726601],
Cell[10665, 237, 1502, 32, 70, "Text",
 CellID->96107494],
Cell[12170, 271, 593, 16, 70, "Text",
 CellID->1155734],
Cell[12766, 289, 65, 1, 70, "MathCaption",
 CellID->21129096],
Cell[12834, 292, 107, 3, 70, "Input",
 CellID->195332175],
Cell[12944, 297, 67, 1, 70, "MathCaption",
 CellID->377888904],
Cell[13014, 300, 102, 3, 70, "Input",
 CellID->3877354],
Cell[13119, 305, 69, 1, 70, "MathCaption",
 CellID->393873513],
Cell[13191, 308, 1470, 39, 70, "Input",
 CellID->123700731],
Cell[14664, 349, 184, 7, 70, "MathCaption",
 CellID->399507665],
Cell[CellGroupData[{
Cell[14873, 360, 534, 15, 70, "Input",
 CellID->105219035],
Cell[15410, 377, 2493, 64, 70, "Output",
 CellID->93885606]
}, Open  ]],
Cell[17918, 444, 380, 10, 70, "MathCaption",
 CellID->37038723],
Cell[CellGroupData[{
Cell[18323, 458, 701, 19, 70, "Input",
 CellID->264225266],
Cell[19027, 479, 1634, 49, 70, "Output",
 CellID->23002527]
}, Open  ]],
Cell[20676, 531, 67, 1, 70, "MathCaption",
 CellID->249540538],
Cell[CellGroupData[{
Cell[20768, 536, 167, 5, 70, "Input",
 CellID->195232335],
Cell[20938, 543, 24922, 413, 70, "Output",
 Evaluatable->False,
 CellID->468420774]
}, Open  ]],
Cell[45875, 959, 159, 6, 70, "MathCaption",
 CellID->43062275],
Cell[CellGroupData[{
Cell[46059, 969, 627, 21, 70, "Input",
 CellID->255181142],
Cell[46689, 992, 852, 25, 70, "Output",
 CellID->43299816]
}, Open  ]],
Cell[47556, 1020, 161, 6, 70, "MathCaption",
 CellID->421610236],
Cell[CellGroupData[{
Cell[47742, 1030, 349, 11, 70, "Input",
 CellID->360004944],
Cell[48094, 1043, 1836, 66, 70, "Output",
 CellID->146761073]
}, Open  ]],
Cell[49945, 1112, 209, 7, 70, "MathCaption",
 CellID->415932578],
Cell[CellGroupData[{
Cell[50179, 1123, 185, 5, 70, "Input",
 CellID->131736850],
Cell[50367, 1130, 7631, 268, 70, "Output",
 CellID->370983]
}, Open  ]],
Cell[58013, 1401, 86, 1, 70, "MathCaption",
 CellID->591125754],
Cell[CellGroupData[{
Cell[58124, 1406, 328, 10, 70, "Input",
 CellID->51000242],
Cell[58455, 1418, 12788, 214, 70, "Output",
 Evaluatable->False,
 CellID->149850549]
}, Open  ]],
Cell[71258, 1635, 77, 1, 70, "MathCaption",
 CellID->362130201],
Cell[CellGroupData[{
Cell[71360, 1640, 229, 8, 70, "Input",
 CellID->49102556],
Cell[71592, 1650, 8526, 144, 70, "Output",
 Evaluatable->False,
 CellID->215593990]
}, Open  ]],
Cell[80133, 1797, 245, 6, 70, "Text",
 CellID->570828056],
Cell[80381, 1805, 211, 8, 70, "MathCaption",
 CellID->472741309],
Cell[CellGroupData[{
Cell[80617, 1817, 405, 13, 70, "Input",
 CellID->429868938],
Cell[81025, 1832, 461, 15, 70, "Output",
 CellID->405823540]
}, Open  ]],
Cell[81501, 1850, 248, 8, 70, "Text",
 CellID->18906293],
Cell[81752, 1860, 165, 7, 70, "MathCaption",
 CellID->365939695],
Cell[CellGroupData[{
Cell[81942, 1871, 395, 13, 70, "Input",
 CellID->430008224],
Cell[82340, 1886, 1024, 33, 70, "Output",
 CellID->239111665]
}, Open  ]],
Cell[83379, 1922, 302, 10, 70, "MathCaption",
 CellID->573274344],
Cell[CellGroupData[{
Cell[83706, 1936, 201, 7, 70, "Input",
 CellID->503316507],
Cell[83910, 1945, 427, 13, 70, "Output",
 CellID->628313806]
}, Open  ]],
Cell[84352, 1961, 140, 4, 70, "MathCaption",
 CellID->26842024],
Cell[CellGroupData[{
Cell[84517, 1969, 387, 12, 70, "Input",
 CellID->485356648],
Cell[84907, 1983, 8144, 138, 70, "Output",
 Evaluatable->False,
 CellID->396312025]
}, Open  ]],
Cell[93066, 2124, 345, 6, 70, "Text",
 CellID->390017566],
Cell[93414, 2132, 424, 10, 70, "Text",
 CellID->521058742],
Cell[93841, 2144, 146, 4, 70, "MathCaption",
 CellID->662313930],
Cell[CellGroupData[{
Cell[94012, 2152, 1004, 30, 70, "Input",
 CellID->56815398],
Cell[95019, 2184, 36178, 597, 70, "Output",
 Evaluatable->False,
 CellID->19972902]
}, Open  ]],
Cell[131212, 2784, 373, 10, 70, "Text",
 CellID->455565396],
Cell[131588, 2796, 150, 4, 70, "Text",
 CellID->111314128],
Cell[131741, 2802, 146, 4, 70, "MathCaption",
 CellID->172571707],
Cell[CellGroupData[{
Cell[131912, 2810, 996, 29, 70, "Input",
 CellID->321949639],
Cell[132911, 2841, 28147, 465, 70, "Output",
 Evaluatable->False,
 CellID->397044575]
}, Open  ]],
Cell[161073, 3309, 1369, 38, 70, "Text",
 CellID->526600981],
Cell[162445, 3349, 1354, 28, 70, "Text",
 CellID->308446489],
Cell[CellGroupData[{
Cell[163824, 3381, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[164934, 3413, 804, 18, 70, "SectionHeaderSpacer"],
Cell[165741, 3433, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[165936, 3440, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166777, 3463, 1120, 30, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[167900, 3495, 804, 18, 70, "SectionHeaderSpacer"],
Cell[168707, 3515, 218, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[168928, 3522, 242, 5, 70, "RelatedTutorials",
 CellID->563144912],
Cell[169173, 3529, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[170004, 3551, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

