(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     31785,        866]
NotebookOptionsPosition[     27588,        737]
NotebookOutlinePosition[     29509,        786]
CellTagsIndexPosition[     29466,        783]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "DensityMatrix", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/DensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "DMVariables", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/DMVariables", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"DensityMatrix\"\>", 2->"\<\"DMVariables\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Displaying the Density Matrix", "Title",
 CellID->471728094],

Cell[TextData[{
 "When an atomic system has been specified, its corresponding symbolic \
density matrix can be formed. This is done with the ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 " function."
}], "Text",
 CellID->97203088],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["DensityMatrix",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"], "[", 
     StyleBox["sys", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "form", " ", "the", " ", "density", " ", "matrix", " ", "for", " ", "an",
       " ", "atomic", " ", "system"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["DMVariables",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/DMVariables"], "[", 
     StyleBox["sys", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "form", " ", "the", " ", "list", " ", "of", " ", "variables", " ", 
      "representing", " ", "density", " ", "matrix", " ", "elements"}], 
     "TableText"]}
  }]], "DefinitionBox",
 CellID->167132553],

Cell["Forming the density matrix.", "Caption",
 CellID->494650522],

Cell["This loads the package.", "MathCaption",
 CellID->23442507],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->531984176],

Cell[TextData[{
 "Density matrix elements for systems that neglect angular momentum are \
labeled with the ",
 Cell[BoxData[
  ButtonBox["StateLabel",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Label"]], "InlineFormula"],
 " ",
 "for each state as a subscript."
}], "Text",
 CellID->121057749],

Cell["A two-level atomic system.", "MathCaption",
 CellID->197743091],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", "1", "]"}], ",", 
    RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->439981477],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", "1", "]"}], ",", 
   RowBox[{"AtomicState", "[", "2", "]"}]}], "}"}]], "Output",
 ImageSize->{226, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->767047339]
}, Open  ]],

Cell["The density matrix for this system.", "MathCaption",
 CellID->62939615],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->342482749],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "2"}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{120, 29},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->308842805]
}, Open  ]],

Cell[TextData[{
 "Density matrix elements for systems with Zeeman structure are additionally \
labeled with the ",
 Cell[BoxData[
  ButtonBox["M",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/M"]], "InlineFormula"],
 " quantum number for each state in the subscript."
}], "Text",
 CellID->306095361],

Cell[TextData[{
 "An atomic system consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " state and a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "0"}], "InlineMath"]]],
 " state."
}], "MathCaption",
 CellID->209898232],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->88315689],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{398, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->811329576]
}, Open  ]],

Cell["The density matrix for this system.", "MathCaption",
 CellID->340131566],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->107473352],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztXb1vGzcUp3X6tFXIAVIgU6sCLZAOLTqmGpIUaNMWaNEM7V4jqOAMRYM0
gzd381LAtzQe/Sd4O48ePXr0oMGjR48er8fjx5ESJZFHHo+kzqguEkU+vvfj
4xPJ+/Xdz3vv9v/4c+/d61d74+/f7r3Zf/3q7/GLv95mRdEWAFv/AQC+GQP4
Ps3e4kua/Ze+hxcAPsz/icAsngAwicEs+zTCZWk6A6h4BgaS9b50SN5DC/p9
xsOYxKgq/NTFZfFkChJc1mNFxEn+qSWoF2nI+6LRBQwd0kUk71PkNh301e+n
p6f5O/hqU8+LqYgu/obtKvPMCE7nrBg6IixKprlTUsWmAP1l/ttaYRRuxhjV
4XpKZzHI3D2rj7qbJinbHRLTp9XIH6mGu2xT69DsydqCeJYOSDFpjSbbrm8o
yHYXhQ1DL1RnMN2Tmh9sozb/HB4e0kCBJJB48fj6+vqH8/NzPGS4QhJDoQxg
XX4w0wRM0fAgaR+gHzxQRK9ckWmCrZ5ScbneUySK2Me2FUXHFo6HbHTEaM61
W6zD9hcJ8BwK+hu5DMODlTDI9hkEFNvroUBqoaDToXMOvkhTbpL5ik4l3cmi
gNe8cDXy1dXVlSDI7J+cnFDgOwSmTIU4wZoWIYs1kkR/Ljhm1Qox2TUrJONK
2tAxZb7rrpArWnaxZSJ5ouBMfp5oEM/VnbUFoI3cRkFVbthoDAVlm4GCjlxN
NHBY6d/f3x8dHBywYSUqvqKhpUtnLwRuLtJN+ADKdkOjXAY4aYPU6QstpVEy
TgYCcaIdXw8rKFybkEWtaJnXpdqzYT3TQvSbOHIXgI6cuPCBGG6SJ2iIMwQE
3v4cHB0dwVjBDAuS1npyeXm5/NxmyC3s4GthR4uXUNgc6ueMisl0wq+uCFg9
oTTiGWSfOle+fEu4pIxRsitAaOSw8WtFLfcSXw3fCXvU+4ak6Qw8jgnwzAOe
fSzEBLRbeXR7ewtIFM33V9O5iJ2v0VJyiEnWSaSXYn2TNyOLE7QNywNWYc8E
fab+IRSFeu+xdbh9biFHB5xdJ61dJScca4eBja0RUQZmOnfCyc907lyUzHR2
acLEn68NQG9f9FM3tcZDAxdl9CbWiqHp59d24Slo1zgRaMBuRMkfOv6LGAcT
r38f1NrNMz+tQUsW/ohva/lQvtDwml802v5aU787AgzWwiN7e+elUu3fKpQ9
VDMzv/672W3IoeI66okspeRzh+SJ6pnW7+NycJehgJimcTxudBHKcwmXj9Tc
i3S1yDWoggfBHs9XT8FBu3JFzoFfSLBi8Epp5f2LgKGQ7M1PpzBNx1Hzh0G5
mLJIL7DKhrBN0xHt+VfwDvyCxwx9J2iIKlMjGNQqofvIotMvE8RKkRrKUDBM
03xEt1mUSQzOWa9K5QgTBVl54VivQ+fRRKFU2FDnMJRgXRii8XQE+LDBT5Kz
MHDPcEn6TrgArBEThuHFbkOZrmMIgFIhQnQKtCPFYihBuujjITLE3NG5uzlw
2fq1DI7lHuOt5QrivBx3U+QdnaFXjBBtLGgl5UGflWGKuaODzLZ7pq7idQRi
qowcb0w1QtipYXYv4ac8M4C7fdHfuqm14tCQmwNz3JPnAg30uSd1dfOdn9Yo
DuWPGl7jI2GnFDz+EXYUb0XlV0eJNLbaEBKKCzlqfMx580k5uMuQN0yTQVzK
AdPkxhHLG6u5V3FMrsVI4E7WcXhVyxDictIcl6GQ7S7aACwsp8+xDEW9OXQU
qc0krsiRB8zQQWwzdEQn72r5UVzBwpVsOq7g4XBKnTogqoRoIwuF4v86QhIP
adIMNjevjg0U/MmrYwMN9/PqVIWCDhFHE41SYcUMK0GSSBJGXh0LAPiRV8cC
EG7n1TEMAF0/1JZXp1QIEe321CgLktwSL9Lr1Gx5Tbl1arO69sQ6FVruQlYd
xYgglVVHn2XiTUodu6bWmk/HjqlOJNMxZWrtmXRKzu4mk071WisOTZNJx11r
SqWKKec1PhJzmkw6IjPzq6OEGVttGmJOQ8zZYF0aYg4oz5RhD+QD5eXYRYK7
w4FtcYaWYxcKl1k52kg4Qcp5c3x8rBJT5FgF+gSZMAg5tnFwmYxjGwvPiDhV
wuMCCYd71CYfaGDm2927uzsGIW2qgSxZJkzyjWnr/STdmEbBL7KNCetrJNng
fIfjm5ubl2dnZ4xIoh1MSU8fl2eSZLOGFRMuucaQ4f6SagwB4B+ZpoTh9Pe/
7odTPb+4uFjyIBq4qqDRwyyJpo5sN6Ill+zhv1lihe1sN+6QaerIduPluLtA
qsERAh5yzD++DovlnrpB9h4GOAmmUsB4QL8wZaoHpBpdUz0i1aw3tXZSDZ7d
3DklO7tbcHfQUGnsaZ37RQsuuNCwklxGgiDbEGhctGYgGK+IG8pH5LGO8KWT
aslHAs1AgAGG5yc8QL6RZVA0QKSR9+g92PofnypFbQ==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{405, 65},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->826100853]
}, Open  ]],

Cell[TextData[{
 "Density matrix elements for systems with hyperfine and Zeeman structure \
have the ",
 Cell[BoxData[
  ButtonBox["StateLabel",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Label"]], "InlineFormula"],
 " and the ",
 Cell[BoxData[
  ButtonBox["F",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/F"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["M",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/M"]], "InlineFormula"],
 " quantum numbers for each state in the subscript."
}], "Text",
 CellID->755714195],

Cell[TextData[{
 "An atomic system consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", 
    RowBox[{"1", "/", "2"}]}], "InlineMath"]]],
 " state in an atom with nuclear spin ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"I", "=", 
    RowBox[{"1", "/", "2"}]}], "InlineMath"]]],
 "."
}], "MathCaption",
 CellID->714035101],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"NuclearSpin", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}]}], "]"}], "}"}]}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->434083352],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"NuclearSpin", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"F", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{367, 120},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->76460204]
}, Open  ]],

Cell["The density matrix for this system.", "MathCaption",
 CellID->246945590],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "sys", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->139923646],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{485, 65},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->451289833]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Displaying the Density Matrix - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 37.4360521}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "When an atomic system has been specified, its corresponding symbolic \
density matrix can be formed. This is done with the DensityMatrix function. \
Forming the density matrix. This loads the package.", "synonyms" -> {}, 
    "title" -> "Displaying the Density Matrix", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/DisplayingTheDensityMatrix"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9471, 194, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10368, 229, 66, 1, 70, "Title",
 CellID->471728094],
Cell[10437, 232, 340, 10, 70, "Text",
 CellID->97203088],
Cell[10780, 244, 784, 23, 70, "DefinitionBox",
 CellID->167132553],
Cell[11567, 269, 66, 1, 70, "Caption",
 CellID->494650522],
Cell[11636, 272, 65, 1, 70, "MathCaption",
 CellID->23442507],
Cell[11704, 275, 107, 3, 70, "Input",
 CellID->531984176],
Cell[11814, 280, 319, 10, 70, "Text",
 CellID->121057749],
Cell[12136, 292, 69, 1, 70, "MathCaption",
 CellID->197743091],
Cell[CellGroupData[{
Cell[12230, 297, 221, 7, 70, "Input",
 CellID->439981477],
Cell[12454, 306, 282, 9, 70, "Output",
 CellID->767047339]
}, Open  ]],
Cell[12751, 318, 77, 1, 70, "MathCaption",
 CellID->62939615],
Cell[CellGroupData[{
Cell[12853, 323, 144, 4, 70, "Input",
 CellID->342482749],
Cell[13000, 329, 1100, 34, 70, "Output",
 CellID->308842805]
}, Open  ]],
Cell[14115, 366, 323, 9, 70, "Text",
 CellID->306095361],
Cell[14441, 377, 265, 11, 70, "MathCaption",
 CellID->209898232],
Cell[CellGroupData[{
Cell[14731, 392, 377, 12, 70, "Input",
 CellID->88315689],
Cell[15111, 406, 798, 24, 70, "Output",
 CellID->811329576]
}, Open  ]],
Cell[15924, 433, 78, 1, 70, "MathCaption",
 CellID->340131566],
Cell[CellGroupData[{
Cell[16027, 438, 144, 4, 70, "Input",
 CellID->107473352],
Cell[16174, 444, 2708, 48, 70, "Output",
 Evaluatable->False,
 CellID->826100853]
}, Open  ]],
Cell[18897, 495, 600, 19, 70, "Text",
 CellID->755714195],
Cell[19500, 516, 332, 13, 70, "MathCaption",
 CellID->714035101],
Cell[CellGroupData[{
Cell[19857, 533, 357, 11, 70, "Input",
 CellID->434083352],
Cell[20217, 546, 1374, 40, 70, "Output",
 CellID->76460204]
}, Open  ]],
Cell[21606, 589, 78, 1, 70, "MathCaption",
 CellID->246945590],
Cell[CellGroupData[{
Cell[21709, 594, 144, 4, 70, "Input",
 CellID->139923646],
Cell[21856, 600, 2725, 49, 70, "Output",
 Evaluatable->False,
 CellID->451289833]
}, Open  ]],
Cell[CellGroupData[{
Cell[24618, 654, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[25728, 686, 804, 18, 70, "SectionHeaderSpacer"],
Cell[26535, 706, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[26730, 713, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[27561, 735, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

