(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     46748,       1296]
NotebookOptionsPosition[     41651,       1135]
NotebookOutlinePosition[     43738,       1188]
CellTagsIndexPosition[     43695,       1185]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/TheDensityMatrixAndTheLiouvilleEquation.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["The Density Matrix and the Liouville Equation", "Title",
 CellID->509267359],

Cell[TextData[{
 "The density matrix is a generalization of the state vector that allows \
graceful handling of ensemble averages and relaxation effects. For a single \
atom with state vector ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", "\[Psi]"}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineMath"],
 ", we define the ",
 StyleBox["density operator",
  FontSlant->"Italic"],
 " by ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]", "=", 
      RowBox[{"|", "\[Psi]"}]}], "\[RightAngleBracket]"}], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[Psi]", "|"}]}]}], TraditionalForm]], "InlineMath"],
 "."
}], "Text",
 CellID->60640988],

Cell["Load the package.", "MathCaption",
 CellID->106720500],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->27959808],

Cell["Define an atomic system and form its ket vector.", "MathCaption",
 CellID->200065976],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"2", ",", 
      RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], 
   "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->484360868],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Energy", "\[Rule]", "\[CapitalDelta]"}]}], "]"}]}], 
  "}"}]], "Output",
 ImageSize->{378, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->556262954]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"ket", "=", 
   RowBox[{"Ket", "[", 
    RowBox[{"system", ",", "c"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->67883978],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["c", "1"], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["c", "2"], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{58, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->210018019]
}, Open  ]],

Cell["\<\
This finds the density matrix in terms of the state vector coefficients.\
\>", "MathCaption",
 CellID->339934743],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ket", "\[CenterDot]", 
   SuperscriptBox["ket", "\[Dagger]"]}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->62312969],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"Conjugate", "[", 
        RowBox[{
         SubscriptBox["c", "1"], "[", "t", "]"}], "]"}], " ", 
       RowBox[{
        SubscriptBox["c", "1"], "[", "t", "]"}]}], 
      RowBox[{
       RowBox[{"Conjugate", "[", 
        RowBox[{
         SubscriptBox["c", "2"], "[", "t", "]"}], "]"}], " ", 
       RowBox[{
        SubscriptBox["c", "1"], "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"Conjugate", "[", 
        RowBox[{
         SubscriptBox["c", "1"], "[", "t", "]"}], "]"}], " ", 
       RowBox[{
        SubscriptBox["c", "2"], "[", "t", "]"}]}], 
      RowBox[{
       RowBox[{"Conjugate", "[", 
        RowBox[{
         SubscriptBox["c", "2"], "[", "t", "]"}], "]"}], " ", 
       RowBox[{
        SubscriptBox["c", "2"], "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{326, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->110884756]
}, Open  ]],

Cell[TextData[{
 "Evidently, the diagonal matrix elements of the density operator are the \
probabilities of the corresponding states (here the states 1 and 2). The \
off-diagonal matrix elements are known as ",
 StyleBox["coherences",
  FontSlant->"Italic"],
 ". "
}], "Text",
 CellID->210105707],

Cell[TextData[{
 "We can retrace the example given in ",
 ButtonBox["\"The State Vector and the Schr\[ODoubleDot]dinger Equation\"",
  BaseStyle->"Link",
  ButtonData->
   "paclet:AtomicDensityMatrix/tutorial/\
TheStateVectorAndTheSchrodingerEquation"],
 " in terms of the density-matrix elements rather than the state-vector \
amplitudes. The Liouville equation governing the evolution of the density \
matrix can be found from the Schr\[ODoubleDot]dinger equation: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{"\[PartialD]", "\[Rho]"}], 
     RowBox[{"\[PartialD]", "t"}],
     MultilineFunction->None], "=", 
    RowBox[{"-", 
     RowBox[{"i", "[", 
      RowBox[{"H", ",", "\[Rho]"}], "]"}]}]}], TraditionalForm]], 
  "InlineMath"],
 "."
}], "Text",
 CellID->25365813],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 " forms the density matrix for an atomic system."
}], "MathCaption",
 CellID->60827562],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "system", "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->203218259],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "2"}]], "[", "t", "]"}]},
     {
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "1"}]], "[", "t", "]"}], 
      RowBox[{
       SubscriptBox["\[Rho]", 
        RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{120, 29},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->21091601]
}, Open  ]],

Cell["\<\
The Hamiltonian describing the interaction with an electric field. We \
normalize the electric field to frequency units by dividing by the reduced \
dipole matrix element between states 1 and 2.\
\>", "MathCaption",
 CellID->265025652],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"H", "=", 
   RowBox[{"Hamiltonian", "[", 
    RowBox[{"system", ",", 
     RowBox[{"ElectricField", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"\[CapitalOmega]", "/", 
         RowBox[{"ReducedME", "[", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
       "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->90461799],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[CapitalOmega]"}]},
     {
      RowBox[{"-", "\[CapitalOmega]"}], "\[CapitalDelta]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{62, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->2859802]
}, Open  ]],

Cell["The Liouville equation.", "MathCaption",
 CellID->886331892],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"eq", "=", 
    RowBox[{"LiouvilleEquation", "[", 
     RowBox[{"system", ",", "H"}], "]"}]}], ")"}], "//", 
  "TableForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->484620359],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{290, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//TableForm=",
 CellID->269271340]
}, Open  ]],

Cell["Initial conditions.", "MathCaption",
 CellID->639160661],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"init", "=", 
  RowBox[{"InitialConditions", "[", 
   RowBox[{"system", ",", 
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0"},
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], ",", 
    "0"}], "]"}]}]], "Input",
 CellLabel->"In[8]:=",
 CellID->236712826],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "1"}]], "[", "0", "]"}], "\[Equal]", "1"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "2"}]], "[", "0", "]"}], "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "1"}]], "[", "0", "]"}], "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "2"}]], "[", "0", "]"}], "\[Equal]", "0"}]}], 
  "}"}]], "Output",
 ImageSize->{322, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->836022128]
}, Open  ]],

Cell["List of the density-matrix variables.", "MathCaption",
 CellID->19810966],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vars", "=", 
  RowBox[{"DMVariables", "[", "system", "]"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->276951613],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"1", ",", "2"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "1"}]], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}], "}"}]], "Output",
 ImageSize->{226, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->636756750]
}, Open  ]],

Cell["Solve the Liouville equation.", "MathCaption",
 CellID->33833520],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"DSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"eq", ",", "init"}], "}"}], ",", "vars", ",", "t"}], "]"}], 
    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellLabel->"In[10]:=",
 CellID->924046702],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "1"}]], "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[CapitalDelta]", "2"], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"], " ", 
       RowBox[{"Cosh", "[", 
        RowBox[{"t", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}]}], 
     RowBox[{
      SuperscriptBox["\[CapitalDelta]", "2"], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "2"}]], "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"\[CapitalOmega]", " ", 
      RowBox[{"(", 
       RowBox[{"\[CapitalDelta]", "-", 
        RowBox[{"\[CapitalDelta]", " ", 
         RowBox[{"Cosh", "[", 
          RowBox[{"t", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["\[CapitalOmega]", "2"]}]}]], " ", 
         RowBox[{"Sinh", "[", 
          RowBox[{"t", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}]}], 
       ")"}]}], 
     RowBox[{
      SuperscriptBox["\[CapitalDelta]", "2"], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "1"}]], "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{"\[CapitalOmega]", " ", 
      RowBox[{"(", 
       RowBox[{"\[CapitalDelta]", "-", 
        RowBox[{"\[CapitalDelta]", " ", 
         RowBox[{"Cosh", "[", 
          RowBox[{"t", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["\[CapitalOmega]", "2"]}]}]], " ", 
         RowBox[{"Sinh", "[", 
          RowBox[{"t", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}]}], 
       ")"}]}], 
     RowBox[{
      SuperscriptBox["\[CapitalDelta]", "2"], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "2"}]], "[", "t", "]"}], "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["\[CapitalOmega]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"Cosh", "[", 
          RowBox[{"t", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[CapitalDelta]", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}], "]"}]}], ")"}]}],
       
      RowBox[{
       SuperscriptBox["\[CapitalDelta]", "2"], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["\[CapitalOmega]", "2"]}]}]]}]}]}], "}"}]], "Output",
 ImageSize->{485, 199},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->51837265]
}, Open  ]],

Cell["\<\
The diagonal density-matrix elements are the probabilities of finding each \
state.\
\>", "MathCaption",
 CellID->94345139],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"1", ",", "1"}]], "[", "t", "]"}], ",", 
        RowBox[{
         SubscriptBox["\[Rho]", 
          RowBox[{"2", ",", "2"}]], "[", "t", "]"}]}], "}"}], "/.", "sol"}], "/.",
      
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[CapitalOmega]", "\[Rule]", "1"}], ",", 
       RowBox[{"\[CapitalDelta]", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<Probability\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->33775256],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->140242666]
}, Open  ]],

Cell[TextData[{
 "If instead of a single atom, we are interested in averages over an ensemble \
of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]], "InlineMath"],
 " atoms, each with state vector ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Psi]", "i"]}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula"],
 ", we simply work with the averaged density matrix: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]", "=", 
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"i", "=", "1"}], "n"], 
       RowBox[{"|", 
        SubscriptBox["\[Psi]", "i"]}]}]}], "\[RightAngleBracket]"}], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SubscriptBox["\[Psi]", "i"], "|"}]}]}], TraditionalForm]], 
  "InlineMath"],
 "."
}], "Text",
 CellID->148218043],

Cell[TextData[{
 "Everything then follows identically as above. Note that averaging the state \
vectors, rather than the density matrices, would not produce satisfactory \
results. Also, the averaged density matrix can represent states of the \
ensemble that can not correspond to a single atomic state vector. For \
example, the density matrix ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Rho]", "=", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"1", "0"},
        {"0", "1"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}]}], 
   TraditionalForm]], "InlineMath"],
 " represents atoms that are equally likely to be in state 1 or 2, but have \
no well-defined phase between the amplitudes to be in these states, whereas a \
state vector always has a particular phase between its components."
}], "Text",
 CellID->316066021],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"The Density Matrix and the Liouville Equation - Wolfram \
Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 43, 25.0567759}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The density matrix is a generalization of the state vector that allows \
graceful handling of ensemble averages and relaxation effects. For a single \
atom with state vector |\\[Psi]>, we define the density operator by \\[Rho]=|\
\\[Psi]><\\[Psi]|. Load the package. Define an atomic system and form its ket \
vector.", "synonyms" -> {}, "title" -> 
    "The Density Matrix and the Liouville Equation", "type" -> "Tutorial", 
    "uri" -> "AtomicDensityMatrix/tutorial/\
TheDensityMatrixAndTheLiouvilleEquation"}, "SearchTextTranslated" -> "", 
  "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 8057, 166, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[8954, 201, 82, 1, 70, "Title",
 CellID->509267359],
Cell[9039, 204, 686, 23, 70, "Text",
 CellID->60640988],
Cell[9728, 229, 60, 1, 70, "MathCaption",
 CellID->106720500],
Cell[9791, 232, 106, 3, 70, "Input",
 CellID->27959808],
Cell[9900, 237, 91, 1, 70, "MathCaption",
 CellID->200065976],
Cell[CellGroupData[{
Cell[10016, 242, 370, 12, 70, "Input",
 CellID->484360868],
Cell[10389, 256, 423, 14, 70, "Output",
 CellID->556262954]
}, Open  ]],
Cell[CellGroupData[{
Cell[10849, 275, 191, 6, 70, "Input",
 CellID->67883978],
Cell[11043, 283, 835, 26, 70, "Output",
 CellID->210018019]
}, Open  ]],
Cell[11893, 312, 123, 3, 70, "MathCaption",
 CellID->339934743],
Cell[CellGroupData[{
Cell[12041, 319, 172, 5, 70, "Input",
 CellID->62312969],
Cell[12216, 326, 1496, 46, 70, "Output",
 CellID->110884756]
}, Open  ]],
Cell[13727, 375, 297, 8, 70, "Text",
 CellID->210105707],
Cell[14027, 385, 799, 23, 70, "Text",
 CellID->25365813],
Cell[14829, 410, 274, 9, 70, "MathCaption",
 CellID->60827562],
Cell[CellGroupData[{
Cell[15128, 423, 150, 5, 70, "Input",
 CellID->203218259],
Cell[15281, 430, 1099, 34, 70, "Output",
 CellID->21091601]
}, Open  ]],
Cell[16395, 467, 245, 5, 70, "MathCaption",
 CellID->265025652],
Cell[CellGroupData[{
Cell[16665, 476, 511, 15, 70, "Input",
 CellID->90461799],
Cell[17179, 493, 811, 24, 70, "Output",
 CellID->2859802]
}, Open  ]],
Cell[18005, 520, 66, 1, 70, "MathCaption",
 CellID->886331892],
Cell[CellGroupData[{
Cell[18096, 525, 229, 8, 70, "Input",
 CellID->484620359],
Cell[18328, 535, 2480, 45, 70, "Output",
 Evaluatable->False,
 CellID->269271340]
}, Open  ]],
Cell[20823, 583, 62, 1, 70, "MathCaption",
 CellID->639160661],
Cell[CellGroupData[{
Cell[20910, 588, 704, 20, 70, "Input",
 CellID->236712826],
Cell[21617, 610, 699, 24, 70, "Output",
 CellID->836022128]
}, Open  ]],
Cell[22331, 637, 79, 1, 70, "MathCaption",
 CellID->19810966],
Cell[CellGroupData[{
Cell[22435, 642, 138, 4, 70, "Input",
 CellID->276951613],
Cell[22576, 648, 560, 19, 70, "Output",
 CellID->636756750]
}, Open  ]],
Cell[23151, 670, 71, 1, 70, "MathCaption",
 CellID->33833520],
Cell[CellGroupData[{
Cell[23247, 675, 340, 11, 70, "Input",
 CellID->924046702],
Cell[23590, 688, 4311, 128, 70, "Output",
 CellID->51837265]
}, Open  ]],
Cell[27916, 819, 133, 4, 70, "MathCaption",
 CellID->94345139],
Cell[CellGroupData[{
Cell[28074, 827, 810, 26, 70, "Input",
 CellID->33775256],
Cell[28887, 855, 7619, 129, 70, "Output",
 Evaluatable->False,
 CellID->140242666]
}, Open  ]],
Cell[36521, 987, 846, 29, 70, "Text",
 CellID->148218043],
Cell[37370, 1018, 1286, 30, 70, "Text",
 CellID->316066021],
Cell[CellGroupData[{
Cell[38681, 1052, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[39791, 1084, 804, 18, 70, "SectionHeaderSpacer"],
Cell[40598, 1104, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[40793, 1111, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[41624, 1133, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

