(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     81803,       2454]
NotebookOptionsPosition[     73212,       2180]
NotebookOutlinePosition[     75527,       2235]
CellTagsIndexPosition[     75484,       2232]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Constructing the Hamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Constructing the Hamiltonian\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "DropFastTerms", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/DropFastTerms", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "EffectiveHamiltonian", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "RotatingWaveApproximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "RotatingWaveTransform", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveTransform", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "RotatingWaveTransformMatrix", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"DropFastTerms\"\>", 
       2->"\<\"EffectiveHamiltonian\"\>", 
       3->"\<\"RotatingWaveApproximation\"\>", 
       4->"\<\"RotatingWaveTransform\"\>", 
       5->"\<\"RotatingWaveTransformMatrix\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation",
                    "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation\"\>",
        2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["The Rotating-Wave Approximation", "Title",
 CellID->509267359],

Cell[TextData[{
 "The Hamiltonian for a light field interacting with an atomic transition has \
matrix elements that oscillate at the optical frequency. However, by a \
suitable change of basis and neglecting terms corresponding to very \
far-off-resonant  optical coupling, the time dependence can often be \
eliminated from the Hamiltonian, greatly simplifying calculations. In this \
tutorial, we discuss this approximation, known as the ",
 StyleBox["rotating-wave approximation",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellID->1534169418],

Cell["This loads the package.", "MathCaption",
 CellID->339534619],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->87034352],

Cell["\<\
As a simple example, we consider two atomic states coupled by a near-resonant \
monochromatic light field.\
\>", "Text",
 CellID->209068752],

Cell["A two-level atomic system.", "MathCaption",
 CellID->70779043],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"Energy", "\[Rule]", "0"}], ",", 
      RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"2", ",", 
      RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
      RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "}"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->29838874],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Energy", "\[Rule]", "\[Omega]0"}], ",", 
     RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{572, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->49432954]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for this system interacting with a monochromatic optical \
field with frequency ",
 Cell[BoxData[
  StyleBox["\[Omega]", "InlineMath"]]],
 " and induced Rabi frequency ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["\[CapitalOmega]", "R"], "InlineMath"]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->457381827],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"sys", ",", 
      RowBox[{"ElectricField", "\[Rule]", 
       RowBox[{"OpticalField", "[", 
        RowBox[{"\[Omega]", ",", 
         RowBox[{"\[CapitalOmega]R", "/", " ", 
          RowBox[{"ReducedME", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", 
             RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], 
        "]"}]}]}], "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->692860306],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]R"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{186, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->335988776]
}, Open  ]],

Cell["\<\
If we write the matrix elements of the light-atom interaction Hamiltonian in \
terms of exponentials, rather than trigonometric functions, each off-diagonal \
matrix element is composed of two terms.\
\>", "Text",
 CellID->395087951],

Cell["The Hamiltonian expressed in terms of exponential functions.", \
"MathCaption",
 CellID->114000830],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "//", "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->9490531],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]R"}]}], "\[Omega]0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{310, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->92095166]
}, Open  ]],

Cell["\<\
We can show that, for each of these matrix elements, one of the terms induces \
a near-resonant coupling, while the other induces a far-off-resonant \
coupling.\
\>", "Text",
 CellID->87359988],

Cell[TextData[{
 "Consider one of the matrix elements written above: ",
 "\n\t",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    StyleBox["\[LeftAngleBracket]", "InlineMath"], 
    RowBox[{
     StyleBox["0", "InlineMath"], 
     StyleBox["|", "InlineMath"], 
     StyleBox["H", "InlineMath"], 
     StyleBox["|", "InlineMath"], 
     SubscriptBox[
      StyleBox["\[Omega]", "InlineMath"], "0"]}], 
    StyleBox["\[RightAngleBracket]", "InlineMath"]}], 
   StyleBox["=", "InlineMath"], 
   StyleBox[
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], 
     SubscriptBox["\[CapitalOmega]", "R"], 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"0", "|", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "|", 
       SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}]}], 
    "InlineMath"]}]], "InlineFormula"],
 ","
}], "Text",
 CellID->383056238],

Cell[TextData[{
 "where ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", "0"}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath"],
 " is the lower state with energy zero, and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath"],
 " is the upper state with energy ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Omega]", "0"], TraditionalForm]], "InlineMath"],
 ". For a near-resonant transition, the energy of the state ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"H", "\[VerticalSeparator]", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath"],
 " should be close to that of ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[VerticalSeparator]", "0"}], "\[RightAngleBracket]"}], 
   TraditionalForm]], "InlineMath"],
 ", i.e., zero. "
}], "Text",
 CellID->74222856],

Cell[TextData[{
 "First we consider the term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 ". Applying the energy operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"E", "=", 
    RowBox[{"\[ImaginaryI]", " ", 
     FractionBox["d", 
      RowBox[{"d", " ", "t"}]]}]}], TraditionalForm]], "InlineMath"],
 " (with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[HBar]", "=", "0"}], TraditionalForm]], "InlineMath"],
 "), we have\n\t",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[ImaginaryI]", 
      FractionBox["d", 
       RowBox[{"d", "\[VeryThinSpace]", "t"}]]}], ")"}], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], 
   "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", "="}], "InlineMath"]], "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{"(", 
    RowBox[{"\[ImaginaryI]", 
     FractionBox["d", 
      RowBox[{"d", "\[VeryThinSpace]", "t"}]]}], ")"}], "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 "\n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"E", "|", 
       SubscriptBox["\[Omega]", "0"]}]}], "\[RightAngleBracket]"}], ")"}], 
   "InlineMath"]], "InlineFormula"],
 "\n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"-", "\[Omega]"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}]}], 
   "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"+", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]]}], "InlineMath"]], 
  "InlineFormula"],
 Cell[BoxData[
  StyleBox[
   SubscriptBox["\[Omega]", "0"], "InlineMath"]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " \n\t\t\t",
 Cell[BoxData[
  StyleBox["=", "InlineMath"]], "InlineFormula"],
 Cell[BoxData[
  RowBox[{
   StyleBox[" ", "InlineMath"], 
   RowBox[{
    RowBox[{
     StyleBox["(", "InlineMath"], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Omega]", "InlineMath"], "0"], 
      StyleBox["-", "InlineMath"], 
      StyleBox["\[Omega]", "InlineMath"]}], 
     StyleBox[")", "InlineMath"]}], 
    StyleBox[" ", "InlineMath"], 
    StyleBox[
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], 
     "InlineMath"]}]}]]],
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"]
}], "Text",
 CellID->408772018],

Cell[TextData[{
 "In other words, the energy of ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " is ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["\[Omega]", "InlineMath"], "0"], 
   StyleBox["-", "InlineMath"], 
   StyleBox["\[Omega]", "InlineMath"]}]], "InlineFormula"],
 ", which, if ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "\[TildeTilde]", "\[Omega]"}], 
   "InlineMath"]], "InlineFormula"],
 ", is near zero, the energy of the state ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{"|", "0"}], "\[RightAngleBracket]"}], "InlineMath"]], 
  "InlineFormula"],
 ". Thus, if ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "InlineMath"], "0"], 
    StyleBox["-", "InlineMath"], 
    StyleBox["\[Omega]", "InlineMath"]}], 
   StyleBox["\[LessTilde]", "InlineMath"], 
   StyleBox["\[CapitalGamma]", "InlineMath"]}]], "InlineFormula"],
 ", where \[CapitalGamma] is the line width of the upper state, the term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", "|", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " represents a resonant transition, for which energy is conserved. On the \
other hand, performing a calculation similar to the above, we find that the \
energy of ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " is ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["\[Omega]", "InlineMath"], "0"], "+", 
   StyleBox["\[Omega]", "InlineMath"]}]], "InlineFormula"],
 ". If ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "\[TildeTilde]", "\[Omega]"}], 
   "InlineMath"]], "InlineFormula"],
 ", then this energy is much greater than the energy of the lower state (",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[Omega]", "InlineMath"], "0"], "+", 
    StyleBox["\[Omega]", "InlineMath"]}], 
   StyleBox[">>", "InlineMath"], 
   StyleBox["\[CapitalGamma]", "InlineMath"]}]], "InlineFormula"],
 " for optical frequencies). The term ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", "|", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "t"}]], "|", 
     SubscriptBox["\[Omega]", "0"]}], "\[RightAngleBracket]"}], 
   "InlineMath"]], "InlineFormula"],
 " represents a far-off-resonant transition. This sort of transition is \
highly suppressed, and can be neglected."
}], "Text",
 CellID->131956570],

Cell["\<\
We can visualize the situation by drawing a level diagram, and indicating the \
resonant and off-resonant couplings.\
\>", "Text",
 CellID->119515781],

Cell["\<\
Level diagram for the system, showing both resonant and off-resonant \
couplings.\
\>", "MathCaption",
 CellID->295356471],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{"h", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "1"}], ",", 
      RowBox[{"\[Omega]", "\[Rule]", "0.9"}]}], "}"}]}], ",", 
   RowBox[{"SuppressOffResonantCouplings", "\[Rule]", "False"}]}], 
  "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->738472575],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{-0.9, 0}, {-0.09999999999999998, 0}}]}, {{}, 
     LineBox[{{0.09999999999999998, 1}, {0.9, 1}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{-0.45999999999999996`, 0}, {0.45999999999999996`, -0.9}}], 
    ArrowBox[{{-0.45999999999999996`, 0}, {0.45999999999999996`, 0.9}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 99},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->45982557]
}, Open  ]],

Cell[TextData[{
 "One arrow, pointing up from the lower level, nearly matches the separation \
between the lower and upper states, and represents an optical field detuned \
by ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "-", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath"],
 " from resonance. The other arrow points down from the lower level, and \
couples the lower level to a point far below resonance (by an amount ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "+", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath"],
 ") with the excited state."
}], "Text",
 CellID->67742302],

Cell["\<\
In order to see how we might remove the optical frequencies from the \
Hamiltonian, we first consider a physically analogous situation \[LongDash] \
that of a spin 1/2 atomic system subject to an oscillating magnetic field.\
\>", "Text",
 CellID->5846930],

Cell["\<\
Define a second system consisting of the Zeeman sublevels of a spin-1/2 \
state.\
\>", "MathCaption",
 CellID->240378968],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys2", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->76640165],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      FractionBox["1", "2"]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", 
      FractionBox["1", "2"]}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{567, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->223453178]
}, Open  ]],

Cell[TextData[{
 "The Hamiltonian for this system subject to an oscillating magnetic field \
directed along ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and a static magnetic field directed along ",
 StyleBox["z",
  FontSlant->"Italic"],
 " is formally identical to the optically coupled two-level system above \
(allowing for an arbitrary shift in the zero reference energy by adding a \
constant term to the diagonal)."
}], "Text",
 CellID->207411124],

Cell[TextData[{
 "Find the Hamiltonian for this system interacting with a magnetic field \
directed along ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and oscillating with frequency \[Omega]."
}], "MathCaption",
 CellID->311487406],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h2", "=", 
    RowBox[{
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"sys2", ",", 
       RowBox[{"MagneticField", "\[Rule]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], "\[CapitalOmega]L", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"\[Omega]", " ", "t"}], "]"}]}], ",", "0", ",", 
           RowBox[{"-", "\[Omega]0"}]}], "}"}], "/", 
         RowBox[{"(", 
          RowBox[{"BohrMagneton", "  ", 
           RowBox[{"GFactor", "[", "1", "]"}]}], ")"}]}]}]}], "]"}], "//", 
     "TrigToExp"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->253774865],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ", 
        "\[CapitalOmega]L"}]}], 
      FractionBox["\[Omega]0", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{310, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->3971715]
}, Open  ]],

Cell[TextData[{
 "The x-directed oscillating magnetic field can be thought of as the sum of \
two counter-rotating magnetic fields, one rotating clockwise around the ",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis and the other rotating counterclockwise. Each term in the \
off-diagonal elements of the Hamiltonian corresponds to one or the other of \
the rotating fields. "
}], "Text",
 CellID->52559842],

Cell[TextData[{
 "Physically, we expect that if we transform into a frame rotating about the \
",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis at frequency \[Omega], the component of the magnetic field that the \
frame is co-rotating with will appear static, while the counter-rotating \
field will appear to rotate at twice the frequency it has in the non-rotating \
frame. The unitary transformation required to perform this task is given by \
the matrix for rotations about the z axis:"
}], "Text",
 CellID->244684399],

Cell[TextData[{
 "Matrix for rotation by an angle ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Omega]"}], " ", "t"}], TraditionalForm]], "InlineMath"],
 " about the ",
 StyleBox["z",
  FontSlant->"Italic"],
 "-axis."
}], "MathCaption",
 CellID->23996460],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u2", "=", 
    RowBox[{"WignerD", "[", 
     RowBox[{"sys2", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[Omega]"}], " ", "t"}], ",", "0", ",", "0"}], "}"}]}],
      "]"}]}], ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->191574436],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}], "2"]], "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", "\[ImaginaryI]", " ", "t", " ", 
        "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{104, 49},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->946485]
}, Open  ]],

Cell[TextData[{
 "There is a slight complication in applying the transform to the \
Hamiltonian, however, due to the time dependence of the unitary \
transformation. We would like the transformed Hamiltonian to have the \
properties of a Hamiltonian, i.e., to satisfy the Schr\[ODoubleDot]dinger \
equation ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"H", "|", "\[Psi]"}], "\[RightAngleBracket]"}], "=", 
    RowBox[{"\[ImaginaryI]", " ", 
     FractionBox["d", 
      RowBox[{"d", " ", "t"}]]}]}], TraditionalForm]], "InlineMath"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"|", "\[Psi]"}], "\[RightAngleBracket]"}], TraditionalForm]], 
  "InlineMath"],
 " in the rotating frame. The fact that the rotating frame is non-intertial, \
however, means that the Schr\[ODoubleDot]dinger equation must be modified by \
a correction term, analogous to the fictitious force used in classical \
mechanics to account for the modifications that Newton's laws undergo in an \
accelerating frame. Alternatively, it is more convenient to define a modified \
effective Hamiltonian in the rotating frame, so that the \
Schr\[ODoubleDot]dinger equation is the same in all frames. If we define a \
modified effective Hamiltonian in the rotating frame by ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["H", "eff"], "=", 
    RowBox[{
     RowBox[{
      SuperscriptBox["U", "\[Dagger]"], " ", "H", " ", "U"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["U", "\[Dagger]"], " ", 
      FractionBox["dU", "dt"]}]}]}], TraditionalForm]], "InlineMath"],
 ", it can be easily shown, starting from the Schr\[ODoubleDot]dinger \
equation in the stationary frame, that this results in the same form for the \
Schr\[ODoubleDot]dinger equation in both the stationary and rotating frames."
}], "Text",
 CellID->305054736],

Cell["Find the effective Hamiltonian in the rotating frame.", "MathCaption",
 CellID->216972968],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["u2", "\[Dagger]"], ".", "h2", ".", "u2"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{
       SuperscriptBox["u2", "\[Dagger]"], ".", 
       RowBox[{"D", "[", 
        RowBox[{"u2", ",", "t"}], "]"}]}]}]}], "//", "ComplexExpand"}], "//", 
   "TrigToExp"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->331600442],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Omega]", "2"], "-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]L"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[Omega]", "2"]}], "+", 
       FractionBox["\[Omega]0", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{235, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->34982414]
}, Open  ]],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  ButtonBox["EffectiveHamiltonian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"]], 
  "InlineFormula"],
 " can be used to give the same result."
}], "MathCaption",
 CellID->270489364],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EffectiveHamiltonian", "[", 
    RowBox[{"h2", ",", "u2", ",", "t"}], "]"}], "//", "Expand"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->391661896],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Omega]", "2"], "-", 
       FractionBox["\[Omega]0", "2"]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]L"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]L", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]L"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[Omega]", "2"]}], "+", 
       FractionBox["\[Omega]0", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{235, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]//MatrixForm=",
 CellID->535263236]
}, Open  ]],

Cell["\<\
We see that transforming the Hamiltonian to the effective rotating-frame \
Hamiltonian has two effects: the oscillation frequencies in the off-diagonal \
elements are shifted by \[Omega], and the energy splitting between the \
diagonal terms is shifted by the same amount. This second effect is a result \
of the correction term in the formula for the effective Hamiltonian.\
\>", "Text",
 CellID->319046361],

Cell["\<\
In the optical case that we considered initially, the analogous unitary \
transformation does not have the same physical interpretation as taking the \
stationary frame to a rotating frame. Nonetheless, on the strength of the \
analogy, we continue to refer to the transformed frame as a rotating frame.\
\>", "Text",
 CellID->119866632],

Cell[TextData[{
 "In constructing the unitary transformation matrix for the optical case, we \
can think of shifting the upper state down by a frequency \[Omega] in order \
to simultaneously shift the optical frequency in the resonant coupling term \
to zero. The unitary transformation is then written as ",
 Cell[BoxData[
  FormBox[
   RowBox[{"U", "=", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", "D"}]]}], TraditionalForm]], 
  "InlineMath"],
 ", where ",
 Cell[BoxData[
  FormBox["D", TraditionalForm]], "InlineMath"],
 " is a diagonal matrix with the desired energy shift for each atomic state \
on the diagonal:"
}], "Text",
 CellID->12796374],

Cell["\<\
The unitary matrix for transformation to the interaction frame in the optical \
case.\
\>", "MathCaption",
 CellID->568113300],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "t", " ", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "\[Omega]"}]}], "}"}], "]"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->186586323],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{71, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]//MatrixForm=",
 CellID->137196017]
}, Open  ]],

Cell["\<\
The unitary matrix that we find by this method is equivalent to the one used \
in the spin-1/2 case, up to an overall phase factor. We then find the \
effective Hamiltonian in the rotating frame:\
\>", "Text",
 CellID->5994744],

Cell[TextData[{
 "Apply ",
 Cell[BoxData[
  ButtonBox["EffectiveHamiltonian",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"]], 
  "InlineFormula"],
 " to the stationary frame and chosen unitary matrix."
}], "MathCaption",
 CellID->398631076],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hEff", "=", 
    RowBox[{
     RowBox[{"EffectiveHamiltonian", "[", 
      RowBox[{"h", ",", "u", ",", "t"}], "]"}], "//", "TrigToExp"}]}], ")"}], 
  "//", "MatrixForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->222156589],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "t", " ", 
          "\[Omega]"}]], " ", "\[CapitalOmega]R"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[CapitalOmega]R", "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]], " ",
         "\[CapitalOmega]R"}]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{235, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]//MatrixForm=",
 CellID->468013568]
}, Open  ]],

Cell[TextData[{
 "The level diagram helps us visualize what we have accomplished. The upper \
state has been shifted down by the optical frequency \[Omega], so that it now \
is only ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "-", "\[Omega]"}], TraditionalForm]], 
  "InlineMath"],
 " above the lower state. The frequencies of the two optical fields have been \
shifted by the same amount, so that the frequency of one of them is zero (the \
two ends of the arrow are at the same energy) and the frequency of the other \
is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"2", " ", "\[Omega]"}], TraditionalForm]], "InlineMath"],
 ". Note, however, that each field has the same detuning from resonance as it \
did in the stationary frame: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Omega]", "0"], "-", "\[Omega]"}], TraditionalForm]], 
  "InlineMath"],
 " below resonance for the near-resonant field, and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Omega]", "+", 
    SubscriptBox["\[Omega]", "0"]}], TraditionalForm]], "InlineMath"],
 " below resonance for the off-resonant field."
}], "Text",
 CellID->1668820],

Cell["\<\
Level diagram for the system in the rotating frame, showing both resonant and \
off-resonant couplings. (Here, for the purposes of the plot, we have \
transformed to a frame that is almost, but not exactly, the correct rotating \
frame, so that both coupling fields are still plotted.)\
\>", "MathCaption",
 CellID->77373423],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"sys", ",", 
   RowBox[{
    RowBox[{"EffectiveHamiltonian", "[", 
     RowBox[{"h", ",", 
      RowBox[{"MatrixExp", "[", 
       RowBox[{"\[ImaginaryI]", " ", "t", " ", 
        RowBox[{"DiagonalMatrix", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "\[Omega]1"}]}], "}"}], "]"}]}], "]"}], ",", "t"}], 
     "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Omega]0", "\[Rule]", "1"}], ",", 
      RowBox[{"\[Omega]", "\[Rule]", "0.9"}], ",", 
      RowBox[{"\[Omega]1", "\[Rule]", "0.900001"}]}], "}"}]}], ",", 
   RowBox[{"SuppressOffResonantCouplings", "\[Rule]", "False"}]}], 
  "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->230965145],

Cell[GraphicsData["CompressedBitmap", "\<\
eJx9lk1IG0EYhjeu0ZQKWqQaqzGr8Sf+Jv7HGGv67yVQ8NKTRKQQD6XBeujN
3jx69OjRS0HoxaPFUnpMbx4tvdhDwUIPXgpp3plvzb7lo4Hdzc6zzzffzM7M
TmFjp/Ty1cbO1uaG92x7o1za2nzjPX29XStyQ47jrNeOTc/B/2rtr5zWnWq1
Chi8PDEXN3p5eWn+4eiw6LFFL46OjkoHBwfmrtOiRxatnpycXEcikXSlUnGi
Fj20CEVXbW1twE6XRQ/MpdG7uLgAQlan+XxeaN5cwpHr6+vDYrH4u6WlBU/s
l8vlfwLgkQvP846f137Hx8dMy/u1X03CU21XV1cU3vVd0+BuQr5o7gStKFYP
ob23td/e3p65E3S/3qmwYDsxQqgH9Zk7QcuK1UuILEE5xYoTIkvQkmJ5hMgS
lFWsPkJkCVqsj4hKOp02d/2E/BcZRBnFShAiS9CCYg0QIkvQvGINEiJL0Jxi
DREiS9CsRZkvtV8mY5syTAjBzIwKoBmLEAxBzV2SEFmCphVrhBBZgqYUa5QQ
WYLSijVGiCxBKcUat2iyPvVgJs/Pz50JQjRhBU0oE3aSEFmCxhUrRYgsQWOK
lSZElqBRxZoiRJagEcWaJkQLkaCkMmFnCNGEFTSsWLOEyBI0pFhzhMgSNKhY
84TIEjSgWAuEyBKUUCZshhBNWEH9irVIiCxBfYqVJUSWIE+xlgiRJSiuWDlC
ZAnqVRaiW+bcjH7Ft/3d7u4uDuj4Up+srq46DSix3358yYPrTa8y0ZvMOYxq
8E7wui6j0SjC+aGQWf709BQhpSyMqvxnsR0A95fQmLJoNNrKMBKKh4eH58lk
Eq3CEECWty1Gw4BRO6IDQ0lQYMrfteGxA4KBXLAU3bHNQmy/WX4w/7vXo6TZ
YKOhN1DLQalUQk53bTH+IhqyN/1rA92z7wZ1oXOC6aE+THy01ZTZ3Y7ZY6EL
kS42Qb3BSM3Y0mFv9TWVSn1cWVlZPjs7Q1SzfNhOCKObUIZUUW6idwfDNCHV
qmwv/7iu+zmbzaJv4vUcPuVyuZ/t7e3Ij2WU+DKOX62trcjLymE0/0dnZ6eP
zVy2qrTRvGtsL/2dIt4BsrbdH8aIwXsGwmNmsHYFIzSiTd9jsdi3eDwOU1Yc
1I2mmzEqhltff9EbZpC22+H7fm1t7UOhUDB3rbYMfW4MHB31gXAzrGQjbYet
i8r9yeYkbIib1SvwFVC38DP11PyJ6gziHEIWIdCQfVI2GHhH6B0zpxLm7N4k
hiP0n9qc0F+Dtfuh\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{94, 99},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->442136929]
}, Open  ]],

Cell["\<\
Finally, we note that, in a typical atomic system, the far-off-resonant terms \
(those that oscillate at twice the optical frequency in the effective \
Hamiltonian) lead to excitations that are so weak that the terms can be \
neglected to an excellent approximation. This is the rotating-wave \
approximation.\
\>", "Text",
 CellID->8916765],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  ButtonBox["DropFastTerms",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DropFastTerms"]], 
  "InlineFormula"],
 " sets terms that oscillate at twice the optical frequency to zero."
}], "MathCaption",
 CellID->131611831],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"hRWA", "=", 
    RowBox[{"DropFastTerms", "[", 
     RowBox[{"hEff", ",", "\[Omega]", ",", "t"}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->612776079],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{96, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]//MatrixForm=",
 CellID->64654372]
}, Open  ]],

Cell[TextData[{
 "In the case considered here, we have eliminated all time dependence from \
the Hamiltonian. Furthermore, when written in terms of the optical detuning \
",
 Cell[BoxData[
  StyleBox["\[CapitalDelta]", "InlineMath"]]],
 ", there is no longer any explicit dependence on either the optical or \
transition frequency."
}], "Text",
 CellID->618247489],

Cell["\<\
Write the optical frequency in terms of detuning \[CapitalDelta] from \
resonance.\
\>", "MathCaption",
 CellID->494812334],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"hRWA", "/.", 
   RowBox[{"\[Omega]", "\[Rule]", 
    RowBox[{"\[Omega]0", "+", "\[CapitalDelta]"}]}]}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->190456385],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{"-", "\[CapitalDelta]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{76, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[15]//MatrixForm=",
 CellID->902369107]
}, Open  ]],

Cell["\<\
All succeeding calculations can be performed using this approximate effective \
Hamiltonian, and the results can be transformed back into the stationary \
frame, if necessary.\
\>", "Text",
 CellID->713011104],

Cell[TextData[{
 "A number of functions are available that perform various steps of the \
rotating-wave approximation, or all of the steps together. ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransformMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"]],
   "InlineFormula"],
 " can be used to automatically create an appropriate transformation matrix \
for going to the rotating frame. ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransform",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransform"]], 
  "InlineFormula"],
 "  can create the transform matrix and apply it to the Hamiltonian, and ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " can perform the transformation and drop the fast oscillating terms, thus \
implementing the RWA in one step."
}], "Text",
 CellID->33346025],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["EffectiveHamiltonian",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/EffectiveHamiltonian"], "[",
      
     RowBox[{
      StyleBox["h", "TI"], ",", 
      StyleBox["u", "TI"], ",", 
      StyleBox["t", "TI"]}], "]"}], Cell[TextData[{
     "apply the unitary transformation matrix ",
     Cell[BoxData[
      StyleBox["u", "TI"]], "InlineFormula"],
     " to the Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula"],
     ", assuming time variable ",
     Cell[BoxData[
      StyleBox["t", "TI"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["DropFastTerms",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/DropFastTerms"], "[", 
     RowBox[{
      StyleBox["h", "TI"], ",", 
      StyleBox["\[Omega]", "TR"], ",", 
      StyleBox["t", "TI"]}], "]"}], Cell[TextData[{
     "drop terms from ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula"],
     " that oscillate at twice the frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["RotatingWaveTransformMatrix",
      BaseStyle->"Link",
      ButtonData->
       "paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"], "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", 
      StyleBox["\[Omega]", "TR"]}], "]"}], Cell[TextData[{
     "automatically (for simple systems) create a unitary matrix appropriate \
for performing the RWA for a atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula"],
     " subject to an optical field of frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["RotatingWaveTransform",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransform"], 
     "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", 
      StyleBox["h", "TI"], ",", 
      StyleBox["\[Omega]", "TR"]}], "]"}], Cell[TextData[{
     "automatically create a unitary transformation to the rotating frame and \
apply it to a Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["RotatingWaveApproximation",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"],
      "[", 
     RowBox[{
      StyleBox["sys", "TI"], 
      StyleBox[",", "TI"], 
      StyleBox["h", "TI"], ",", 
      StyleBox["\[Omega]", "TR"]}], "]"}], Cell[TextData[{
     "automatically transform the Hamiltonian ",
     Cell[BoxData[
      StyleBox["h", "TI"]], "InlineFormula"],
     " to the rotating frame and drop fast-oscillating terms"
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->1334],

Cell["Making the rotating-wave approximation.", "Caption",
 CellID->164610213],

Cell[TextData[{
 "For a simple system, ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " generates a unitary transformation matrix by assuming that states with ",
 Cell[BoxData[
  RowBox[{"Energy", "\[Rule]", "0"}]], "InlineFormula"],
 " are lower states that should remain unshifted, while states with energies \
that are not explicitly zero are upper states that should be shifted down by \
the optical frequency \[Omega]. The RWA is then applied using this \
transformation. ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransformMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransformMatrix"]],
   "InlineFormula"],
 " can be used to return the transform matrix itself, while ",
 Cell[BoxData[
  ButtonBox["RotatingWaveTransform",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveTransform"]], 
  "InlineFormula"],
 " applies the transform matrix to the Hamiltonian, without dropping \
fast-oscillating terms."
}], "Text",
 CellID->555006801],

Cell["\<\
Automatically apply the RWA to a Hamiltonian, assuming an optical field of \
frequency \[Omega].\
\>", "MathCaption",
 CellID->91728896],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveApproximation", "[", 
   RowBox[{"sys", ",", "h", ",", "\[Omega]"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->42004999],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]R", "2"]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{96, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[16]//MatrixForm=",
 CellID->180663118]
}, Open  ]],

Cell["Return the automatically generated transform matrix.", "MathCaption",
 CellID->251677183],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransformMatrix", "[", 
   RowBox[{"sys", ",", "\[Omega]"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->390115046],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{71, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]//MatrixForm=",
 CellID->169415782]
}, Open  ]],

Cell["\<\
Automatically generate and apply the transform to the Hamiltonian, without \
dropping fast-oscillating terms.\
\>", "MathCaption",
 CellID->16178055],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransform", "[", 
   RowBox[{"sys", ",", "h", ",", "\[Omega]"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[18]:=",
 CellID->280989001],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]]}], " ",
        "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"\[ImaginaryI]", " ", "t", " ", "\[Omega]"}]]}], " ", 
       "\[CapitalOmega]R", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
      RowBox[{
       RowBox[{"-", "\[Omega]"}], "+", "\[Omega]0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{251, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[18]//MatrixForm=",
 CellID->411726623]
}, Open  ]],

Cell[TextData[{
 "For more complicated systems, possibly including multiple optical fields, \
this simple method of generating the transformation to the rotating frame \
does not work. In this case, more information can be supplied to ",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 ", allowing an appropriate transform matrix to be generated, or the \
transform matrix itself can be supplied directly. See the documentation for \
",
 Cell[BoxData[
  ButtonBox["RotatingWaveApproximation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"]], 
  "InlineFormula"],
 " for more information."
}], "Text",
 CellID->6388417],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Constructing the Hamiltonian",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/ConstructingTheHamiltonian"]], \
"RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"The Rotating-Wave Approximation - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 43, 26.7998756}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The Hamiltonian for a light field interacting with an atomic transition \
has matrix elements that oscillate at the optical frequency. However, by a \
suitable change of basis and neglecting terms corresponding to very \
far-off-resonant optical coupling, the time dependence can often be \
eliminated from the Hamiltonian, greatly simplifying calculations. In this \
tutorial, we discuss this approximation, known as the rotating-wave \
approximation. This loads the package. As a simple example, we consider two \
atomic states coupled by a near-resonant monochromatic light field.", 
    "synonyms" -> {}, "title" -> "The Rotating-Wave Approximation", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/TheRotatingWaveApproximation"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 12074, 249, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[12971, 284, 68, 1, 70, "Title",
 CellID->509267359],
Cell[13042, 287, 546, 11, 70, "Text",
 CellID->1534169418],
Cell[13591, 300, 66, 1, 70, "MathCaption",
 CellID->339534619],
Cell[13660, 303, 106, 3, 70, "Input",
 CellID->87034352],
Cell[13769, 308, 150, 4, 70, "Text",
 CellID->209068752],
Cell[13922, 314, 68, 1, 70, "MathCaption",
 CellID->70779043],
Cell[CellGroupData[{
Cell[14015, 319, 457, 13, 70, "Input",
 CellID->29838874],
Cell[14475, 334, 512, 15, 70, "Output",
 CellID->49432954]
}, Open  ]],
Cell[15002, 352, 350, 11, 70, "MathCaption",
 CellID->457381827],
Cell[CellGroupData[{
Cell[15377, 367, 559, 16, 70, "Input",
 CellID->692860306],
Cell[15939, 385, 1008, 30, 70, "Output",
 CellID->335988776]
}, Open  ]],
Cell[16962, 418, 243, 5, 70, "Text",
 CellID->395087951],
Cell[17208, 425, 105, 2, 70, "MathCaption",
 CellID->114000830],
Cell[CellGroupData[{
Cell[17338, 431, 132, 4, 70, "Input",
 CellID->9490531],
Cell[17473, 437, 1659, 48, 70, "Output",
 CellID->92095166]
}, Open  ]],
Cell[19147, 488, 203, 5, 70, "Text",
 CellID->87359988],
Cell[19353, 495, 1080, 33, 70, "Text",
 CellID->383056238],
Cell[20436, 530, 998, 33, 70, "Text",
 CellID->74222856],
Cell[21437, 565, 4596, 166, 70, "Text",
 CellID->408772018],
Cell[26036, 733, 3116, 94, 70, "Text",
 CellID->131956570],
Cell[29155, 829, 160, 4, 70, "Text",
 CellID->119515781],
Cell[29318, 835, 132, 4, 70, "MathCaption",
 CellID->295356471],
Cell[CellGroupData[{
Cell[29475, 843, 366, 11, 70, "Input",
 CellID->738472575],
Cell[29844, 856, 588, 13, 70, "Output",
 CellID->45982557]
}, Open  ]],
Cell[30447, 872, 637, 16, 70, "Text",
 CellID->67742302],
Cell[31087, 890, 265, 5, 70, "Text",
 CellID->5846930],
Cell[31355, 897, 131, 4, 70, "MathCaption",
 CellID->240378968],
Cell[CellGroupData[{
Cell[31511, 905, 329, 10, 70, "Input",
 CellID->76640165],
Cell[31843, 917, 697, 22, 70, "Output",
 CellID->223453178]
}, Open  ]],
Cell[32555, 942, 453, 12, 70, "Text",
 CellID->207411124],
Cell[33011, 956, 231, 7, 70, "MathCaption",
 CellID->311487406],
Cell[CellGroupData[{
Cell[33267, 967, 719, 21, 70, "Input",
 CellID->253774865],
Cell[33989, 990, 1739, 51, 70, "Output",
 CellID->3971715]
}, Open  ]],
Cell[35743, 1044, 407, 9, 70, "Text",
 CellID->52559842],
Cell[36153, 1055, 523, 11, 70, "Text",
 CellID->244684399],
Cell[36679, 1068, 270, 11, 70, "MathCaption",
 CellID->23996460],
Cell[CellGroupData[{
Cell[36974, 1083, 347, 12, 70, "Input",
 CellID->191574436],
Cell[37324, 1097, 1021, 30, 70, "Output",
 CellID->946485]
}, Open  ]],
Cell[38360, 1130, 1852, 41, 70, "Text",
 CellID->305054736],
Cell[40215, 1173, 96, 1, 70, "MathCaption",
 CellID->216972968],
Cell[CellGroupData[{
Cell[40336, 1178, 441, 14, 70, "Input",
 CellID->331600442],
Cell[40780, 1194, 1555, 46, 70, "Output",
 CellID->34982414]
}, Open  ]],
Cell[42350, 1243, 279, 9, 70, "MathCaption",
 CellID->270489364],
Cell[CellGroupData[{
Cell[42654, 1256, 220, 7, 70, "Input",
 CellID->391661896],
Cell[42877, 1265, 1557, 46, 70, "Output",
 CellID->535263236]
}, Open  ]],
Cell[44449, 1314, 418, 7, 70, "Text",
 CellID->319046361],
Cell[44870, 1323, 347, 6, 70, "Text",
 CellID->119866632],
Cell[45220, 1331, 691, 17, 70, "Text",
 CellID->12796374],
Cell[45914, 1350, 136, 4, 70, "MathCaption",
 CellID->568113300],
Cell[CellGroupData[{
Cell[46075, 1358, 373, 12, 70, "Input",
 CellID->186586323],
Cell[46451, 1372, 851, 25, 70, "Output",
 CellID->137196017]
}, Open  ]],
Cell[47317, 1400, 237, 5, 70, "Text",
 CellID->5994744],
Cell[47557, 1407, 286, 9, 70, "MathCaption",
 CellID->398631076],
Cell[CellGroupData[{
Cell[47868, 1420, 277, 9, 70, "Input",
 CellID->222156589],
Cell[48148, 1431, 1410, 41, 70, "Output",
 CellID->468013568]
}, Open  ]],
Cell[49573, 1475, 1153, 30, 70, "Text",
 CellID->1668820],
Cell[50729, 1507, 335, 6, 70, "MathCaption",
 CellID->77373423],
Cell[CellGroupData[{
Cell[51089, 1517, 749, 21, 70, "Input",
 CellID->230965145],
Cell[51841, 1540, 1509, 29, 70, "Output",
 Evaluatable->False,
 CellID->442136929]
}, Open  ]],
Cell[53365, 1572, 351, 7, 70, "Text",
 CellID->8916765],
Cell[53719, 1581, 294, 9, 70, "MathCaption",
 CellID->131611831],
Cell[CellGroupData[{
Cell[54038, 1594, 244, 8, 70, "Input",
 CellID->612776079],
Cell[54285, 1604, 918, 28, 70, "Output",
 CellID->64654372]
}, Open  ]],
Cell[55218, 1635, 364, 9, 70, "Text",
 CellID->618247489],
Cell[55585, 1646, 133, 4, 70, "MathCaption",
 CellID->494812334],
Cell[CellGroupData[{
Cell[55743, 1654, 217, 7, 70, "Input",
 CellID->190456385],
Cell[55963, 1663, 890, 27, 70, "Output",
 CellID->902369107]
}, Open  ]],
Cell[56868, 1693, 219, 5, 70, "Text",
 CellID->713011104],
Cell[57090, 1700, 1009, 24, 70, "Text",
 CellID->33346025],
Cell[58102, 1726, 2885, 86, 70, "DefinitionBox",
 CellID->1334],
Cell[60990, 1814, 78, 1, 70, "Caption",
 CellID->164610213],
Cell[61071, 1817, 1151, 28, 70, "Text",
 CellID->555006801],
Cell[62225, 1847, 146, 4, 70, "MathCaption",
 CellID->91728896],
Cell[CellGroupData[{
Cell[62396, 1855, 200, 6, 70, "Input",
 CellID->42004999],
Cell[62599, 1863, 919, 28, 70, "Output",
 CellID->180663118]
}, Open  ]],
Cell[63533, 1894, 95, 1, 70, "MathCaption",
 CellID->251677183],
Cell[CellGroupData[{
Cell[63653, 1899, 190, 5, 70, "Input",
 CellID->390115046],
Cell[63846, 1906, 851, 25, 70, "Output",
 CellID->169415782]
}, Open  ]],
Cell[64712, 1934, 159, 4, 70, "MathCaption",
 CellID->16178055],
Cell[CellGroupData[{
Cell[64896, 1942, 197, 6, 70, "Input",
 CellID->280989001],
Cell[65096, 1950, 1334, 39, 70, "Output",
 CellID->411726623]
}, Open  ]],
Cell[66445, 1992, 797, 19, 70, "Text",
 CellID->6388417],
Cell[CellGroupData[{
Cell[67267, 2015, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[68377, 2047, 804, 18, 70, "SectionHeaderSpacer"],
Cell[69184, 2067, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[69379, 2074, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70220, 2097, 1120, 30, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[71343, 2129, 804, 18, 70, "SectionHeaderSpacer"],
Cell[72150, 2149, 201, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[72354, 2156, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[73185, 2178, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

