(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     38756,       1143]
NotebookOptionsPosition[     34032,       1003]
NotebookOutlinePosition[     36220,       1056]
CellTagsIndexPosition[     36177,       1053]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "ReducedME", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ReducedME", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "WignerEckart", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/WignerEckart", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"ReducedME\"\>", 2->"\<\"WignerEckart\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/TheWignerEckartTheorem", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/TheWignerEckartTheorem", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/TheWignerEckartTheorem.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/TheWignerEckartTheorem", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/TheWignerEckartTheorem\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["The Wigner-Eckart Theorem", "Title",
 CellID->471728094],

Cell["\<\
The Wigner-Eckart theorem gives the matrix elements of irreducible tensor \
operators in terms of their reduced matrix elements:\
\>", "Text",
 CellID->97203088],

Cell[TextData[{
 "\t ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       RowBox[{"\[Gamma]", " ", "F", " ", "M"}], "|", 
       SubsuperscriptBox["T", "q", "\[Kappa]"], "|", 
       RowBox[{
        RowBox[{"\[Gamma]", "'"}], " ", 
        RowBox[{"F", "'"}], " ", 
        RowBox[{"M", "'"}]}]}], "\[RightAngleBracket]"}], "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"F", "-", "M"}]], 
      RowBox[{"(", GridBox[{
         {"F", "\[Kappa]", 
          RowBox[{"F", "'"}]},
         {
          RowBox[{"-", "M"}], "q", 
          RowBox[{"M", "'"}]}
        }], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Gamma]", " ", "F"}], "||", 
        SuperscriptBox["T", "\[Kappa]"], "||", 
        RowBox[{
         RowBox[{"\[Gamma]", "'"}], " ", 
         RowBox[{"F", "'"}]}]}], ")"}]}]}], "InlineMath"], TraditionalForm]]]
}], "Text",
 CellID->421393016],

Cell[TextData[{
 "Here ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"(", GridBox[{
       {"\[SmallCircle]", "\[SmallCircle]", "\[SmallCircle]"},
       {"\[SmallCircle]", "\[SmallCircle]", "\[SmallCircle]"}
      }], ")"}], "InlineMath"], TraditionalForm]]],
 " is the ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ThreeJSymbol",
    BaseStyle->"Link",
    ButtonData->"paclet:ref/ThreeJSymbol"], "InlineFormula"]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"(", 
     RowBox[{"\[SmallCircle]", 
      RowBox[{"||", 
       RowBox[{"\[SmallCircle]", 
        RowBox[{"||", "\[SmallCircle]"}]}]}]}], ")"}], "InlineMath"], 
   TraditionalForm]]],
 " is the reduced matrix element, which is independent of spatial indices (",
 Cell[BoxData[
  StyleBox["M", "InlineMath"]]],
 " and ",
 Cell[BoxData[
  StyleBox["q", "InlineMath"]]],
 ")."
}], "Text",
 CellID->27191548],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["WignerEckart",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/WignerEckart"], "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["op", "TI"], ",", 
        StyleBox["k", "TI"], ",", 
        StyleBox["q", "TI"]}], "}"}]}], "]"}], Cell[TextData[{
     "the matrix representation of the operator ",
     StyleBox["op", "TI"],
     " with rank ",
     StyleBox["k", "TI"],
     " and index ",
     StyleBox["q", "TI"],
     " for atomic system sys"
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["WignerEckart",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/WignerEckart"], "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["op", "TI"], ",", 
        StyleBox["k", "TI"]}], "}"}]}], "]"}], Cell[TextData[{
     "the ",
     Cell[BoxData[
      FormBox[
       RowBox[{
        RowBox[{"2", " ", "k"}], "+", "1"}], TraditionalForm]], "InlineMath"],
     
     " matrix components of the operator ",
     StyleBox["op", "TI"],
     " with rank ",
     StyleBox["k", "TI"],
     " for atomic system ",
     StyleBox["sys", "TI"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["WignerEckart",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/WignerEckart"], "[", 
     RowBox[{
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["1", "TR"]], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["op", "TI"], ",", 
        StyleBox["k", "TI"], ",", 
        StyleBox["q", "TI"]}], "}"}], ",", 
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]}], "]"}], Cell[TextData[{
     "the matrix element of the operator ",
     StyleBox["op", "TI"],
     " between atomic states ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["1", "TR"]]]],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]]]
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->395344621],

Cell["Matrix representation of operators.", "Caption",
 CellID->394485849],

Cell["This loads the package.", "MathCaption",
 CellID->491530967],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1016875],

Cell[TextData[{
 "If the reduced matrix element for an operator is predefined, as for example \
for the ",
 Cell[BoxData[
  StyleBox["J", "InlineMath"]]],
 " electronic angular momentum operator, this definition is used by ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["WignerEckart", "InlineFormula"],
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/WignerEckart"]]],
 " to produce explicit matrix elements for the operator."
}], "Text",
 CellID->121057749],

Cell[TextData[{
 "An atomic system consisting of a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " state."
}], "MathCaption",
 CellID->211439404],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{"AtomicState", "[", 
     RowBox[{"1", ",", 
      RowBox[{"J", "\[Rule]", "1"}]}], "]"}], "}"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->239200921],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{590, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->7763087]
}, Open  ]],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  ButtonBox["J",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/J"]]],
 " operator is a rank 1 (",
 Cell[BoxData[
  StyleBox[
   RowBox[{"\[Kappa]", "=", "1"}], "InlineMath"]]],
 ") spherical tensor operator. Thus it has ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"2", "\[Kappa]"}], "+", "1"}], "=", "3"}], "InlineMath"]]],
 " components. This gives the matrices for the ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", "1"], "InlineMath"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", "0"], "InlineMath"]], "InlineFormula"],
 ", and ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["J", 
    RowBox[{"-", "1"}]], "InlineMath"]], "InlineFormula"],
 " operators."
}], "MathCaption",
 CellID->457381827],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WignerEckart", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"{", 
     RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->692860306],

Cell[GraphicsData["CompressedBitmap", "\<\
eJztWj1MGzEUNrlcfi6EQGgpY9QuVStVVYeqylB1artU6tixEWoEQ1VEO2Sj
W0ayMTIysoWRkZGRIQNjRkbG6/nO8dnJ8/M9JwGpukiEnJ993+f33T372f7S
+bP742fnz95Op/XpoLO/u7fzu/Xx10FU5K0wxsbR38sW47/D6Kf4GrMwDLlR
/efH/7zvJycn8S/+V07Kdo+Pj2VZOymr3N3dybobQL03Geu9AOpVkrK/h4eH
sp6X0CwmF8+vr68/n5+fqzT59fZ4PFaqR50aDSLKk0+bDUYhW0NsTcQWpLQk
ToOIHVixS2yQGsSny4Zh6C8M3ghRRZqWAPhy+tC8vrq6AoTStBbV94+OjqZ0
9dlo0I1h4vIIvjsYSaEgWxOxCaFaNzc3Er9BxA4Q2yPRetCOvSZ8Oj/mKnBf
jAeEWU7fp36v11Ml8VLTdHWu3oeLi4v4qiggVRphOGTd9kBKAtmaiK0GuKJO
xA4QW1V2dCQf7kL87U0ebsUVuouhx5LKDZMOqg9hirJev9/nGsVXBUW6wrvL
y8tK2lBWKsq3WgUKJ9d13LyBmwOzdygkqrh5k6YLBblmlMbYpGRWh4daPvrM
qJPEuunQyMWUt7gPnb6dnp5KEnU6CXed5kV210lDFmy0GYKukzavMOu0lADI
gwl/jS1OogdAaEwqLwDTMbBpmMqYJOd4dkm0sgnFEQ/u3WFSPuyytjZNmLU1
EVssSYEzXSMiBlbEIktM8lGtzAk2c8Ma0qQswappaJJgKzTX+wI/urc6V2zA
xZtwMe5rA0QNLm5Kl0WPXFqMe9gAEcD3WoVrz/hVgyD69T3K9y1qfZUTyYnk
RB6SyCRkU1cYtmKbMQUvoT3AQLGlBYxQlmHQacUAI7TQSJqOnrQ1hO3kXrNz
pgzjNG3FAGOB+78EcMSQMNtSnE6dJIsJKHPO1K3iUKfOGFt3cagsliCOa6b5
xNH1rkmlhU7gqIErnTQE50r8d0rQQ4D7KJEHIue8fUu0XnAWTSeSZXZEys0x
Igt1PS1v35L9mT+pNuTtBuRsHs6WoBuQ87w9J5ITmZuIth/ykES0Uwo6Eb7S
uX57e6sSARe7HXbg60hTsb7/9ezsjO/Hxlf4Jgg5n7Ym8Znh6fm6NZefwhZl
/JqXx1f6kj/fnJGHBqCtPizXhnY7rDn21DJ4HcCkZtuLwHRdU7Bm+vDpC/4a
GTYw+Xsj1UrGTL6H4wugRe+7W6e7kPNiRmVEJqeJtREJ6/tcE2zz0ZjpvX/k
JI0WBz0ZWTLv3K7hTYS4fGtVPrENANk3yuGaaGZFtvTZkl5azD5AAjqapupU
4CGtkjKVYi5NHU5t+jyYhrw0dazI96GORiKJWTyEJS/NpO/auyNiPGfJDw4o
TLPvrGMBpZreXw696wCmWRd6EMuKifXTNZz5AHYF8LunSSI1U8KZVlYQkIQ9
9gbSRPGQnB5uGGFJGT22fECDpa8YYDYfwK4A2EKYx6Ln2Xbb1+HaT+HahnTd
sCLwDC42JPeG4mRBY3K8ma38A4sXgx8=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{231, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->128562285]
}, Open  ]],

Cell[BoxData[GridBox[{
   {Cell["operator", "TableHeader"], Cell["rank", "TableHeader"], ""},
   {
    ButtonBox["Zero",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Zero"], Cell[
    "0", "TableText"], Cell["the zero operator", "TableText"]},
   {
    ButtonBox["Identity",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Identity"], Cell[
    "0", "TableText"], Cell["the identity operator", "TableText"]},
   {
    ButtonBox["Energy",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], Cell[
    "0", "TableText"], Cell[
    "the internal (unperturbed) energy operator", "TableText"]},
   {
    ButtonBox["Dipole",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Dipole"], Cell[
    "1", "TableText"], Cell["the E1 electric dipole operator", "TableText"]},
   {
    ButtonBox["J",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/J"], Cell["1", "TableText"], 
    Cell["the angular momentum operator", "TableText"]},
   {
    ButtonBox["MagneticMoment",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/MagneticMoment"], Cell[
    "1", "TableText"], Cell["the magnetic moment operator ", "TableText"]},
   {
    ButtonBox["Polarizability",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"], Cell[
    "0", "TableText"], Cell[
    "the effective Hamiltonian for scalar polarizability", "TableText"]},
   {
    ButtonBox["Polarizability",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"], Cell[
    "1", "TableText"], Cell[
    "the effective Hamiltonian for vector polarizability", "TableText"]},
   {
    ButtonBox["Polarizability",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Polarizability"], Cell[
    "2", "TableText"], Cell[
    "the effective Hamiltonian for tensor polarizability", "TableText"]},
   {
    ButtonBox["Polarization",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Polarization"], Cell[
    TextData[Cell[BoxData[
     StyleBox["\[Kappa]", "InlineMath"]]]], "TableText"], Cell[TextData[{
     "the polarization operator of rank ",
     Cell[BoxData[
      StyleBox["\[Kappa]", "InlineMath"]]]
    }], "TableText"]}
  }]], "DefinitionBox3Col",
 GridBoxOptions->{
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {
    False, True, False, False, False, False, False, False, {False}, False}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{
  "Columns" -> {0.28, {0.56}, 0.28}, "ColumnsIndexed" -> {}, 
   "Rows" -> {0.2, {0.16}, 0.2}, "RowsIndexed" -> {}}},
 CellID->21974],

Cell["Some predefined operators.", "Caption",
 CellID->29990986],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox[
   StyleBox["WignerEckart", "InlineFormula"],
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/WignerEckart"]]],
 " can be used with an undefined operator: the reduced matrix elements are \
then given symbolically as ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ReducedME",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/ReducedME"], 
   "InlineFormula"]]],
 " objects."
}], "Text",
 CellID->755714195],

Cell[TextData[{
 "Even though the ",
 Cell[BoxData[
  StyleBox[
   SubsuperscriptBox["A", "1", "1"], "InlineMath"]], "InlineFormula"],
 " operator is undefined, its tensor rank and index determine its matrix \
elements up to a reduced matrix element."
}], "MathCaption",
 CellID->219581442],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WignerEckart", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"{", 
     RowBox[{"A", ",", "1", ",", "1"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->172703519],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"ReducedME", "[", 
         RowBox[{
          RowBox[{"AtomicState", "[", 
           RowBox[{"1", ",", 
            RowBox[{"J", "\[Rule]", "1"}], ",", 
            RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "1"}], "}"}], ",", 
          RowBox[{"AtomicState", "[", 
           RowBox[{"1", ",", 
            RowBox[{"J", "\[Rule]", "1"}], ",", 
            RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
          RowBox[{"AtomicSystemType", "\[Rule]", "Zeeman"}]}], "]"}], 
        SqrtBox["6"]]}], "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"ReducedME", "[", 
         RowBox[{
          RowBox[{"AtomicState", "[", 
           RowBox[{"1", ",", 
            RowBox[{"J", "\[Rule]", "1"}], ",", 
            RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "1"}], "}"}], ",", 
          RowBox[{"AtomicState", "[", 
           RowBox[{"1", ",", 
            RowBox[{"J", "\[Rule]", "1"}], ",", 
            RowBox[{"M", "\[Rule]", 
             RowBox[{"-", "1"}]}]}], "]"}], ",", 
          RowBox[{"AtomicSystemType", "\[Rule]", "Zeeman"}]}], "]"}], 
        SqrtBox["6"]]}]},
     {"0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{946, 77},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->951967584]
}, Open  ]],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["ReducedME",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ReducedME"], "[", 
     RowBox[{
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["1", "TR"]], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["op", "TI"], ",", 
        StyleBox["k", "TI"]}], "}"}], ",", 
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]}], "]"}], Cell[TextData[{
     "a symbolic reduced matrix element of the rank-",
     StyleBox["k", "TI"],
     " operator ",
     StyleBox["op", "TI"],
     " between atomic states ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["s", "TI"], 
        StyleBox["1", "TR"]], " "}]]],
     "and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["s", "TI"], 
       StyleBox["2", "TR"]]]]
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->326007787],

Cell["Symbolic reduced matrix element.", "Caption",
 CellID->298626249],

Cell["\<\
We can complete the definition of a tensor operator by giving a definition \
for its reduced matrix element. For example, consider a scalar, parity \
non-conserving interaction mixing two opposite parity states. \
\>", "Text",
 CellID->278825201],

Cell[TextData[{
 "Define the ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ReducedME",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/ReducedME"], 
   "InlineFormula"]]],
 " for a scalar ",
 Cell[BoxData[
  StyleBox["PNC", "InlineFormula"]]],
 " operator. The parity-violating matrix elements are imaginary. WignerEckart \
assumes that symbolic parameters are real, so a factor of \[ImaginaryI] must \
be included explicitly. The parameter ",
 Cell[BoxData["\[Delta]"]],
 " is a real, parity-violating mixing parameter."
}], "MathCaption",
 CellID->406279997],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReducedME", "[", 
   RowBox[{"s1_AtomicState", ",", 
    RowBox[{"{", 
     RowBox[{"PNC", ",", "0"}], "}"}], ",", "s2_AtomicState", ",", 
    "opts___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Order", "[", 
    RowBox[{
     RowBox[{"StateLabel", "[", "s1", "]"}], ",", 
     RowBox[{"StateLabel", "[", "s2", "]"}]}], "]"}], 
   SqrtBox[
    RowBox[{
     RowBox[{"2", 
      RowBox[{"J", "[", "s1", "]"}]}], "+", "1"}]], "\[ImaginaryI]", " ", 
   "\[Delta]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->290689302],

Cell[TextData[{
 "An atomic system consisting of two ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"J", "=", "1"}], "InlineMath"]]],
 " states."
}], "MathCaption",
 CellID->120727952],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"Sublevels", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}], ",", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "1"}]}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[6]:=",
 CellID->27859779],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{590, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->424535483]
}, Open  ]],

Cell[TextData[{
 "The matrix for the ",
 Cell[BoxData[
  StyleBox["PNC", "InlineFormula"]]],
 " operator for this system."
}], "MathCaption",
 CellID->95915604],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WignerEckart", "[", 
   RowBox[{"sys", ",", 
    RowBox[{"{", 
     RowBox[{"PNC", ",", "0", ",", "0"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->543089629],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{"\[ImaginaryI]", " ", "\[Delta]"}], "0", "0"},
     {"0", "0", "0", "0", 
      RowBox[{"\[ImaginaryI]", " ", "\[Delta]"}], "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"\[ImaginaryI]", " ", "\[Delta]"}]},
     {
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Delta]"}], "0", "0", "0", "0", 
      "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Delta]"}], "0", "0", "0", 
      "0"},
     {"0", "0", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Delta]"}], "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{190, 87},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->371391]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"The Wigner-Eckart Theorem - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 43, 30.1790688}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The Wigner-Eckart theorem gives the matrix elements of irreducible \
tensor operators in terms of their reduced matrix elements: <\\[Gamma] F \
M|T_q^\\[Kappa]|\\[Gamma]' F' M'>=(-1)^F-M(GridBox[{{F, \\[Kappa], RowBox[{F, \
'}]}, {RowBox[{-, M}], q, RowBox[{M, '}]}}])(\\[Gamma] \
F||T^\\[Kappa]||\\[Gamma]' F') Here (GridBox[{{(), (), ()}, {(), (), ()}}]) \
is the ThreeJSymbol and (()||()||()) is the reduced matrix element, which is \
independent of spatial indices (M and q).", "synonyms" -> {}, "title" -> 
    "The Wigner-Eckart Theorem", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/TheWignerEckartTheorem"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9442, 194, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10339, 229, 62, 1, 70, "Title",
 CellID->471728094],
Cell[10404, 232, 171, 4, 70, "Text",
 CellID->97203088],
Cell[10578, 238, 1003, 34, 70, "Text",
 CellID->421393016],
Cell[11584, 274, 893, 33, 70, "Text",
 CellID->27191548],
Cell[12480, 309, 2161, 76, 70, "DefinitionBox",
 CellID->395344621],
Cell[14644, 387, 74, 1, 70, "Caption",
 CellID->394485849],
Cell[14721, 390, 66, 1, 70, "MathCaption",
 CellID->491530967],
Cell[14790, 393, 105, 3, 70, "Input",
 CellID->1016875],
Cell[14898, 398, 476, 13, 70, "Text",
 CellID->121057749],
Cell[15377, 413, 175, 7, 70, "MathCaption",
 CellID->211439404],
Cell[CellGroupData[{
Cell[15577, 424, 248, 8, 70, "Input",
 CellID->239200921],
Cell[15828, 434, 648, 20, 70, "Output",
 CellID->7763087]
}, Open  ]],
Cell[16491, 457, 816, 31, 70, "MathCaption",
 CellID->457381827],
Cell[CellGroupData[{
Cell[17332, 492, 218, 7, 70, "Input",
 CellID->692860306],
Cell[17553, 501, 1781, 33, 70, "Output",
 Evaluatable->False,
 CellID->128562285]
}, Open  ]],
Cell[19349, 537, 2721, 71, 70, "DefinitionBox3Col",
 CellID->21974],
Cell[22073, 610, 64, 1, 70, "Caption",
 CellID->29990986],
Cell[22140, 613, 489, 16, 70, "Text",
 CellID->755714195],
Cell[22632, 631, 290, 8, 70, "MathCaption",
 CellID->219581442],
Cell[CellGroupData[{
Cell[22947, 643, 231, 8, 70, "Input",
 CellID->172703519],
Cell[23181, 653, 2009, 56, 70, "Output",
 CellID->951967584]
}, Open  ]],
Cell[25205, 712, 939, 34, 70, "DefinitionBox",
 CellID->326007787],
Cell[26147, 748, 71, 1, 70, "Caption",
 CellID->298626249],
Cell[26221, 751, 256, 5, 70, "Text",
 CellID->278825201],
Cell[26480, 758, 581, 17, 70, "MathCaption",
 CellID->406279997],
Cell[27064, 777, 551, 18, 70, "Input",
 CellID->290689302],
Cell[27618, 797, 178, 7, 70, "MathCaption",
 CellID->120727952],
Cell[CellGroupData[{
Cell[27821, 808, 377, 12, 70, "Input",
 CellID->27859779],
Cell[28201, 822, 1116, 33, 70, "Output",
 CellID->424535483]
}, Open  ]],
Cell[29332, 858, 160, 6, 70, "MathCaption",
 CellID->95915604],
Cell[CellGroupData[{
Cell[29517, 868, 233, 8, 70, "Input",
 CellID->543089629],
Cell[29753, 878, 1272, 37, 70, "Output",
 CellID->371391]
}, Open  ]],
Cell[CellGroupData[{
Cell[31062, 920, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[32172, 952, 804, 18, 70, "SectionHeaderSpacer"],
Cell[32979, 972, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[33174, 979, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[34005, 1001, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

